{-# OPTIONS_GHC -w #-}
{-# OPTIONS -fglasgow-exts -cpp #-}
module Language.Fortran.Parser.Fortran77 ( expressionParser
                               , statementParser
                               , fortran77Parser
                               , extended77Parser
                               ) where

import Prelude hiding (EQ,LT,GT) -- Same constructors exist in the AST

import Data.Maybe (isNothing, fromJust)
import qualified Data.ByteString.Char8 as B
import Language.Fortran.Util.Position
import Language.Fortran.ParserMonad
import Language.Fortran.Lexer.FixedForm
import Language.Fortran.Transformer (transform, Transformation(..))
import Language.Fortran.AST

import Debug.Trace
import qualified Data.Array as Happy_Data_Array
import qualified GHC.Exts as Happy_GHC_Exts
import Control.Applicative(Applicative(..))
import Control.Monad (ap)

-- parser produced by Happy Version 1.19.5

newtype HappyAbsSyn  = HappyAbsSyn HappyAny
#if __GLASGOW_HASKELL__ >= 607
type HappyAny = Happy_GHC_Exts.Any
#else
type HappyAny = forall a . a
#endif
happyIn6 :: (ProgramFile A0) -> (HappyAbsSyn )
happyIn6 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn6 #-}
happyOut6 :: (HappyAbsSyn ) -> (ProgramFile A0)
happyOut6 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut6 #-}
happyIn7 :: (ProgramFile A0) -> (HappyAbsSyn )
happyIn7 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn7 #-}
happyOut7 :: (HappyAbsSyn ) -> (ProgramFile A0)
happyOut7 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut7 #-}
happyIn8 :: ([ ([ Block A0 ], ProgramUnit A0) ]) -> (HappyAbsSyn )
happyIn8 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn8 #-}
happyOut8 :: (HappyAbsSyn ) -> ([ ([ Block A0 ], ProgramUnit A0) ])
happyOut8 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut8 #-}
happyIn9 :: (ProgramUnit A0) -> (HappyAbsSyn )
happyIn9 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn9 #-}
happyOut9 :: (HappyAbsSyn ) -> (ProgramUnit A0)
happyOut9 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut9 #-}
happyIn10 :: (Maybe (AList Expression A0)) -> (HappyAbsSyn )
happyIn10 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn10 #-}
happyOut10 :: (HappyAbsSyn ) -> (Maybe (AList Expression A0))
happyOut10 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut10 #-}
happyIn11 :: (Name) -> (HappyAbsSyn )
happyIn11 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn11 #-}
happyOut11 :: (HappyAbsSyn ) -> (Name)
happyOut11 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut11 #-}
happyIn12 :: ([ Block A0 ]) -> (HappyAbsSyn )
happyIn12 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn12 #-}
happyOut12 :: (HappyAbsSyn ) -> ([ Block A0 ])
happyOut12 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut12 #-}
happyIn13 :: (Block A0) -> (HappyAbsSyn )
happyIn13 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn13 #-}
happyOut13 :: (HappyAbsSyn ) -> (Block A0)
happyOut13 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut13 #-}
happyIn14 :: ([ Block A0 ]) -> (HappyAbsSyn )
happyIn14 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn14 #-}
happyOut14 :: (HappyAbsSyn ) -> ([ Block A0 ])
happyOut14 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut14 #-}
happyIn15 :: (Block A0) -> (HappyAbsSyn )
happyIn15 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn15 #-}
happyOut15 :: (HappyAbsSyn ) -> (Block A0)
happyOut15 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut15 #-}
happyIn16 :: (Maybe Token) -> (HappyAbsSyn )
happyIn16 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn16 #-}
happyOut16 :: (HappyAbsSyn ) -> (Maybe Token)
happyOut16 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut16 #-}
happyIn17 :: (Token) -> (HappyAbsSyn )
happyIn17 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn17 #-}
happyOut17 :: (HappyAbsSyn ) -> (Token)
happyOut17 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut17 #-}
happyIn18 :: (Statement A0) -> (HappyAbsSyn )
happyIn18 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn18 #-}
happyOut18 :: (HappyAbsSyn ) -> (Statement A0)
happyOut18 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut18 #-}
happyIn19 :: (Statement A0) -> (HappyAbsSyn )
happyIn19 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn19 #-}
happyOut19 :: (HappyAbsSyn ) -> (Statement A0)
happyOut19 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut19 #-}
happyIn20 :: (Statement A0) -> (HappyAbsSyn )
happyIn20 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn20 #-}
happyOut20 :: (HappyAbsSyn ) -> (Statement A0)
happyOut20 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut20 #-}
happyIn21 :: (DoSpecification A0) -> (HappyAbsSyn )
happyIn21 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn21 #-}
happyOut21 :: (HappyAbsSyn ) -> (DoSpecification A0)
happyOut21 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut21 #-}
happyIn22 :: (Statement A0) -> (HappyAbsSyn )
happyIn22 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn22 #-}
happyOut22 :: (HappyAbsSyn ) -> (Statement A0)
happyOut22 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut22 #-}
happyIn23 :: (Expression A0) -> (HappyAbsSyn )
happyIn23 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn23 #-}
happyOut23 :: (HappyAbsSyn ) -> (Expression A0)
happyOut23 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut23 #-}
happyIn24 :: (Expression A0) -> (HappyAbsSyn )
happyIn24 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn24 #-}
happyOut24 :: (HappyAbsSyn ) -> (Expression A0)
happyOut24 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut24 #-}
happyIn25 :: (AList ControlPair A0) -> (HappyAbsSyn )
happyIn25 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn25 #-}
happyOut25 :: (HappyAbsSyn ) -> (AList ControlPair A0)
happyOut25 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut25 #-}
happyIn26 :: (AList ControlPair A0) -> (HappyAbsSyn )
happyIn26 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn26 #-}
happyOut26 :: (HappyAbsSyn ) -> (AList ControlPair A0)
happyOut26 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut26 #-}
happyIn27 :: (ControlPair A0) -> (HappyAbsSyn )
happyIn27 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn27 #-}
happyOut27 :: (HappyAbsSyn ) -> (ControlPair A0)
happyOut27 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut27 #-}
happyIn28 :: (Expression A0) -> (HappyAbsSyn )
happyIn28 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn28 #-}
happyOut28 :: (HappyAbsSyn ) -> (Expression A0)
happyOut28 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut28 #-}
happyIn29 :: (Expression A0) -> (HappyAbsSyn )
happyIn29 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn29 #-}
happyOut29 :: (HappyAbsSyn ) -> (Expression A0)
happyOut29 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut29 #-}
happyIn30 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn30 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn30 #-}
happyOut30 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut30 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut30 #-}
happyIn31 :: (Expression A0) -> (HappyAbsSyn )
happyIn31 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn31 #-}
happyOut31 :: (HappyAbsSyn ) -> (Expression A0)
happyOut31 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut31 #-}
happyIn32 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn32 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn32 #-}
happyOut32 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut32 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut32 #-}
happyIn33 :: (Maybe (AList Expression A0)) -> (HappyAbsSyn )
happyIn33 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn33 #-}
happyOut33 :: (HappyAbsSyn ) -> (Maybe (AList Expression A0))
happyOut33 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut33 #-}
happyIn34 :: ([ Expression A0 ]) -> (HappyAbsSyn )
happyIn34 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn34 #-}
happyOut34 :: (HappyAbsSyn ) -> ([ Expression A0 ])
happyOut34 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut34 #-}
happyIn35 :: (Expression A0) -> (HappyAbsSyn )
happyIn35 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn35 #-}
happyOut35 :: (HappyAbsSyn ) -> (Expression A0)
happyOut35 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut35 #-}
happyIn36 :: (Expression A0) -> (HappyAbsSyn )
happyIn36 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn36 #-}
happyOut36 :: (HappyAbsSyn ) -> (Expression A0)
happyOut36 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut36 #-}
happyIn37 :: (Statement A0) -> (HappyAbsSyn )
happyIn37 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn37 #-}
happyOut37 :: (HappyAbsSyn ) -> (Statement A0)
happyOut37 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut37 #-}
happyIn38 :: (Statement A0) -> (HappyAbsSyn )
happyIn38 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn38 #-}
happyOut38 :: (HappyAbsSyn ) -> (Statement A0)
happyOut38 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut38 #-}
happyIn39 :: (Statement A0) -> (HappyAbsSyn )
happyIn39 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn39 #-}
happyOut39 :: (HappyAbsSyn ) -> (Statement A0)
happyOut39 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut39 #-}
happyIn40 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn40 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn40 #-}
happyOut40 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut40 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut40 #-}
happyIn41 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn41 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn41 #-}
happyOut41 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut41 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut41 #-}
happyIn42 :: (Expression A0) -> (HappyAbsSyn )
happyIn42 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn42 #-}
happyOut42 :: (HappyAbsSyn ) -> (Expression A0)
happyOut42 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut42 #-}
happyIn43 :: ([ Declarator A0 ]) -> (HappyAbsSyn )
happyIn43 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn43 #-}
happyOut43 :: (HappyAbsSyn ) -> ([ Declarator A0 ])
happyOut43 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut43 #-}
happyIn44 :: (Declarator A0) -> (HappyAbsSyn )
happyIn44 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn44 #-}
happyOut44 :: (HappyAbsSyn ) -> (Declarator A0)
happyOut44 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut44 #-}
happyIn45 :: (Statement A0) -> (HappyAbsSyn )
happyIn45 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn45 #-}
happyOut45 :: (HappyAbsSyn ) -> (Statement A0)
happyOut45 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut45 #-}
happyIn46 :: (AList ImpList A0) -> (HappyAbsSyn )
happyIn46 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn46 #-}
happyOut46 :: (HappyAbsSyn ) -> (AList ImpList A0)
happyOut46 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut46 #-}
happyIn47 :: (ImpList A0) -> (HappyAbsSyn )
happyIn47 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn47 #-}
happyOut47 :: (HappyAbsSyn ) -> (ImpList A0)
happyOut47 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut47 #-}
happyIn48 :: (AList ImpElement A0) -> (HappyAbsSyn )
happyIn48 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn48 #-}
happyOut48 :: (HappyAbsSyn ) -> (AList ImpElement A0)
happyOut48 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut48 #-}
happyIn49 :: (ImpElement A0) -> (HappyAbsSyn )
happyIn49 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn49 #-}
happyOut49 :: (HappyAbsSyn ) -> (ImpElement A0)
happyOut49 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut49 #-}
happyIn50 :: (Expression A0) -> (HappyAbsSyn )
happyIn50 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn50 #-}
happyOut50 :: (HappyAbsSyn ) -> (Expression A0)
happyOut50 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut50 #-}
happyIn51 :: (AList FormatItem A0) -> (HappyAbsSyn )
happyIn51 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn51 #-}
happyOut51 :: (HappyAbsSyn ) -> (AList FormatItem A0)
happyOut51 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut51 #-}
happyIn52 :: (FormatItem A0) -> (HappyAbsSyn )
happyIn52 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn52 #-}
happyOut52 :: (HappyAbsSyn ) -> (FormatItem A0)
happyOut52 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut52 #-}
happyIn53 :: (FormatItem A0) -> (HappyAbsSyn )
happyIn53 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn53 #-}
happyOut53 :: (HappyAbsSyn ) -> (FormatItem A0)
happyOut53 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut53 #-}
happyIn54 :: (AList DataGroup A0) -> (HappyAbsSyn )
happyIn54 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn54 #-}
happyOut54 :: (HappyAbsSyn ) -> (AList DataGroup A0)
happyOut54 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut54 #-}
happyIn55 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn55 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn55 #-}
happyOut55 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut55 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut55 #-}
happyIn56 :: (Expression A0) -> (HappyAbsSyn )
happyIn56 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn56 #-}
happyOut56 :: (HappyAbsSyn ) -> (Expression A0)
happyOut56 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut56 #-}
happyIn57 :: (Expression A0) -> (HappyAbsSyn )
happyIn57 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn57 #-}
happyOut57 :: (HappyAbsSyn ) -> (Expression A0)
happyOut57 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut57 #-}
happyIn58 :: (AList (AList Expression) A0) -> (HappyAbsSyn )
happyIn58 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn58 #-}
happyOut58 :: (HappyAbsSyn ) -> (AList (AList Expression) A0)
happyOut58 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut58 #-}
happyIn59 :: (AList CommonGroup A0) -> (HappyAbsSyn )
happyIn59 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn59 #-}
happyOut59 :: (HappyAbsSyn ) -> (AList CommonGroup A0)
happyOut59 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut59 #-}
happyIn60 :: (CommonGroup A0) -> (HappyAbsSyn )
happyIn60 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn60 #-}
happyOut60 :: (HappyAbsSyn ) -> (CommonGroup A0)
happyOut60 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut60 #-}
happyIn61 :: (CommonGroup A0) -> (HappyAbsSyn )
happyIn61 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn61 #-}
happyOut61 :: (HappyAbsSyn ) -> (CommonGroup A0)
happyOut61 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut61 #-}
happyIn62 :: (Expression A0) -> (HappyAbsSyn )
happyIn62 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn62 #-}
happyOut62 :: (HappyAbsSyn ) -> (Expression A0)
happyOut62 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut62 #-}
happyIn63 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn63 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn63 #-}
happyOut63 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut63 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut63 #-}
happyIn64 :: (AList Declarator A0) -> (HappyAbsSyn )
happyIn64 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn64 #-}
happyOut64 :: (HappyAbsSyn ) -> (AList Declarator A0)
happyOut64 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut64 #-}
happyIn65 :: (Declarator A0) -> (HappyAbsSyn )
happyIn65 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn65 #-}
happyOut65 :: (HappyAbsSyn ) -> (Declarator A0)
happyOut65 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut65 #-}
happyIn66 :: (AList Declarator A0) -> (HappyAbsSyn )
happyIn66 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn66 #-}
happyOut66 :: (HappyAbsSyn ) -> (AList Declarator A0)
happyOut66 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut66 #-}
happyIn67 :: (Declarator A0) -> (HappyAbsSyn )
happyIn67 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn67 #-}
happyOut67 :: (HappyAbsSyn ) -> (Declarator A0)
happyOut67 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut67 #-}
happyIn68 :: (Declarator A0) -> (HappyAbsSyn )
happyIn68 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn68 #-}
happyOut68 :: (HappyAbsSyn ) -> (Declarator A0)
happyOut68 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut68 #-}
happyIn69 :: (AList DimensionDeclarator A0) -> (HappyAbsSyn )
happyIn69 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn69 #-}
happyOut69 :: (HappyAbsSyn ) -> (AList DimensionDeclarator A0)
happyOut69 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut69 #-}
happyIn70 :: (DimensionDeclarator A0) -> (HappyAbsSyn )
happyIn70 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn70 #-}
happyOut70 :: (HappyAbsSyn ) -> (DimensionDeclarator A0)
happyOut70 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut70 #-}
happyIn71 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn71 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn71 #-}
happyOut71 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut71 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut71 #-}
happyIn72 :: (AList Argument A0) -> (HappyAbsSyn )
happyIn72 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn72 #-}
happyOut72 :: (HappyAbsSyn ) -> (AList Argument A0)
happyOut72 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut72 #-}
happyIn73 :: (AList Argument A0) -> (HappyAbsSyn )
happyIn73 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn73 #-}
happyOut73 :: (HappyAbsSyn ) -> (AList Argument A0)
happyOut73 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut73 #-}
happyIn74 :: (Argument A0) -> (HappyAbsSyn )
happyIn74 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn74 #-}
happyOut74 :: (HappyAbsSyn ) -> (Argument A0)
happyOut74 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut74 #-}
happyIn75 :: (Expression A0) -> (HappyAbsSyn )
happyIn75 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn75 #-}
happyOut75 :: (HappyAbsSyn ) -> (Expression A0)
happyOut75 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut75 #-}
happyIn76 :: (Expression A0) -> (HappyAbsSyn )
happyIn76 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn76 #-}
happyOut76 :: (HappyAbsSyn ) -> (Expression A0)
happyOut76 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut76 #-}
happyIn77 :: ([ Expression A0 ]) -> (HappyAbsSyn )
happyIn77 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn77 #-}
happyOut77 :: (HappyAbsSyn ) -> ([ Expression A0 ])
happyOut77 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut77 #-}
happyIn78 :: (Expression A0) -> (HappyAbsSyn )
happyIn78 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn78 #-}
happyOut78 :: (HappyAbsSyn ) -> (Expression A0)
happyOut78 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut78 #-}
happyIn79 :: (Expression A0) -> (HappyAbsSyn )
happyIn79 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn79 #-}
happyOut79 :: (HappyAbsSyn ) -> (Expression A0)
happyOut79 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut79 #-}
happyIn80 :: (Expression A0) -> (HappyAbsSyn )
happyIn80 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn80 #-}
happyOut80 :: (HappyAbsSyn ) -> (Expression A0)
happyOut80 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut80 #-}
happyIn81 :: (BinaryOp) -> (HappyAbsSyn )
happyIn81 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn81 #-}
happyOut81 :: (HappyAbsSyn ) -> (BinaryOp)
happyOut81 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut81 #-}
happyIn82 :: (Expression A0) -> (HappyAbsSyn )
happyIn82 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn82 #-}
happyOut82 :: (HappyAbsSyn ) -> (Expression A0)
happyOut82 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut82 #-}
happyIn83 :: ([ Index A0 ]) -> (HappyAbsSyn )
happyIn83 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn83 #-}
happyOut83 :: (HappyAbsSyn ) -> ([ Index A0 ])
happyOut83 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut83 #-}
happyIn84 :: (Index A0) -> (HappyAbsSyn )
happyIn84 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn84 #-}
happyOut84 :: (HappyAbsSyn ) -> (Index A0)
happyOut84 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut84 #-}
happyIn85 :: (Index A0) -> (HappyAbsSyn )
happyIn85 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn85 #-}
happyOut85 :: (HappyAbsSyn ) -> (Index A0)
happyOut85 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut85 #-}
happyIn86 :: ((SrcSpan, UnaryOp)) -> (HappyAbsSyn )
happyIn86 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn86 #-}
happyOut86 :: (HappyAbsSyn ) -> ((SrcSpan, UnaryOp))
happyOut86 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut86 #-}
happyIn87 :: (Maybe (AList Expression A0)) -> (HappyAbsSyn )
happyIn87 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn87 #-}
happyOut87 :: (HappyAbsSyn ) -> (Maybe (AList Expression A0))
happyOut87 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut87 #-}
happyIn88 :: ([ Expression A0 ]) -> (HappyAbsSyn )
happyIn88 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn88 #-}
happyOut88 :: (HappyAbsSyn ) -> ([ Expression A0 ])
happyOut88 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut88 #-}
happyIn89 :: (Expression A0) -> (HappyAbsSyn )
happyIn89 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn89 #-}
happyOut89 :: (HappyAbsSyn ) -> (Expression A0)
happyOut89 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut89 #-}
happyIn90 :: (Expression A0) -> (HappyAbsSyn )
happyIn90 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn90 #-}
happyOut90 :: (HappyAbsSyn ) -> (Expression A0)
happyOut90 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut90 #-}
happyIn91 :: (Expression A0) -> (HappyAbsSyn )
happyIn91 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn91 #-}
happyOut91 :: (HappyAbsSyn ) -> (Expression A0)
happyOut91 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut91 #-}
happyIn92 :: (Maybe (SrcSpan, String)) -> (HappyAbsSyn )
happyIn92 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn92 #-}
happyOut92 :: (HappyAbsSyn ) -> (Maybe (SrcSpan, String))
happyOut92 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut92 #-}
happyIn93 :: ((SrcSpan, String)) -> (HappyAbsSyn )
happyIn93 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn93 #-}
happyOut93 :: (HappyAbsSyn ) -> ((SrcSpan, String))
happyOut93 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut93 #-}
happyIn94 :: (Expression A0) -> (HappyAbsSyn )
happyIn94 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn94 #-}
happyOut94 :: (HappyAbsSyn ) -> (Expression A0)
happyOut94 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut94 #-}
happyIn95 :: (Expression A0) -> (HappyAbsSyn )
happyIn95 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn95 #-}
happyOut95 :: (HappyAbsSyn ) -> (Expression A0)
happyOut95 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut95 #-}
happyIn96 :: (Expression A0) -> (HappyAbsSyn )
happyIn96 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn96 #-}
happyOut96 :: (HappyAbsSyn ) -> (Expression A0)
happyOut96 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut96 #-}
happyIn97 :: (Expression A0) -> (HappyAbsSyn )
happyIn97 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn97 #-}
happyOut97 :: (HappyAbsSyn ) -> (Expression A0)
happyOut97 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut97 #-}
happyIn98 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn98 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn98 #-}
happyOut98 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut98 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut98 #-}
happyIn99 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn99 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn99 #-}
happyOut99 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut99 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut99 #-}
happyIn100 :: (Expression A0) -> (HappyAbsSyn )
happyIn100 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn100 #-}
happyOut100 :: (HappyAbsSyn ) -> (Expression A0)
happyOut100 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut100 #-}
happyIn101 :: (Expression A0) -> (HappyAbsSyn )
happyIn101 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn101 #-}
happyOut101 :: (HappyAbsSyn ) -> (Expression A0)
happyOut101 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut101 #-}
happyIn102 :: (TypeSpec A0) -> (HappyAbsSyn )
happyIn102 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn102 #-}
happyOut102 :: (HappyAbsSyn ) -> (TypeSpec A0)
happyOut102 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut102 #-}
happyIn103 :: (Maybe (Selector A0)) -> (HappyAbsSyn )
happyIn103 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn103 #-}
happyOut103 :: (HappyAbsSyn ) -> (Maybe (Selector A0))
happyOut103 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut103 #-}
happyIn104 :: (Maybe (Selector A0)) -> (HappyAbsSyn )
happyIn104 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn104 #-}
happyOut104 :: (HappyAbsSyn ) -> (Maybe (Selector A0))
happyOut104 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut104 #-}
happyIn105 :: (Maybe (Selector A0)) -> (HappyAbsSyn )
happyIn105 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn105 #-}
happyOut105 :: (HappyAbsSyn ) -> (Maybe (Selector A0))
happyOut105 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut105 #-}
happyIn106 :: (TypeSpec A0) -> (HappyAbsSyn )
happyIn106 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn106 #-}
happyOut106 :: (HappyAbsSyn ) -> (TypeSpec A0)
happyOut106 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut106 #-}
happyIn107 :: (Expression A0) -> (HappyAbsSyn )
happyIn107 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn107 #-}
happyOut107 :: (HappyAbsSyn ) -> (Expression A0)
happyOut107 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut107 #-}
happyInTok :: (Token) -> (HappyAbsSyn )
happyInTok x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyInTok #-}
happyOutTok :: (HappyAbsSyn ) -> (Token)
happyOutTok x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOutTok #-}


happyActOffsets :: HappyAddr
happyActOffsets = HappyA# "\x6a\x05\xb2\x05\x90\x01\x8d\x06\x63\x05\x00\x00\x8f\x07\x00\x00\x00\x00\x00\x00\x90\x01\xd2\x06\x00\x00\x00\x00\x00\x00\x00\x00\x90\x01\x90\x01\xa2\x06\x4e\x00\x00\x00\x00\x00\x00\x00\x90\x01\x00\x00\x00\x00\x7c\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xcf\x06\x00\x00\xd0\x06\x7a\x06\x79\x06\x89\x06\x22\x00\xc7\x06\x00\x00\xba\x06\x00\x00\x6b\x06\x90\x01\x82\x01\x00\x00\xea\x00\x00\x00\xea\x00\xe5\xff\xb9\x06\x00\x00\x54\x00\xb6\x06\xd7\x02\xb6\x06\xb6\x06\xb6\x06\x69\x00\x69\x00\x69\x00\x4e\x01\xb5\x06\x5f\x06\x5f\x06\x1d\x00\x6f\x06\x6f\x06\x6f\x06\x6f\x06\x6f\x06\x6f\x06\x5e\x06\x4b\x0c\xae\x06\x5b\x06\x5b\x06\xaa\x06\x4b\x06\x00\x00\xe7\x05\x55\x06\xe7\x05\x00\x00\x8b\x06\x40\x06\x40\x06\x40\x06\xdd\xff\x51\x06\x4f\x06\x4d\x06\xbd\x02\x00\x00\x8e\x06\x8e\x06\x3a\x06\x38\x06\x36\x06\x00\x00\x00\x00\x34\x06\x32\x06\xe7\x05\x5b\x02\x00\x00\x00\x00\x82\x06\x9b\x00\x83\x06\x33\x06\x72\x06\x00\x00\x68\x06\x1e\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x57\x06\x00\x00\x00\x00\x7d\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x76\x02\x23\x02\x53\x06\x00\x00\x56\x06\x45\x06\x44\x06\xf5\x05\xfa\x05\x00\x00\xf0\x05\x3b\x06\x16\x01\x00\x00\x00\x00\x00\x00\x3e\x06\x00\x00\x67\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x9a\x00\x00\x00\x00\x00\x3e\x06\x00\x00\x00\x00\x90\x01\x61\x00\x04\x00\x90\x01\x00\x00\x37\x06\x25\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x06\x00\x00\x00\x00\x00\x00\xe1\x05\x3e\x0b\x31\x06\x90\x01\x90\x01\x32\x00\x59\x01\x23\x03\x00\x00\xee\x05\x1b\x06\x00\x00\x24\x06\x00\x00\x00\x00\x00\x00\x25\x06\xbe\x00\x90\x01\xde\x0b\x00\x00\xaa\x04\x00\x00\xe4\x05\x3e\x0b\x9f\x04\x07\x03\xda\x05\x90\x01\x90\x01\x90\x01\x90\x01\x90\x01\x44\x01\x90\x01\x90\x01\x90\x01\x90\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xde\x0b\x9e\x0b\x6e\x0b\x6e\x0b\xda\x05\x90\x01\xda\x05\xda\x05\x03\x04\x03\x04\xe3\x0b\x00\x00\x90\x01\x00\x00\x90\x01\x00\x00\x00\x00\x00\x00\xd3\x05\x3e\x0b\x97\x04\x21\x03\x00\x00\x00\x00\x00\x00\x90\x01\x39\x01\xc0\x05\xc0\x05\x00\x00\x00\x00\xd1\x05\x3e\x0b\x90\x01\x00\x00\x0f\x06\x51\x03\x3e\x03\x00\x00\x1c\x03\x2b\x01\xc8\x05\x0e\x01\x00\x00\xbb\x05\x90\x01\x27\x03\x02\x06\x00\x00\x00\x00\x05\x06\x04\x00\x04\x00\xbd\x05\xfe\x05\x3e\x0b\x90\x01\xb0\x02\x9a\x02\x00\x00\xf4\x05\xac\x05\xac\x05\xf8\x05\x00\x00\xa8\x05\xeb\xff\x8b\x02\xf6\x05\xa3\x05\xa3\x05\xd3\x0b\xf0\x00\x00\x00\x00\x00\xfe\x00\x87\x01\xf0\x00\xd3\x0b\xfe\x00\x00\x00\xa1\x05\x86\x03\x54\x02\x00\x00\xe0\x05\x00\x00\x40\x02\x00\x01\x30\x00\x60\x05\x56\x02\x00\x00\x00\x00\x00\x00\x00\x00\x67\x02\x00\x00\x00\x00\x00\x00\x00\x00\xc4\x05\x00\x00\x00\x00\x68\x05\x00\x00\x00\x00\xbe\x05\xbd\x02\x61\x05\x5f\x05\x58\x05\x30\x05\x00\x00\x00\x00\x58\x05\xb2\x05\x00\x00\xbd\x02\xe7\x04\x58\x05\x57\x05\x00\x00\x00\x00\xbd\x02\xa7\x05\x9f\x05\x00\x00\xbd\x02\x9e\x04\x47\x05\x00\x00\x32\x02\x00\x00\x00\x00\x00\x00\x5a\x00\x3b\x00\x00\x00\x00\x00\x00\x00\xb5\x00\x5d\x05\x00\x00\x00\x00\x00\x00\xb8\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\xd5\x01\x00\x00\x3d\x05\x00\x00\x30\x02\x00\x00\x4b\x05\x1f\x01\x8a\x05\x00\x00\xf0\x00\xf0\x00\xf0\x00\xf0\x00\xf0\x00\x00\x00\x89\x05\x41\x05\x00\x00\x00\x00\x2f\x05\x00\x00\x2f\x05\x76\x05\x00\x00\x76\x05\xc0\x01\x00\x00\x24\x05\x00\x00\x71\x02\x6d\x05\x90\x01\xa7\x01\x3e\x05\x3b\x05\x04\x00\x00\x00\xbc\x03\x00\x00\x00\x00\x00\x00\x00\x00\x3e\x0b\x00\x00\x00\x00\x2b\x01\x29\x05\x59\x06\x00\x00\x3e\x0b\x00\x00\x00\x00\x00\x00\x18\x02\x00\x00\x08\x04\x00\x00\x3e\x0b\x38\x05\x14\x01\x90\x01\x00\x00\x3e\x0b\x35\x05\xb6\x02\x1d\x05\xe9\x00\xc3\x0b\x00\x00\x90\x01\x00\x00\x3e\x0b\x00\x00\x14\x01\xe3\x00\x00\x00\xcc\x00\x00\x00\x21\x05\x22\x05\x00\x00\x00\x00\x00\x00\x90\x01\x00\x00\x04\x00\xb3\x04\x3e\x0b\x43\x00\xfa\x01\x00\x00\xe9\x04\x00\x00\x2e\x0b\x00\x00\x00\x00\xe3\x01\xef\x04\x00\x00\x00\x00\xe3\x01\x00\x00\xe3\x01\xde\x04\xec\x01\x00\x00\xa9\x04\xa9\x04\xa9\x04\xcb\x03\xcb\x03\x00\x00\x00\x00\xf0\x00\x84\x04\x00\x00\x5b\x04\x00\x00\x5e\x0b\xb5\x01\x00\x00\x00\x00\x00\x00\xb5\x01\xb5\x01\x00\x00\x00\x00\xa5\x04\x30\x00\x00\x00\x30\x00\x00\x00\x30\x00\x00\x00\xbd\x02\x00\x00\x55\x04\x54\x04\x00\x00\x0c\x04\x4a\x04\x00\x00\x00\x00\x00\x00\x00\x00\xc3\x03\x2a\x00\x00\x00\x00\x00\xb8\x00\xce\x0b\x78\x03\x50\x04\xb5\x01\xb5\x01\xb5\x01\xb5\x01\xb5\x01\x76\x00\xb5\x01\xb5\x01\x00\x00\x00\x00\x09\x01\x00\x00\xbe\x0b\x17\x03\x4e\x04\xe3\x01\xe3\x01\xe3\x01\xe3\x01\xe3\x01\xa8\x01\xe3\x01\xe3\x01\xe3\x01\xe3\x01\x00\x00\x00\x00\x15\x04\x63\x04\x53\x04\xe9\x00\x1e\x0b\x70\x01\x1e\x04\x00\x00\x1e\x0b\x00\x00\xbd\x01\x16\x04\x4f\x04\x70\x01\x00\x00\x00\x00\x40\x04\xf4\x02\x00\x00\x46\x01\xbe\x0b\x8e\x0b\x4e\x0b\x4e\x0b\xda\x03\xe3\x01\xda\x03\xda\x03\x87\x03\x87\x03\xb3\x0b\x00\x00\x00\x00\xae\x0b\x7e\x0b\xd7\x03\x9d\x01\xd7\x03\xd7\x03\x4c\x03\x4c\x03\x0a\x06\x00\x00\x9d\x01\x13\x04\x00\x00\x00\x00\x00\x00\x61\x03\x0a\x06\xee\x04\x00\x00\x13\x00\xd3\x03\x06\x04\x00\x00\x00\x00\x00\x00\x00\x00"#

happyGotoOffsets :: HappyAddr
happyGotoOffsets = HappyA# "\x01\x00\x2e\x02\x73\x0a\xf1\x03\x05\x00\x00\x00\x8b\x03\x00\x00\x00\x00\x00\x00\x5d\x0a\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x47\x0a\xdf\x07\x00\x00\x7c\x03\x00\x00\x00\x00\x00\x00\x31\x0a\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x6f\x02\x89\x03\x70\x03\xc3\x02\x00\x00\x00\x00\x00\x00\x00\x00\x71\x03\x1b\x0a\x4e\x02\x00\x00\xf5\x00\x00\x00\xd4\x00\x2e\x00\x00\x00\x00\x00\x69\x05\xad\x03\xc8\x01\x9a\x03\x8a\x03\x77\x03\x36\x02\x31\x02\xff\x01\xd4\x05\x94\x02\x35\x00\x25\x02\x38\x04\x12\x03\xe8\x02\xe6\x02\xc6\x02\xa9\x02\xa1\x02\xfe\xff\xf7\xff\x00\x00\x73\x02\x85\x01\xa0\x02\x00\x00\x00\x00\x08\x00\x87\x04\x0f\x00\x00\x00\x00\x00\xb9\x02\x9b\x02\x99\x02\x30\x01\x84\x02\x00\x00\x70\x02\xa7\x00\x00\x00\x8d\x02\x7b\x02\x62\x02\x4b\x02\x51\x04\x00\x00\x00\x00\x00\x00\x9f\x03\x0c\x00\x5b\x05\x00\x00\x00\x00\x00\x00\x00\x00\x59\x03\x4f\x01\x00\x00\x00\x00\x00\x00\xf1\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x1f\x0c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x18\x0c\x11\x0c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xd6\x06\x3a\x01\x00\x00\xc8\x06\x00\x00\xf3\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xca\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf1\x06\x00\x00\xd4\x04\x05\x0a\x00\x00\x00\x00\xfe\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf3\x01\xf2\x01\xd0\x02\xef\x09\xd9\x09\x57\x02\xc3\x09\x00\x00\x00\x00\xc3\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb3\x07\xad\x09\xed\x01\x00\x00\x0e\x02\x00\x00\x08\x02\xed\x01\x00\x00\xed\x01\xed\x01\x97\x09\x81\x09\x6b\x09\x55\x09\x3f\x09\x29\x09\x13\x09\xfd\x08\xe7\x08\xd1\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xed\x01\xed\x01\xed\x01\xed\x01\xed\x01\xbb\x08\xed\x01\xed\x01\xed\x01\xed\x01\xed\x01\x00\x00\x0d\x06\x00\x00\xa5\x08\x00\x00\x00\x00\x00\x00\xb8\x01\xed\x01\xed\x01\x00\x00\x00\x00\x00\x00\x00\x00\x8f\x08\x31\x07\xcc\x01\xde\x01\x00\x00\x00\x00\xc1\x01\xab\x01\x79\x08\x00\x00\x5b\x01\xab\x01\xab\x01\x00\x00\x00\x00\x76\x07\x00\x00\xb3\x00\x00\x00\x4c\x01\x63\x08\xab\x01\x00\x00\x00\x00\x00\x00\x00\x00\x5c\x02\x92\x01\x00\x00\x00\x00\xab\x01\xdb\x06\x00\x00\x00\x00\x00\x00\x00\x00\x77\x06\x06\x01\x00\x00\x00\x00\xf1\x05\xb2\x01\x00\x00\x00\x00\x75\x01\xaa\x00\x00\x00\x0a\x0c\x00\x00\x00\x00\xa5\x05\x00\x00\x03\x0c\x00\x00\x4c\x04\x00\x00\xde\x00\xee\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x78\x00\x00\x07\x55\x05\x5b\x05\x00\x00\x00\x00\x00\x00\x00\x00\x50\x05\x00\x00\x00\x00\x00\x00\x00\x00\xc5\x01\x00\x00\x00\x00\x2d\x01\x00\x00\x00\x00\xd3\x01\x85\x00\xd7\x01\x2d\x03\xcf\x01\xcd\x00\x00\x00\x00\x00\xc4\x01\x20\x02\x00\x00\x77\x00\xcd\x00\xa3\x01\x00\x00\x00\x00\x00\x00\x3d\x00\x00\x00\x00\x00\x00\x00\x1b\x00\xcd\x00\x9b\x01\x00\x00\xed\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xda\x02\x00\x00\x00\x00\x00\x00\x00\x00\x06\x06\x00\x00\x00\x00\x00\x00\x00\x00\x2c\x00\x06\x0b\x00\x00\xba\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xfc\x0b\xf5\x0b\xee\x0b\xe7\x0b\x13\x07\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x54\x05\x00\x00\xdf\x02\x00\x00\x00\x00\x00\x00\x5a\x05\x00\x00\x8f\x01\x00\x00\x77\x02\x00\x00\x4d\x08\x71\x01\x00\x00\x00\x00\x03\x00\x00\x00\x5d\x01\x00\x00\x00\x00\x00\x00\x00\x00\x5d\x01\x00\x00\x00\x00\x5e\x07\x00\x00\x59\x05\x00\x00\x5d\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x5d\x01\x00\x00\x5d\x01\x00\x00\xc9\x07\x37\x08\x00\x00\x5d\x01\x00\x00\x5d\x01\x00\x00\x00\x00\x5d\x01\x00\x00\xdc\x05\x00\x00\x5d\x01\x00\x00\x9d\x07\x21\x08\x00\x00\x47\x07\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0b\x08\x00\x00\x74\x01\x00\x00\x5d\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x47\x01\x00\x00\x00\x00\xca\x06\x00\x00\x00\x00\x00\x00\xc5\x06\x00\x00\xb0\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x44\x04\x00\x00\x00\x00\xd8\x00\x00\x00\x43\x01\xf9\x0a\x00\x00\x00\x00\x00\x00\xf1\x0a\xe4\x0a\x00\x00\x00\x00\x00\x00\x07\x07\x00\x00\x1a\x07\x00\x00\xdc\x02\x00\x00\x0d\x00\x00\x00\xcd\x00\x46\x00\x00\x00\xcd\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xcd\x00\x00\x00\x00\x00\x00\x00\xd5\x04\x3f\x01\x3f\x01\x3f\x01\xdc\x0a\xcf\x0a\xc7\x0a\xba\x0a\xb2\x0a\xa5\x0a\x9d\x0a\x90\x0a\x00\x00\x00\x00\x00\x00\x00\x00\x2f\x01\x2f\x01\x2f\x01\xab\x06\x9c\x06\x93\x06\x86\x06\x84\x06\x71\x06\x6c\x06\x4e\x06\x4c\x06\x3d\x06\x00\x00\x00\x00\xdb\x00\x00\x00\x00\x00\x00\x00\x1d\x01\xf5\x07\xf9\xff\x00\x00\x9d\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf2\x05\x00\x00\x00\x00\x00\x00\x9d\x00\x00\x00\x00\x00\x67\x00\x67\x00\x67\x00\x67\x00\x67\x00\xdc\x04\x67\x00\x67\x00\x67\x00\x67\x00\x67\x00\x00\x00\x00\x00\x60\x00\x60\x00\x60\x00\x88\x0a\x60\x00\x60\x00\x60\x00\x60\x00\x60\x00\x00\x00\x7b\x0a\x00\x00\x00\x00\x00\x00\x00\x00\x60\x00\x60\x00\x57\x00\x00\x00\xed\xff\xe2\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyDefActions :: HappyAddr
happyDefActions = HappyA# "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xe0\xff\x00\x00\x05\xff\x08\xff\x07\xff\x00\x00\x06\xff\xc0\xfe\xbf\xfe\x0b\xff\x09\xff\x00\x00\x00\x00\x00\x00\xca\xfe\xbe\xfe\xd0\xfe\xd1\xfe\x00\x00\xcb\xfe\xfe\xfe\x00\x00\xdf\xff\xde\xff\xdd\xff\xd3\xff\xd5\xff\xdc\xff\x6c\xff\x00\x00\x53\xff\x54\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xcf\xff\x00\x00\xce\xff\x00\x00\xc9\xff\x80\xff\xc6\xff\xc4\xff\xc3\xff\xc1\xff\x00\x00\x00\x00\xcc\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa9\xfe\xae\xfe\xae\xfe\xae\xfe\xae\xfe\xae\xfe\xae\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xfb\xff\xfa\xff\xe2\xff\x00\x00\xe5\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xe4\xff\x00\x00\x00\x00\xec\xff\xed\xff\xed\xff\x00\x00\x00\x00\xe2\xff\xe6\xff\xf6\xff\xe3\xff\xe2\xff\xf9\xff\x00\x00\x4e\xff\x30\xff\x6e\xff\x00\x00\x68\xff\x00\x00\x6a\xff\x5a\xff\x00\x00\xa9\xfe\xa8\xfe\xa7\xfe\xa6\xfe\xa5\xfe\xa4\xfe\xa3\xfe\x6b\xff\x72\xff\x20\xff\xb2\xfe\x00\x00\xb3\xfe\xb4\xfe\xb5\xfe\xb6\xfe\xb7\xfe\xb1\xfe\xac\xfe\x00\x00\x00\x00\x71\xff\x2a\xff\x00\x00\x73\xff\x6f\xff\x00\x00\x70\xff\x38\xff\x00\x00\x33\xff\x00\x00\xb2\xff\xb3\xff\xa7\xff\xa8\xff\xa9\xff\x00\x00\xca\xfe\xa6\xff\xb0\xff\xb1\xff\xb4\xff\xb5\xff\xb6\xff\xb7\xff\xb8\xff\xb9\xff\xad\xff\xac\xff\xab\xff\xae\xff\xaa\xff\xbb\xff\xbd\xff\xbf\xff\x00\x00\xd8\xff\x00\x00\x00\x00\xb8\xfe\xc2\xff\x7b\xff\x7a\xff\xc5\xff\xc7\xff\x81\xff\x7e\xff\x7d\xff\x7c\xff\x00\x00\xc8\xff\xca\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x79\xff\x00\x00\x00\x00\x66\xff\x5c\xff\x2e\xff\x2d\xff\x2c\xff\x28\xff\x00\x00\x00\x00\x10\xff\xc9\xfe\xc4\xfe\xc3\xfe\xc4\xfe\xff\xfe\x00\x00\x00\x00\x13\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xde\xfe\xdd\xfe\xe0\xfe\xdf\xfe\xe2\xfe\xe1\xfe\xfc\xff\xe1\xff\x11\xff\x12\xff\x0e\xff\x0f\xff\x16\xff\x00\x00\x17\xff\x15\xff\x18\xff\x19\xff\x0d\xff\x0c\xff\x00\x00\x04\xff\x00\x00\xc7\xfe\xc5\xfe\xc8\xfe\xc4\xfe\x74\xff\xd6\xfe\x00\x00\xd8\xfe\xd7\xfe\xdc\xfe\xd5\xfe\x00\x00\x00\x00\x00\x00\xba\xfe\xbc\xfe\x00\x00\x76\xff\x00\x00\x78\xff\x00\x00\x00\x00\x00\x00\xcb\xff\x00\x00\x1c\xff\x00\x00\x00\x00\xda\xff\x00\x00\x00\x00\x00\x00\xc0\xff\x87\xff\x85\xff\x86\xff\x00\x00\x00\x00\x00\x00\xbc\xff\x82\xff\x00\x00\x00\x00\x00\x00\x9f\xff\xcb\xfe\x00\x00\x00\x00\x35\xff\x39\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xab\xfe\x00\x00\xe3\xfe\xe5\xfe\x00\x00\x00\x00\x00\x00\xb0\xfe\x00\x00\xa2\xfe\x00\x00\x00\x00\x00\x00\x5e\xff\x00\x00\x67\xff\x00\x00\x62\xff\x00\x00\x00\x00\x00\x00\x4f\xff\x50\xff\x4a\xff\x6d\xff\x00\x00\x49\xff\x48\xff\x47\xff\x46\xff\x00\x00\x4d\xff\xbd\xfe\xe2\xff\xf8\xff\xf5\xff\xed\xff\x00\x00\x00\x00\xce\xfe\x00\x00\x00\x00\xea\xff\xe7\xff\x00\x00\x00\x00\xb9\xfe\x00\x00\x00\x00\x00\x00\xe8\xff\xeb\xff\xf0\xff\x00\x00\x00\x00\xcf\xfe\xcc\xfe\x00\x00\x00\x00\x00\x00\xf7\xff\x00\x00\x51\xff\x52\xff\x4b\xff\x00\x00\x00\x00\x42\xff\x40\xff\x3c\xff\x00\x00\xc0\xfe\x3f\xff\xc1\xfe\x3d\xff\x00\x00\x63\xff\x61\xff\x60\xff\x65\xff\x00\x00\x00\x00\x69\xff\x00\x00\x5b\xff\x00\x00\x57\xff\x56\xff\x00\x00\x00\x00\xa1\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xad\xfe\x00\x00\xe7\xfe\x2b\xff\x21\xff\x00\x00\x3a\xff\x00\x00\x37\xff\x31\xff\x34\xff\x00\x00\xa1\xff\x00\x00\xa2\xff\x00\x00\xba\xff\x00\x00\x00\x00\xbe\xff\x00\x00\x00\x00\xcd\xff\xd6\xff\xd9\xff\x7f\xff\x32\xff\x1d\xff\x1a\xff\x1b\xff\x1f\xff\x00\x00\x00\x00\x00\x00\x77\xff\x75\xff\xbb\xfe\xd4\xff\x2f\xff\x00\x00\x26\xff\x24\xff\x22\xff\xd4\xfe\xdb\xfe\x00\x00\xd3\xfe\xc6\xfe\x00\xff\x00\x00\x00\x00\x07\xff\x06\xff\x14\xff\x0a\xff\x00\x00\x03\xff\xd2\xfe\xd9\xfe\x00\x00\x00\x00\x29\xff\x00\x00\xdb\xff\x00\x00\x00\x00\xd1\xff\xd0\xff\x1e\xff\x00\x00\x88\xff\x00\x00\xaf\xff\x83\xff\x00\x00\x00\x00\xa0\xff\x00\x00\x9e\xff\x9d\xff\x8b\xff\x8a\xff\x00\x00\x89\xff\x8d\xff\x8c\xff\x00\x00\x9c\xff\x00\x00\x36\xff\x00\x00\xaa\xfe\xe9\xfe\xea\xfe\xe8\xfe\xeb\xfe\xec\xfe\xaf\xfe\xe6\xfe\x00\x00\x00\x00\x59\xff\x00\x00\x5f\xff\x5d\xff\x00\x00\xed\xfe\xf1\xfe\xef\xfe\x00\x00\x00\x00\xee\xfe\x64\xff\x00\x00\x00\x00\xc2\xfe\x00\x00\x44\xff\x00\x00\x4c\xff\x00\x00\xf4\xff\x00\x00\x00\x00\xee\xff\x00\x00\xe9\xff\xef\xff\xf1\xff\xcd\xfe\xf2\xff\x00\x00\x00\x00\x43\xff\x41\xff\x00\x00\xf4\xfe\x00\x00\xf7\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x58\xff\x55\xff\x00\x00\x3b\xff\x92\xff\x00\x00\x95\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa3\xff\xa4\xff\x00\x00\x00\x00\x85\xff\x86\xff\xd7\xff\x00\x00\x00\x00\x27\xff\x25\xff\x23\xff\x00\x00\x00\x00\x00\x00\x00\x00\x02\xff\xda\xfe\x00\x00\x00\x00\x84\xff\x00\x00\x93\xff\x94\xff\x90\xff\x91\xff\x98\xff\x00\x00\x99\xff\x97\xff\x9a\xff\x9b\xff\x8f\xff\x8e\xff\xe4\xfe\xf5\xfe\xf6\xfe\xfa\xfe\x00\x00\xfb\xfe\xf9\xfe\xfc\xfe\xfd\xfe\xf3\xfe\xf2\xfe\x00\x00\x00\x00\x45\xff\xf3\xff\x3e\xff\x00\x00\xf8\xfe\x96\xff\xa5\xff\x00\x00\x00\x00\x00\x00\x01\xff\xd2\xff\xf0\xfe"#

happyCheck :: HappyAddr
happyCheck = HappyA# "\xff\xff\x00\x00\x01\x00\x02\x00\x03\x00\x01\x00\x01\x00\x02\x00\x03\x00\x08\x00\x09\x00\x03\x00\x0b\x00\x08\x00\x09\x00\x03\x00\x08\x00\x09\x00\x03\x00\x06\x00\x07\x00\x09\x00\x09\x00\x29\x00\x09\x00\x0c\x00\x0d\x00\x0e\x00\x19\x00\x10\x00\x01\x00\x28\x00\x29\x00\x06\x00\x07\x00\x01\x00\x09\x00\x40\x00\x13\x00\x0c\x00\x0d\x00\x0e\x00\x05\x00\x10\x00\x1f\x00\x20\x00\x21\x00\x05\x00\x53\x00\x01\x00\x47\x00\x01\x00\x27\x00\x58\x00\x06\x00\x05\x00\x53\x00\x2c\x00\x1f\x00\x20\x00\x21\x00\x0f\x00\x53\x00\x41\x00\x05\x00\x5f\x00\x27\x00\x06\x00\x07\x00\x02\x00\x09\x00\x2c\x00\x05\x00\x0c\x00\x0d\x00\x0e\x00\x5f\x00\x10\x00\x20\x00\x4c\x00\x24\x00\x53\x00\x64\x00\x40\x00\x06\x00\x01\x00\x53\x00\x53\x00\x5f\x00\x4c\x00\x2c\x00\x64\x00\x1f\x00\x20\x00\x21\x00\x05\x00\x53\x00\x60\x00\x40\x00\x46\x00\x27\x00\x60\x00\x05\x00\x4c\x00\x60\x00\x2c\x00\x01\x00\x5e\x00\x60\x00\x60\x00\x53\x00\x60\x00\x40\x00\x47\x00\x42\x00\x43\x00\x44\x00\x53\x00\x41\x00\x01\x00\x53\x00\x5e\x00\x4c\x00\x60\x00\x06\x00\x06\x00\x07\x00\x53\x00\x09\x00\x53\x00\x47\x00\x0c\x00\x0d\x00\x0e\x00\x56\x00\x10\x00\x53\x00\x4c\x00\x47\x00\x06\x00\x07\x00\x5f\x00\x09\x00\x41\x00\x53\x00\x0c\x00\x0d\x00\x0e\x00\x40\x00\x10\x00\x1f\x00\x20\x00\x21\x00\x53\x00\x46\x00\x5e\x00\x24\x00\x60\x00\x27\x00\x05\x00\x05\x00\x47\x00\x4b\x00\x2c\x00\x1f\x00\x20\x00\x21\x00\x53\x00\x47\x00\x40\x00\x56\x00\x4b\x00\x27\x00\x06\x00\x07\x00\x46\x00\x09\x00\x2c\x00\x4b\x00\x0c\x00\x0d\x00\x0e\x00\x40\x00\x10\x00\x42\x00\x43\x00\x44\x00\x06\x00\x53\x00\x47\x00\x06\x00\x01\x00\x02\x00\x03\x00\x4c\x00\x4c\x00\x06\x00\x07\x00\x1f\x00\x20\x00\x21\x00\x53\x00\x53\x00\x53\x00\x56\x00\x01\x00\x27\x00\x03\x00\x1d\x00\x4c\x00\x06\x00\x2c\x00\x07\x00\x5e\x00\x09\x00\x60\x00\x53\x00\x0c\x00\x0d\x00\x0e\x00\x12\x00\x10\x00\x14\x00\x15\x00\x26\x00\x47\x00\x47\x00\x5e\x00\x01\x00\x60\x00\x03\x00\x3d\x00\x4b\x00\x06\x00\x01\x00\x38\x00\x1f\x00\x20\x00\x21\x00\x14\x00\x15\x00\x01\x00\x1e\x00\x4c\x00\x27\x00\x40\x00\x06\x00\x0e\x00\x40\x00\x2c\x00\x53\x00\x43\x00\x44\x00\x53\x00\x40\x00\x01\x00\x42\x00\x43\x00\x44\x00\x2b\x00\x06\x00\x5e\x00\x53\x00\x60\x00\x2a\x00\x2b\x00\x4c\x00\x02\x00\x40\x00\x53\x00\x42\x00\x43\x00\x44\x00\x53\x00\x46\x00\x1e\x00\x56\x00\x01\x00\x4c\x00\x03\x00\x4c\x00\x4c\x00\x06\x00\x07\x00\x48\x00\x53\x00\x54\x00\x53\x00\x53\x00\x02\x00\x56\x00\x40\x00\x05\x00\x42\x00\x43\x00\x44\x00\x54\x00\x46\x00\x40\x00\x5e\x00\x01\x00\x60\x00\x03\x00\x4c\x00\x40\x00\x06\x00\x2c\x00\x43\x00\x44\x00\x05\x00\x53\x00\x0a\x00\x0b\x00\x56\x00\x01\x00\x0b\x00\x03\x00\x48\x00\x40\x00\x06\x00\x56\x00\x43\x00\x44\x00\x53\x00\x46\x00\x01\x00\x46\x00\x03\x00\x02\x00\x54\x00\x06\x00\x05\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x53\x00\x4c\x00\x53\x00\x40\x00\x47\x00\x42\x00\x43\x00\x44\x00\x53\x00\x01\x00\x0f\x00\x03\x00\x47\x00\x05\x00\x06\x00\x4c\x00\x53\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x53\x00\x4b\x00\x53\x00\x56\x00\x40\x00\x20\x00\x42\x00\x43\x00\x44\x00\x36\x00\x01\x00\x38\x00\x03\x00\x25\x00\x26\x00\x06\x00\x4c\x00\x2c\x00\x40\x00\x4b\x00\x42\x00\x43\x00\x44\x00\x53\x00\x46\x00\x55\x00\x56\x00\x11\x00\x0f\x00\x40\x00\x4c\x00\x42\x00\x43\x00\x44\x00\x02\x00\x4b\x00\x47\x00\x53\x00\x19\x00\x4b\x00\x56\x00\x4c\x00\x01\x00\x4b\x00\x03\x00\x20\x00\x47\x00\x06\x00\x53\x00\x4c\x00\x40\x00\x56\x00\x42\x00\x43\x00\x44\x00\x01\x00\x53\x00\x2c\x00\x53\x00\x53\x00\x06\x00\x15\x00\x4c\x00\x0b\x00\x40\x00\x4b\x00\x01\x00\x18\x00\x19\x00\x53\x00\x46\x00\x0b\x00\x56\x00\x40\x00\x2c\x00\x42\x00\x43\x00\x44\x00\x30\x00\x01\x00\x5c\x00\x5d\x00\x48\x00\x53\x00\x06\x00\x4c\x00\x4c\x00\x39\x00\x02\x00\x4c\x00\x01\x00\x05\x00\x53\x00\x53\x00\x54\x00\x56\x00\x53\x00\x53\x00\x47\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x0b\x00\x40\x00\x4c\x00\x42\x00\x43\x00\x44\x00\x53\x00\x01\x00\x04\x00\x53\x00\x11\x00\x0b\x00\x06\x00\x4c\x00\x40\x00\x4c\x00\x42\x00\x43\x00\x44\x00\x0b\x00\x53\x00\x01\x00\x53\x00\x56\x00\x40\x00\x40\x00\x4c\x00\x42\x00\x43\x00\x44\x00\x46\x00\x02\x00\x47\x00\x53\x00\x05\x00\x2d\x00\x56\x00\x4c\x00\x40\x00\x4b\x00\x42\x00\x43\x00\x44\x00\x53\x00\x53\x00\x02\x00\x56\x00\x56\x00\x05\x00\x40\x00\x4c\x00\x42\x00\x43\x00\x44\x00\x53\x00\x46\x00\x3b\x00\x53\x00\x3d\x00\x3e\x00\x56\x00\x4c\x00\x0f\x00\x56\x00\x57\x00\x48\x00\x12\x00\x13\x00\x53\x00\x4c\x00\x40\x00\x56\x00\x42\x00\x43\x00\x44\x00\x02\x00\x53\x00\x54\x00\x05\x00\x20\x00\x53\x00\x5f\x00\x4c\x00\x5f\x00\x40\x00\x01\x00\x42\x00\x43\x00\x44\x00\x53\x00\x06\x00\x2c\x00\x56\x00\x0c\x00\x0d\x00\x0e\x00\x4c\x00\x10\x00\x53\x00\x02\x00\x01\x00\x02\x00\x05\x00\x53\x00\x05\x00\x4b\x00\x56\x00\x0c\x00\x0d\x00\x0e\x00\x4b\x00\x10\x00\x1f\x00\x20\x00\x21\x00\x02\x00\x12\x00\x13\x00\x05\x00\x53\x00\x27\x00\x12\x00\x13\x00\x4c\x00\x4c\x00\x2c\x00\x1f\x00\x20\x00\x21\x00\x05\x00\x53\x00\x53\x00\x54\x00\x63\x00\x27\x00\x02\x00\x01\x00\x02\x00\x05\x00\x2c\x00\x05\x00\x01\x00\x02\x00\x56\x00\x57\x00\x05\x00\x3c\x00\x3d\x00\x40\x00\x56\x00\x57\x00\x43\x00\x44\x00\x01\x00\x1b\x00\x1c\x00\x1d\x00\x4c\x00\x0b\x00\x3c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x53\x00\x18\x00\x19\x00\x53\x00\x01\x00\x53\x00\x47\x00\x4c\x00\x0b\x00\x06\x00\x4c\x00\x01\x00\x04\x00\x60\x00\x53\x00\x4c\x00\x06\x00\x53\x00\x54\x00\x38\x00\x55\x00\x11\x00\x53\x00\x54\x00\x14\x00\x15\x00\x02\x00\x60\x00\x0b\x00\x05\x00\x04\x00\x3c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x3c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x02\x00\x47\x00\x05\x00\x05\x00\x05\x00\x53\x00\x47\x00\x3c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x4c\x00\x3a\x00\x3b\x00\x55\x00\x3d\x00\x3e\x00\x47\x00\x53\x00\x55\x00\x40\x00\x02\x00\x5c\x00\x5d\x00\x05\x00\x40\x00\x46\x00\x02\x00\x43\x00\x44\x00\x05\x00\x55\x00\x40\x00\x05\x00\x48\x00\x43\x00\x44\x00\x53\x00\x4c\x00\x53\x00\x08\x00\x53\x00\x56\x00\x34\x00\x53\x00\x53\x00\x54\x00\x0f\x00\x2d\x00\x11\x00\x12\x00\x53\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x02\x00\x3a\x00\x3b\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x61\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x02\x00\x61\x00\x2c\x00\x05\x00\x31\x00\x32\x00\x33\x00\x53\x00\x54\x00\x42\x00\x43\x00\x57\x00\x58\x00\x53\x00\x40\x00\x39\x00\x02\x00\x2d\x00\x2e\x00\x2f\x00\x46\x00\x02\x00\x5c\x00\x5d\x00\x05\x00\x5f\x00\x02\x00\x48\x00\x02\x00\x05\x00\x61\x00\x05\x00\x02\x00\x53\x00\x4c\x00\x50\x00\x56\x00\x54\x00\x55\x00\x54\x00\x55\x00\x53\x00\x59\x00\x58\x00\x59\x00\x5a\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x02\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x61\x00\x5b\x00\x61\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x02\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x02\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x61\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x02\x00\x22\x00\x23\x00\x05\x00\x51\x00\x52\x00\x53\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x13\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x45\x00\x46\x00\x47\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x13\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x0a\x00\x0b\x00\x4a\x00\x4b\x00\x13\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x13\x00\x05\x00\x4a\x00\x4b\x00\x53\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x08\x00\x45\x00\x46\x00\x47\x00\x5f\x00\x0d\x00\x48\x00\x0f\x00\x57\x00\x11\x00\x12\x00\x4b\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x0b\x00\x3a\x00\x3b\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x02\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x07\x00\x45\x00\x46\x00\x47\x00\x40\x00\x08\x00\x02\x00\x53\x00\x54\x00\x02\x00\x0d\x00\x57\x00\x0f\x00\x45\x00\x11\x00\x12\x00\x45\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x05\x00\x3a\x00\x3b\x00\x45\x00\x46\x00\x47\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x05\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x0a\x00\x0b\x00\x08\x00\x40\x00\x53\x00\x54\x00\x0e\x00\x0d\x00\x57\x00\x0f\x00\x02\x00\x11\x00\x12\x00\x53\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x4a\x00\x3a\x00\x3b\x00\x0a\x00\x0b\x00\x45\x00\x50\x00\x45\x00\x4a\x00\x53\x00\x54\x00\x55\x00\x62\x00\x63\x00\x50\x00\x59\x00\x07\x00\x53\x00\x54\x00\x55\x00\x58\x00\x04\x00\x05\x00\x59\x00\x08\x00\x53\x00\x53\x00\x54\x00\x05\x00\x0d\x00\x57\x00\x0f\x00\x53\x00\x11\x00\x12\x00\x65\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x53\x00\x3a\x00\x3b\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x05\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x40\x00\x41\x00\x18\x00\x19\x00\x45\x00\x08\x00\x01\x00\x53\x00\x54\x00\x17\x00\x0d\x00\x57\x00\x0f\x00\x0e\x00\x11\x00\x12\x00\x47\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x4c\x00\x3a\x00\x3b\x00\x01\x00\x48\x00\x50\x00\x05\x00\x53\x00\x4c\x00\x54\x00\x55\x00\x0e\x00\x50\x00\x58\x00\x59\x00\x53\x00\x54\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x5a\x00\x02\x00\x08\x00\x01\x00\x53\x00\x54\x00\x13\x00\x0d\x00\x57\x00\x0f\x00\x05\x00\x11\x00\x12\x00\x05\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x10\x00\x3a\x00\x3b\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x16\x00\x17\x00\x05\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x53\x00\x1f\x00\x20\x00\x11\x00\x05\x00\x13\x00\x2d\x00\x2e\x00\x2f\x00\x2c\x00\x2c\x00\x53\x00\x53\x00\x54\x00\x2c\x00\x45\x00\x57\x00\x2d\x00\x2e\x00\x2f\x00\x02\x00\x02\x00\x39\x00\x39\x00\x44\x00\x53\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x58\x00\x4c\x00\x4c\x00\x48\x00\x46\x00\x05\x00\x4c\x00\x4c\x00\x53\x00\x53\x00\x02\x00\x50\x00\x5b\x00\x53\x00\x53\x00\x54\x00\x58\x00\x58\x00\x48\x00\x53\x00\x53\x00\x5a\x00\x4c\x00\x5b\x00\x54\x00\x5f\x00\x58\x00\x08\x00\x58\x00\x53\x00\x54\x00\x54\x00\x01\x00\x58\x00\x0f\x00\x58\x00\x11\x00\x12\x00\x01\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x0f\x00\x3a\x00\x3b\x00\x0e\x00\x4a\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x53\x00\x50\x00\x53\x00\x01\x00\x53\x00\x54\x00\x55\x00\x53\x00\x20\x00\x05\x00\x59\x00\x53\x00\x2c\x00\x0f\x00\x0e\x00\x05\x00\x47\x00\x53\x00\x01\x00\x05\x00\x2c\x00\x35\x00\x65\x00\x37\x00\x38\x00\x39\x00\x53\x00\x47\x00\x01\x00\x40\x00\x20\x00\x53\x00\x41\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x0f\x00\x2c\x00\x2c\x00\x45\x00\x4c\x00\x45\x00\x46\x00\x47\x00\x48\x00\x41\x00\x01\x00\x53\x00\x4c\x00\x05\x00\x39\x00\x10\x00\x50\x00\x20\x00\x40\x00\x53\x00\x54\x00\x55\x00\x01\x00\x05\x00\x53\x00\x59\x00\x5a\x00\x45\x00\x46\x00\x2c\x00\x48\x00\x54\x00\x05\x00\x4c\x00\x4c\x00\x01\x00\x05\x00\x47\x00\x50\x00\x53\x00\x53\x00\x53\x00\x54\x00\x55\x00\x53\x00\x05\x00\x05\x00\x59\x00\x5a\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x45\x00\x46\x00\x17\x00\x48\x00\x50\x00\x01\x00\x05\x00\x4c\x00\x54\x00\x55\x00\x05\x00\x50\x00\x58\x00\x59\x00\x53\x00\x54\x00\x55\x00\x17\x00\x46\x00\x17\x00\x59\x00\x5a\x00\x0f\x00\x01\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x05\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x17\x00\x01\x00\x48\x00\x53\x00\x05\x00\x17\x00\x4c\x00\x58\x00\x53\x00\x58\x00\x50\x00\x58\x00\x01\x00\x53\x00\x54\x00\x58\x00\x53\x00\x48\x00\x0a\x00\x48\x00\x5a\x00\x4c\x00\x40\x00\x4c\x00\x17\x00\x50\x00\x17\x00\x50\x00\x53\x00\x54\x00\x53\x00\x54\x00\x2c\x00\x59\x00\x58\x00\x5a\x00\x58\x00\x5a\x00\x58\x00\x17\x00\x01\x00\x53\x00\x58\x00\x53\x00\x01\x00\x39\x00\x53\x00\x53\x00\x17\x00\x48\x00\x46\x00\x01\x00\x01\x00\x4c\x00\x48\x00\x01\x00\x01\x00\x50\x00\x4c\x00\x53\x00\x53\x00\x54\x00\x50\x00\x17\x00\x4c\x00\x53\x00\x54\x00\x5a\x00\x17\x00\x01\x00\x40\x00\x53\x00\x5a\x00\x48\x00\x53\x00\x48\x00\x56\x00\x4c\x00\x01\x00\x4c\x00\x01\x00\x50\x00\x59\x00\x50\x00\x53\x00\x54\x00\x53\x00\x54\x00\x48\x00\x17\x00\x0e\x00\x5a\x00\x4c\x00\x5a\x00\x17\x00\x40\x00\x50\x00\x48\x00\x58\x00\x53\x00\x54\x00\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\x5a\x00\xff\xff\x53\x00\x54\x00\xff\xff\xff\xff\x48\x00\x2c\x00\x1a\x00\x5a\x00\x4c\x00\x48\x00\xff\xff\xff\xff\x50\x00\x4c\x00\xff\xff\x53\x00\x54\x00\x50\x00\x39\x00\x2c\x00\x53\x00\x54\x00\x5a\x00\xff\xff\xff\xff\xff\xff\xff\xff\x5a\x00\x1a\x00\xff\xff\x48\x00\xff\xff\x39\x00\xff\xff\x4c\x00\x48\x00\xff\xff\x4c\x00\x50\x00\x4c\x00\xff\xff\x53\x00\x54\x00\x50\x00\x53\x00\xff\xff\x53\x00\x54\x00\x5a\x00\x45\x00\x46\x00\x4c\x00\x48\x00\x5a\x00\xff\xff\xff\xff\x4c\x00\xff\xff\x53\x00\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\x31\x00\x32\x00\x33\x00\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\x33\x00\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\x48\x00\xff\xff\x59\x00\x5a\x00\x32\x00\x33\x00\xff\xff\x48\x00\x50\x00\xff\xff\xff\xff\xff\xff\x54\x00\x55\x00\xff\xff\x50\x00\x58\x00\x59\x00\x5a\x00\x54\x00\x55\x00\x4a\x00\xff\xff\x58\x00\x59\x00\x5a\x00\x48\x00\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\x50\x00\xff\xff\x59\x00\xff\xff\x54\x00\x55\x00\x3f\x00\x40\x00\x58\x00\x59\x00\x5a\x00\xff\xff\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\x40\x00\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x44\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x5b\x00\x44\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x5b\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\xff\xff\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\x59\x00\x4c\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\x4e\x00\x4f\x00\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\x47\x00\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\xff\xff\x4c\x00\xff\xff\xff\xff\xff\xff\x50\x00\x49\x00\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\x50\x00\x59\x00\x5a\x00\x53\x00\x54\x00\x55\x00\x49\x00\xff\xff\xff\xff\x59\x00\x5a\x00\xff\xff\xff\xff\x50\x00\x49\x00\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\x50\x00\x59\x00\x5a\x00\x53\x00\x54\x00\x55\x00\x49\x00\xff\xff\xff\xff\x59\x00\x5a\x00\xff\xff\xff\xff\x50\x00\x49\x00\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\x50\x00\x59\x00\x5a\x00\x53\x00\x54\x00\x55\x00\x49\x00\xff\xff\xff\xff\x59\x00\x5a\x00\xff\xff\xff\xff\x50\x00\x49\x00\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\x50\x00\x59\x00\x5a\x00\x53\x00\x54\x00\x55\x00\x49\x00\xff\xff\xff\xff\x59\x00\x5a\x00\xff\xff\xff\xff\x50\x00\x49\x00\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\x50\x00\x59\x00\x5a\x00\x53\x00\x54\x00\x55\x00\x49\x00\xff\xff\xff\xff\x59\x00\x5a\x00\xff\xff\xff\xff\x50\x00\x49\x00\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\x50\x00\x59\x00\x5a\x00\x53\x00\x54\x00\x55\x00\x49\x00\xff\xff\xff\xff\x59\x00\x5a\x00\xff\xff\xff\xff\x50\x00\x49\x00\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\x50\x00\x59\x00\x5a\x00\x53\x00\x54\x00\x55\x00\x49\x00\xff\xff\xff\xff\x59\x00\x5a\x00\xff\xff\xff\xff\x50\x00\xff\xff\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x5a\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\xff\xff\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\xff\xff\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\xff\xff\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\xff\xff\xff\xff\x4a\x00\x4b\x00\xff\xff\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\xff\xff\xff\xff\x4a\x00\x4b\x00\xff\xff\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\xff\xff\xff\xff\x4a\x00\x4b\x00\xff\xff\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\xff\xff\xff\xff\xff\xff\x4b\x00\xff\xff\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\xff\xff\xff\xff\xff\xff\x4b\x00\xff\xff\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\xff\xff\xff\xff\xff\xff\x4b\x00\xff\xff\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x52\x00\x4a\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x4a\x00\xff\xff\x53\x00\x54\x00\x55\x00\xff\xff\x50\x00\x4a\x00\x59\x00\x53\x00\x54\x00\x55\x00\xff\xff\x50\x00\x4a\x00\x59\x00\x53\x00\x54\x00\x55\x00\xff\xff\x50\x00\x4a\x00\x59\x00\x53\x00\x54\x00\x55\x00\xff\xff\x50\x00\x4a\x00\x59\x00\x53\x00\x54\x00\x55\x00\xff\xff\x50\x00\x4a\x00\x59\x00\x53\x00\x54\x00\x55\x00\xff\xff\x50\x00\x4a\x00\x59\x00\x53\x00\x54\x00\x55\x00\xff\xff\x50\x00\x4a\x00\x59\x00\x53\x00\x54\x00\x55\x00\xff\xff\x50\x00\xff\xff\x59\x00\x53\x00\x54\x00\x55\x00\xff\xff\xff\xff\xff\xff\x59\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\xff\xff\xff\xff\xff\xff\xff\xff\x39\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"#

happyTable :: HappyAddr
happyTable = HappyA# "\x00\x00\x51\x00\x52\x00\x53\x00\x54\x00\x1d\x01\xe7\x00\x53\x00\x54\x00\x55\x00\x56\x00\x69\x00\x04\x00\x55\x00\x56\x00\x51\x01\x6a\x00\x56\x00\x65\x00\x13\x02\x5a\x01\x66\x00\x5b\x01\x84\x01\x66\x00\x5c\x01\x1b\x00\x1c\x00\xd6\x01\x1d\x00\x89\x00\x72\x00\x73\x00\x0a\x02\x5a\x01\xc5\x00\x5b\x01\xb2\x00\xd3\x01\x5c\x01\x1b\x00\x1c\x00\x16\x01\x1d\x00\x1e\x00\x1f\x00\x20\x00\x05\x02\x61\x00\x7c\x01\x98\x01\xc5\x00\x21\x00\x06\x00\x13\x00\x0d\x01\x19\x00\x22\x00\x1e\x00\x1f\x00\x20\x00\xae\x00\x19\x00\x7d\x00\x05\x02\x6e\x02\x21\x00\x0d\x02\x5a\x01\x36\x02\x5b\x01\x22\x00\x37\x02\x5c\x01\x1b\x00\x1c\x00\xd0\x01\x1d\x00\xaf\x00\x1a\x01\x00\x02\x7e\x00\x74\x00\xb2\x00\xd1\x00\x9b\x00\x1b\x01\x19\x00\x46\x02\x23\x00\x22\x00\x74\x00\x1e\x00\x1f\x00\x20\x00\x28\x01\x24\x00\x57\x00\xb2\x00\x8a\x00\x21\x00\x57\x00\x1e\x01\x23\x00\x57\x00\x22\x00\x9b\x00\x5d\x01\x57\x00\x25\x00\x24\x00\x57\x00\x14\x00\x64\x02\x15\x00\x16\x00\x17\x00\x19\x00\x8d\x00\xfe\x01\x19\x00\x5d\x01\x23\x00\x25\x00\x13\x00\x60\x01\x5a\x01\x7d\x01\x5b\x01\x24\x00\x06\x02\x5c\x01\x1b\x00\x1c\x00\x1a\x00\x1d\x00\x7e\x00\x23\x00\x1f\x01\x6a\x01\x5a\x01\xb0\x00\x5b\x01\xd2\x00\x24\x00\x5c\x01\x1b\x00\x1c\x00\x9c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x11\x02\xaa\x00\x5d\x01\x7c\x01\x25\x00\x21\x00\x22\x01\x28\x01\x07\x02\x2a\x02\x22\x00\x1e\x00\x1f\x00\x20\x00\x19\x00\x1f\x01\x9c\x00\x1a\x00\x1b\x02\x21\x00\x59\x01\x5a\x01\x9d\x00\x5b\x01\x22\x00\x2a\x02\x5c\x01\x1b\x00\x1c\x00\x14\x00\x1d\x00\x15\x00\x16\x00\x17\x00\x13\x00\x19\x00\x5b\x02\x13\x00\x11\x00\x02\x01\x12\x00\xff\x01\x23\x00\x13\x00\x03\x01\x1e\x00\x1f\x00\x20\x00\x19\x00\x24\x00\x7d\x01\x00\x02\x11\x00\x21\x00\x12\x00\xa9\x01\x23\x00\x13\x00\x22\x00\x63\x01\x5d\x01\x5b\x01\x25\x00\x24\x00\x5c\x01\x1b\x00\x1c\x00\x22\x01\x1d\x00\x23\x01\x24\x01\xf7\x01\x1f\x01\x43\x01\x5d\x01\x11\x00\x25\x00\x12\x00\x93\x01\xd7\x00\x13\x00\xcd\x00\xb9\x00\x1e\x00\x1f\x00\x20\x00\x49\x02\x24\x01\x37\x01\xb2\x00\x23\x00\x21\x00\x14\x00\x13\x00\x54\xff\x14\x00\x22\x00\x24\x00\x16\x00\x17\x00\x8c\x00\x14\x00\x37\x01\x15\x00\x16\x00\x17\x00\x23\x02\x13\x00\x5d\x01\xba\x00\x25\x00\x85\x01\x86\x01\x18\x00\x57\x02\x14\x00\x3e\x01\x15\x00\x16\x00\x17\x00\x19\x00\xbb\x01\xb5\x00\x1a\x00\x11\x00\x97\x00\x12\x00\x18\x00\x23\x00\x13\x00\x03\x01\xb3\x00\x98\x00\x99\x00\x19\x00\x24\x00\xf3\x01\x1a\x00\x14\x00\xf4\x01\x15\x00\x16\x00\x17\x00\xb4\x00\x40\x02\x9c\x00\x5d\x01\x11\x00\x25\x00\x12\x00\x18\x00\x14\x00\x13\x00\x99\x01\x16\x00\x17\x00\x5e\x00\x19\x00\x6c\x01\x68\x00\x1a\x00\x11\x00\x5f\x00\x12\x00\xb3\x00\x14\x00\x13\x00\x1a\x00\x16\x00\x17\x00\x19\x00\x8b\x01\x11\x00\x7f\x01\x12\x00\x6a\x02\xb4\x00\x13\x00\x9e\x01\x8c\x01\x8d\x01\x8e\x01\x8f\x01\x90\x01\x19\x00\x23\x00\x19\x00\x14\x00\xbc\x00\x15\x00\x16\x00\x17\x00\x24\x00\x11\x00\xa8\x01\x12\x00\x27\x01\x0b\x01\x13\x00\x18\x00\x19\x00\x8c\x01\x8d\x01\x8e\x01\x8f\x01\x90\x01\x19\x00\xd7\x00\x19\x00\x1a\x00\x14\x00\xaf\x00\x15\x00\x16\x00\x17\x00\x29\x01\x11\x00\x2a\x01\x12\x00\x3c\x01\x3d\x01\x13\x00\x18\x00\x22\x00\x14\x00\x2a\x02\x15\x00\x16\x00\x17\x00\x19\x00\xbb\x01\x51\x01\x1a\x00\xd8\x01\x37\x02\x14\x00\x18\x00\x15\x00\x16\x00\x17\x00\x91\x01\x1b\x02\xef\x00\x19\x00\xd6\x01\x1b\x02\x1a\x00\x18\x00\x11\x00\x2a\x02\x12\x00\xaf\x00\x95\x00\x13\x00\x19\x00\x23\x00\x14\x00\x1a\x00\x15\x00\x16\x00\x17\x00\xfe\x01\x24\x00\x22\x00\x19\x00\x3e\x01\x13\x00\xdc\x01\x18\x00\x08\x02\x9c\x00\xd7\x00\xe7\x01\xa3\x01\x19\x01\x19\x00\x9d\x00\x0e\x02\x1a\x00\x14\x00\x6d\x00\x15\x00\x16\x00\x17\x00\x6e\x00\xfe\x01\xb2\x01\xc2\x00\xa5\x00\x26\x01\x13\x00\x18\x00\xa6\x00\x6f\x00\x46\x02\x38\x02\xe7\x01\xbe\x01\x19\x00\xa7\x00\xa8\x00\x1a\x00\x39\x02\x94\x01\xbc\x00\x8c\x01\x8d\x01\x8e\x01\x8f\x01\x90\x01\x62\x01\x14\x00\x23\x00\x15\x00\x16\x00\x17\x00\x19\x00\xfe\x01\x6b\x01\x24\x00\xa4\x00\x65\x01\x13\x00\x18\x00\x14\x00\x1a\x01\x15\x00\x16\x00\x17\x00\x69\x01\x19\x00\xe7\x01\x1b\x01\x1a\x00\x9c\x00\x9c\x00\xff\x01\x15\x00\x16\x00\x17\x00\xaa\x00\x27\x02\x50\x02\x19\x00\x28\x01\x6d\x01\x00\x02\xe9\x01\x14\x00\xd7\x00\x15\x00\x16\x00\x17\x00\x19\x00\x19\x00\x35\x02\x1a\x00\x1a\x00\x9e\x01\x9c\x00\xff\x01\x15\x00\x16\x00\x17\x00\x12\x01\xe8\x01\xb6\x01\x19\x00\xc9\x00\xca\x00\x00\x02\xe9\x01\x14\x01\xbf\x01\xf9\x00\xa5\x00\x95\x00\x96\x00\x19\x00\xa6\x00\x14\x00\x1a\x00\x15\x00\x16\x00\x17\x00\xce\x01\xa7\x00\xa8\x00\xcf\x01\xaf\x00\xcb\x00\xb4\x01\xff\x01\x06\x01\x9c\x00\x35\x01\x15\x00\x16\x00\x17\x00\x19\x00\x13\x00\x22\x00\x00\x02\x61\x01\x1b\x00\x1c\x00\xe9\x01\x1d\x00\xb5\x01\xf6\x01\x6d\x00\x08\x02\xf7\x01\x19\x00\x4a\x01\xd7\x00\x1a\x00\x1a\x00\x1b\x00\x1c\x00\xd7\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x80\x01\x9d\x00\x9e\x00\x81\x01\x12\x01\x21\x00\x9f\x00\xa0\x00\x23\x00\x97\x00\x22\x00\x1e\x00\x1f\x00\x20\x00\x54\x01\x24\x00\x98\x00\x99\x00\x39\x01\x21\x00\x83\x01\x6d\x00\x71\x01\x84\x01\x22\x00\x4a\x01\x6d\x00\x49\x01\xf8\x00\xf9\x00\x4a\x01\x8a\x00\x8b\x00\x14\x00\xfa\x00\xf9\x00\x16\x00\x17\x00\x6d\x00\xb6\x00\xb7\x00\xb8\x00\x23\x00\x55\x01\x4b\x01\x4c\x01\x4d\x01\x4e\x01\x4f\x01\x24\x00\xa4\x01\x19\x01\x19\x00\x37\x01\x8c\x00\x50\x01\x23\x00\x5f\x01\x13\x00\x97\x00\x39\x01\x56\x01\x25\x00\x24\x00\x97\x00\x13\x00\x98\x00\x99\x00\xb9\x00\x51\x01\xda\x01\x98\x00\x99\x00\xdb\x01\x24\x01\x97\x01\x25\x00\x5d\x00\x28\x01\x58\x01\x4b\x01\x4c\x01\x4d\x01\x4e\x01\x4f\x01\x4b\x01\x4c\x01\x4d\x01\x4e\x01\x4f\x01\x9d\x01\x50\x01\x61\x00\x9e\x01\x62\x00\xba\x00\x50\x01\x4b\x01\x4c\x01\x4d\x01\x4e\x01\x4f\x01\x1a\x01\xc7\x00\xc8\x00\x51\x01\xc9\x00\xca\x00\x50\x01\x1b\x01\x51\x01\x9c\x00\x9f\x01\x0b\x01\xc2\x00\xa0\x01\x14\x00\xaa\x00\xc7\x01\x16\x00\x17\x00\xc8\x01\x51\x01\x14\x00\x63\x00\xa5\x00\x16\x00\x17\x00\xcb\x00\xa6\x00\x26\x01\x27\x00\x70\x00\x1a\x00\x8e\x00\x19\x00\xa7\x00\xa8\x00\x28\x00\x6b\x00\x29\x00\x2a\x00\x19\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x3b\x00\x3c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x41\x00\x42\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x4c\x00\x4d\x00\x4e\x00\x4f\x00\x6b\x02\x50\x00\x51\x00\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\x7f\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\xf5\x00\x81\x00\x6d\x00\xf6\x00\x14\x02\x73\x01\x74\x01\x19\x00\x5d\x00\x0f\x01\x10\x01\x5f\x01\xe9\x00\xc0\x00\x9c\x00\xe9\x01\x56\x02\x44\x01\x45\x01\x46\x01\xaa\x00\xaf\x01\xc1\x00\xc2\x00\xb0\x01\xc3\x00\xbd\x01\x75\x01\x08\x01\xbe\x01\x82\x00\x09\x01\xa7\x01\x19\x00\x23\x00\x76\x01\x1a\x00\x0c\x00\x0d\x00\x77\x01\x0d\x00\x24\x00\x03\x02\x78\x01\x79\x01\x7a\x01\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\xb1\x01\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x83\x00\x47\x01\x84\x00\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\xb2\x01\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x2c\x02\x2d\x02\x2e\x02\x2f\x02\x30\x02\x31\x02\x32\x02\x33\x02\x34\x02\x70\x02\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\x85\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x61\x02\x3f\x01\x40\x01\x62\x02\x66\x01\x67\x01\x68\x01\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\xa1\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x1f\x02\x20\x02\x21\x02\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\xa2\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x1d\x02\x1e\x02\x1f\x02\x20\x02\x21\x02\x52\x01\x68\x00\x22\x02\x23\x02\xa3\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x76\x00\x77\x00\x78\x00\x79\x00\x7a\x00\x7b\x00\x7c\x00\x1d\x02\x1e\x02\x1f\x02\x20\x02\x21\x02\xaa\x00\xd6\x01\x22\x02\x23\x02\xbd\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x27\x00\x2e\x02\x2f\x02\x30\x02\xc5\x00\x65\x02\xc6\x00\x28\x00\xcf\x00\x29\x00\x2a\x00\xd7\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x3b\x00\x3c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x41\x00\x42\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x4c\x00\x4d\x00\x4e\x00\x4f\x00\x04\x00\x50\x00\x51\x00\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\x6e\x02\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\xcd\x01\x8e\x01\x8f\x01\x90\x01\xb2\x00\x27\x00\x66\x02\x19\x00\x5d\x00\x45\x02\x11\x02\x5f\x01\x28\x00\x1f\x02\x29\x00\x2a\x00\x2e\x02\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x3b\x00\x3c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x41\x00\x42\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x4c\x00\x4d\x00\x4e\x00\x4f\x00\x6c\x02\x50\x00\x51\x00\xdb\x00\xdc\x00\xdd\x00\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\x44\x02\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x53\x01\x68\x00\x27\x00\xb2\x00\x19\x00\x5d\x00\x53\xff\x13\x02\x5f\x01\x28\x00\x49\x02\x29\x00\x2a\x00\xde\x01\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x3b\x00\x3c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x41\x00\x42\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x4c\x00\x4d\x00\x4e\x00\x4f\x00\x25\x02\x50\x00\x51\x00\x67\x00\x68\x00\x2e\x02\x31\x01\x1f\x02\x88\x01\x32\x01\x0c\x00\x0d\x00\x86\x00\x87\x00\x31\x01\x33\x01\xbf\x01\x32\x01\x0c\x00\x0d\x00\xe9\x00\xf7\x00\xf8\x00\x33\x01\x27\x00\x19\x00\x19\x00\x5d\x00\x18\x02\x0a\x02\x5f\x01\x28\x00\x88\x01\x29\x00\x2a\x00\x89\x01\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x3b\x00\x3c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x41\x00\x42\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x4c\x00\x4d\x00\x4e\x00\x4f\x00\x25\x02\x50\x00\x51\x00\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\x28\x01\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\xfc\x00\xd2\x00\x18\x01\x19\x01\x8e\x01\x27\x00\xcd\x00\x19\x00\x5d\x00\x68\x02\x10\x02\x5f\x01\x28\x00\x9c\x01\x29\x00\x2a\x00\x1f\x01\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x3b\x00\x3c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x41\x00\x42\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x4c\x00\x4d\x00\x4e\x00\x4f\x00\x1a\x01\x50\x00\x51\x00\x3c\x02\xe0\x01\x76\x01\x3d\x02\x1b\x01\xe1\x01\x0c\x00\x0d\x00\x53\xff\xe2\x01\x62\x02\x79\x01\xe3\x01\xe4\x01\x2c\x02\x2d\x02\x2e\x02\x2f\x02\x30\x02\xe5\x01\xc9\x01\x27\x00\xcc\x01\x19\x00\x5d\x00\xd4\x01\x65\x01\x5f\x01\x28\x00\xd8\x01\x29\x00\x2a\x00\xa6\x01\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x3b\x00\x3c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x41\x00\x42\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x4c\x00\x4d\x00\x4e\x00\x4f\x00\xcf\x01\x50\x00\x51\x00\x59\x00\x5a\x00\x5b\x00\x5c\x00\xde\x01\xdf\x01\xa2\x01\x59\x00\x5a\x00\x5b\x00\x5c\x00\xde\x01\x1e\x00\x1f\x00\xab\x00\x28\x01\xac\x00\x44\x01\x6e\x01\x6f\x01\x6d\x00\x6d\x00\x19\x00\x19\x00\x5d\x00\x22\x00\x8e\x01\x5f\x01\x44\x01\x45\x01\x46\x01\xec\x01\xf2\x01\xea\x01\x71\x01\xf5\x01\x19\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x06\x00\x23\x00\x23\x00\xe0\x01\x03\x02\x0c\x02\x23\x00\xe1\x01\x24\x00\x24\x00\x0d\x02\xe2\x01\x47\x01\x24\x00\xe3\x01\xe4\x01\xe9\x00\x06\x00\xa5\x00\x19\x00\x19\x00\xe5\x01\xa6\x00\x47\x01\x5d\x00\xd0\x01\x06\x00\x27\x00\xe9\x00\xa7\x00\xa8\x00\x5d\x00\x58\x01\x06\x00\x28\x00\x06\x00\x29\x00\x2a\x00\x6d\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x3b\x00\x3c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x41\x00\x42\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\x4c\x00\x4d\x00\x4e\x00\x4f\x00\x41\x02\x50\x00\x51\x00\x82\x01\x88\x01\x59\x00\x5a\x00\x5b\x00\x5c\x00\x88\x01\x31\x01\x19\x00\x96\x01\x32\x01\x0c\x00\x0d\x00\x19\x00\xaf\x00\x28\x01\x33\x01\x19\x00\x6d\x00\x6c\x02\x9c\x01\xa2\x01\xa3\x01\x19\x00\xcd\x00\xa6\x01\x22\x00\x90\x00\x91\x01\x91\x00\x92\x00\x93\x00\x19\x00\xab\x01\xc5\x00\xb2\x00\xaf\x00\x19\x00\xd2\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x4a\x00\x4b\x00\xc1\x01\x6d\x00\x22\x00\xdb\x00\x23\x00\xd3\x00\x07\x00\x42\x02\x08\x00\xd2\x00\x04\x01\x24\x00\xc3\x01\x05\x01\x98\x01\x06\x01\x0a\x00\xaf\x00\xb2\x00\xc4\x01\x0c\x00\x0d\x00\x12\x01\x14\x01\x19\x00\x0e\x00\x0f\x00\xc0\x01\x07\x00\x22\x00\x08\x00\x5d\x00\x17\x01\x23\x00\xc3\x01\xcd\x00\x28\x01\x2c\x01\x0a\x00\x19\x00\x24\x00\xc4\x01\x0c\x00\x0d\x00\x19\x00\x2e\x01\x2f\x01\x0e\x00\x0f\x00\x1d\x02\x1e\x02\x1f\x02\x20\x02\x21\x02\xc2\x01\x07\x00\x4a\x02\x08\x00\x76\x01\x04\x01\x30\x01\xc3\x01\x0c\x00\x0d\x00\x2f\x01\x0a\x00\x01\x02\x79\x01\xc4\x01\x0c\x00\x0d\x00\x4b\x02\x8a\x00\x4c\x02\x0e\x00\x0f\x00\x28\x00\x3b\x01\x29\x00\xd2\x01\xd3\x01\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x3c\x01\x36\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x3b\x00\x3c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x4d\x02\x42\x01\xe0\x01\x19\x00\x44\x01\x4e\x02\xe1\x01\x06\x00\x61\x00\xe9\x00\xe2\x01\x06\x00\x58\x01\xe3\x01\xe4\x01\x06\x00\x61\x00\xe0\x01\x65\x00\xe0\x01\xe5\x01\xe1\x01\xb2\x00\xe1\x01\x50\x02\xe2\x01\x51\x02\xe2\x01\xe3\x01\xe4\x01\xe3\x01\xe4\x01\x6d\x00\xff\xff\x06\x00\xe5\x01\xe9\x00\xe5\x01\x06\x00\x52\x02\x6d\x00\x19\x00\x06\x00\x19\x00\x72\x00\x9a\x01\x19\x00\x19\x00\x53\x02\xe0\x01\x81\x00\x90\x00\x9b\x00\xe1\x01\xe0\x01\xae\x00\xbf\x00\xe2\x01\xe1\x01\x19\x00\xe3\x01\xe4\x01\xe2\x01\x54\x02\x23\x00\xe3\x01\xe4\x01\xe5\x01\x27\x02\xc0\x00\xb2\x00\x24\x00\xe5\x01\xe0\x01\x19\x00\xe0\x01\x1a\x00\xe1\x01\xcd\x00\xe1\x01\xcd\x00\xe2\x01\xff\xff\xe2\x01\xe3\x01\xe4\x01\xe3\x01\xe4\x01\xe0\x01\x28\x02\xce\x00\xe5\x01\xe1\x01\xe5\x01\x29\x02\xd3\x00\xe2\x01\xe0\x01\x06\x00\xe3\x01\xe4\x01\xe1\x01\x00\x00\x00\x00\x00\x00\xe2\x01\xe5\x01\x00\x00\xe3\x01\xe4\x01\x00\x00\x00\x00\xe0\x01\x6d\x00\xa0\x01\xe5\x01\xe1\x01\xe0\x01\x00\x00\x00\x00\xe2\x01\xe1\x01\x00\x00\xe3\x01\xe4\x01\xe2\x01\x28\x01\x6d\x00\xe3\x01\xe4\x01\xe5\x01\x00\x00\x00\x00\x00\x00\x00\x00\xe5\x01\x1f\x01\x00\x00\xe0\x01\x00\x00\x2c\x01\x00\x00\xe1\x01\xe0\x01\x00\x00\x23\x00\xe2\x01\xe1\x01\x00\x00\xe3\x01\xe4\x01\xe2\x01\x24\x00\x00\x00\xe3\x01\xe4\x01\xe5\x01\x20\x01\x07\x00\x23\x00\x08\x00\xe5\x01\x00\x00\x00\x00\x09\x00\x00\x00\x24\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x72\x01\x73\x01\x74\x01\x0e\x00\x0f\x00\x20\x01\x07\x00\x00\x00\x08\x00\x16\x02\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x75\x01\x00\x00\x0e\x00\x0f\x00\x15\x02\x74\x01\x00\x00\x75\x01\x76\x01\x00\x00\x00\x00\x00\x00\x77\x01\x0d\x00\x00\x00\x76\x01\x78\x01\x79\x01\x7a\x01\x0c\x00\x0d\x00\xec\x01\x00\x00\x78\x01\x79\x01\x7a\x01\x75\x01\x31\x01\x00\x00\x00\x00\x32\x01\x0c\x00\x0d\x00\x00\x00\x76\x01\x00\x00\x33\x01\x00\x00\x77\x01\x0d\x00\xb7\x01\xb8\x01\x78\x01\x79\x01\x7a\x01\x00\x00\xb9\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x3d\x02\x00\x00\x00\x00\x0e\x00\x0f\x00\xb9\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xd4\x01\xac\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xad\x01\xab\x01\xac\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xad\x01\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\x00\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\xfd\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\xff\xff\x09\x00\x40\x02\xff\x00\x00\x01\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xfd\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\xfe\x00\xff\x00\x00\x01\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xfd\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\xca\x01\x00\x01\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xd3\x00\x07\x00\xd4\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x47\x02\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x3a\x02\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x3e\x02\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xc9\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xd9\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xa7\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xb3\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xbb\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xc0\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xc5\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xe9\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xea\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xeb\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xec\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xed\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xef\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xf0\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xf1\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xf2\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xf3\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xfc\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x09\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x0d\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x0e\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x17\x01\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xbc\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xce\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xd5\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\xd6\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x66\x02\x00\x00\x0b\x00\x0c\x00\x0d\x00\x00\x00\x00\x00\xf9\x01\x0e\x00\x0f\x00\xfa\x01\x0c\x00\x0d\x00\x67\x02\x00\x00\x00\x00\xfb\x01\xfc\x01\x00\x00\x00\x00\xf9\x01\x57\x02\x00\x00\xfa\x01\x0c\x00\x0d\x00\x00\x00\x00\x00\xf9\x01\xfb\x01\xfc\x01\xfa\x01\x0c\x00\x0d\x00\x58\x02\x00\x00\x00\x00\xfb\x01\xfc\x01\x00\x00\x00\x00\xf9\x01\x59\x02\x00\x00\xfa\x01\x0c\x00\x0d\x00\x00\x00\x00\x00\xf9\x01\xfb\x01\xfc\x01\xfa\x01\x0c\x00\x0d\x00\x5b\x02\x00\x00\x00\x00\xfb\x01\xfc\x01\x00\x00\x00\x00\xf9\x01\x5c\x02\x00\x00\xfa\x01\x0c\x00\x0d\x00\x00\x00\x00\x00\xf9\x01\xfb\x01\xfc\x01\xfa\x01\x0c\x00\x0d\x00\x5d\x02\x00\x00\x00\x00\xfb\x01\xfc\x01\x00\x00\x00\x00\xf9\x01\x5e\x02\x00\x00\xfa\x01\x0c\x00\x0d\x00\x00\x00\x00\x00\xf9\x01\xfb\x01\xfc\x01\xfa\x01\x0c\x00\x0d\x00\x5f\x02\x00\x00\x00\x00\xfb\x01\xfc\x01\x00\x00\x00\x00\xf9\x01\x18\x02\x00\x00\xfa\x01\x0c\x00\x0d\x00\x00\x00\x00\x00\xf9\x01\xfb\x01\xfc\x01\xfa\x01\x0c\x00\x0d\x00\x19\x02\x00\x00\x00\x00\xfb\x01\xfc\x01\x00\x00\x00\x00\xf9\x01\x1a\x02\x00\x00\xfa\x01\x0c\x00\x0d\x00\x00\x00\x00\x00\xf9\x01\xfb\x01\xfc\x01\xfa\x01\x0c\x00\x0d\x00\xf8\x01\x00\x00\x00\x00\xfb\x01\xfc\x01\x00\x00\x00\x00\xf9\x01\x00\x00\x00\x00\xfa\x01\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\xfb\x01\xfc\x01\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\x00\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x2c\x02\x2d\x02\x2e\x02\x2f\x02\x30\x02\x31\x02\x32\x02\x33\x02\x34\x02\x00\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\x00\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x2c\x02\x2d\x02\x2e\x02\x2f\x02\x30\x02\x00\x00\x00\x00\x33\x02\x34\x02\x00\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x1d\x02\x1e\x02\x1f\x02\x20\x02\x21\x02\x00\x00\x00\x00\x22\x02\x23\x02\x00\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\x00\x00\x00\x00\xe0\x00\xe1\x00\x00\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x1d\x02\x1e\x02\x1f\x02\x20\x02\x21\x02\x00\x00\x00\x00\x00\x00\x23\x02\x00\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x2c\x02\x2d\x02\x2e\x02\x2f\x02\x30\x02\x00\x00\x00\x00\x00\x00\x34\x02\x00\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\x00\x00\x00\x00\x00\x00\xe1\x00\x00\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x1d\x02\x1e\x02\x1f\x02\x20\x02\x21\x02\x2c\x02\x2d\x02\x2e\x02\x2f\x02\x30\x02\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x2c\x02\x2d\x02\x2e\x02\x2f\x02\x30\x02\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\x1d\x02\x1e\x02\x1f\x02\x20\x02\x21\x02\x8c\x01\x8d\x01\x8e\x01\x8f\x01\x90\x01\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xe2\x00\xe3\x00\xe4\x00\xe5\x00\xe6\x00\xe7\x00\xed\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x31\x01\xee\x01\x00\x00\x32\x01\x0c\x00\x0d\x00\x00\x00\x31\x01\xef\x01\x33\x01\x32\x01\x0c\x00\x0d\x00\x00\x00\x31\x01\xf0\x01\x33\x01\x32\x01\x0c\x00\x0d\x00\x00\x00\x31\x01\x88\x01\x33\x01\x32\x01\x0c\x00\x0d\x00\x00\x00\x31\x01\x92\x01\x33\x01\x32\x01\x0c\x00\x0d\x00\x00\x00\x31\x01\x30\x01\x33\x01\x32\x01\x0c\x00\x0d\x00\x00\x00\x31\x01\x35\x01\x33\x01\x32\x01\x0c\x00\x0d\x00\x00\x00\x31\x01\x37\x01\x33\x01\x32\x01\x0c\x00\x0d\x00\x00\x00\x31\x01\x00\x00\x33\x01\x32\x01\x0c\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x33\x01\x76\x00\x77\x00\x78\x00\x79\x00\x7a\x00\x7b\x00\x7c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x7d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyReduceArr = Happy_Data_Array.array (3, 350) [
	(3 , happyReduce_3),
	(4 , happyReduce_4),
	(5 , happyReduce_5),
	(6 , happyReduce_6),
	(7 , happyReduce_7),
	(8 , happyReduce_8),
	(9 , happyReduce_9),
	(10 , happyReduce_10),
	(11 , happyReduce_11),
	(12 , happyReduce_12),
	(13 , happyReduce_13),
	(14 , happyReduce_14),
	(15 , happyReduce_15),
	(16 , happyReduce_16),
	(17 , happyReduce_17),
	(18 , happyReduce_18),
	(19 , happyReduce_19),
	(20 , happyReduce_20),
	(21 , happyReduce_21),
	(22 , happyReduce_22),
	(23 , happyReduce_23),
	(24 , happyReduce_24),
	(25 , happyReduce_25),
	(26 , happyReduce_26),
	(27 , happyReduce_27),
	(28 , happyReduce_28),
	(29 , happyReduce_29),
	(30 , happyReduce_30),
	(31 , happyReduce_31),
	(32 , happyReduce_32),
	(33 , happyReduce_33),
	(34 , happyReduce_34),
	(35 , happyReduce_35),
	(36 , happyReduce_36),
	(37 , happyReduce_37),
	(38 , happyReduce_38),
	(39 , happyReduce_39),
	(40 , happyReduce_40),
	(41 , happyReduce_41),
	(42 , happyReduce_42),
	(43 , happyReduce_43),
	(44 , happyReduce_44),
	(45 , happyReduce_45),
	(46 , happyReduce_46),
	(47 , happyReduce_47),
	(48 , happyReduce_48),
	(49 , happyReduce_49),
	(50 , happyReduce_50),
	(51 , happyReduce_51),
	(52 , happyReduce_52),
	(53 , happyReduce_53),
	(54 , happyReduce_54),
	(55 , happyReduce_55),
	(56 , happyReduce_56),
	(57 , happyReduce_57),
	(58 , happyReduce_58),
	(59 , happyReduce_59),
	(60 , happyReduce_60),
	(61 , happyReduce_61),
	(62 , happyReduce_62),
	(63 , happyReduce_63),
	(64 , happyReduce_64),
	(65 , happyReduce_65),
	(66 , happyReduce_66),
	(67 , happyReduce_67),
	(68 , happyReduce_68),
	(69 , happyReduce_69),
	(70 , happyReduce_70),
	(71 , happyReduce_71),
	(72 , happyReduce_72),
	(73 , happyReduce_73),
	(74 , happyReduce_74),
	(75 , happyReduce_75),
	(76 , happyReduce_76),
	(77 , happyReduce_77),
	(78 , happyReduce_78),
	(79 , happyReduce_79),
	(80 , happyReduce_80),
	(81 , happyReduce_81),
	(82 , happyReduce_82),
	(83 , happyReduce_83),
	(84 , happyReduce_84),
	(85 , happyReduce_85),
	(86 , happyReduce_86),
	(87 , happyReduce_87),
	(88 , happyReduce_88),
	(89 , happyReduce_89),
	(90 , happyReduce_90),
	(91 , happyReduce_91),
	(92 , happyReduce_92),
	(93 , happyReduce_93),
	(94 , happyReduce_94),
	(95 , happyReduce_95),
	(96 , happyReduce_96),
	(97 , happyReduce_97),
	(98 , happyReduce_98),
	(99 , happyReduce_99),
	(100 , happyReduce_100),
	(101 , happyReduce_101),
	(102 , happyReduce_102),
	(103 , happyReduce_103),
	(104 , happyReduce_104),
	(105 , happyReduce_105),
	(106 , happyReduce_106),
	(107 , happyReduce_107),
	(108 , happyReduce_108),
	(109 , happyReduce_109),
	(110 , happyReduce_110),
	(111 , happyReduce_111),
	(112 , happyReduce_112),
	(113 , happyReduce_113),
	(114 , happyReduce_114),
	(115 , happyReduce_115),
	(116 , happyReduce_116),
	(117 , happyReduce_117),
	(118 , happyReduce_118),
	(119 , happyReduce_119),
	(120 , happyReduce_120),
	(121 , happyReduce_121),
	(122 , happyReduce_122),
	(123 , happyReduce_123),
	(124 , happyReduce_124),
	(125 , happyReduce_125),
	(126 , happyReduce_126),
	(127 , happyReduce_127),
	(128 , happyReduce_128),
	(129 , happyReduce_129),
	(130 , happyReduce_130),
	(131 , happyReduce_131),
	(132 , happyReduce_132),
	(133 , happyReduce_133),
	(134 , happyReduce_134),
	(135 , happyReduce_135),
	(136 , happyReduce_136),
	(137 , happyReduce_137),
	(138 , happyReduce_138),
	(139 , happyReduce_139),
	(140 , happyReduce_140),
	(141 , happyReduce_141),
	(142 , happyReduce_142),
	(143 , happyReduce_143),
	(144 , happyReduce_144),
	(145 , happyReduce_145),
	(146 , happyReduce_146),
	(147 , happyReduce_147),
	(148 , happyReduce_148),
	(149 , happyReduce_149),
	(150 , happyReduce_150),
	(151 , happyReduce_151),
	(152 , happyReduce_152),
	(153 , happyReduce_153),
	(154 , happyReduce_154),
	(155 , happyReduce_155),
	(156 , happyReduce_156),
	(157 , happyReduce_157),
	(158 , happyReduce_158),
	(159 , happyReduce_159),
	(160 , happyReduce_160),
	(161 , happyReduce_161),
	(162 , happyReduce_162),
	(163 , happyReduce_163),
	(164 , happyReduce_164),
	(165 , happyReduce_165),
	(166 , happyReduce_166),
	(167 , happyReduce_167),
	(168 , happyReduce_168),
	(169 , happyReduce_169),
	(170 , happyReduce_170),
	(171 , happyReduce_171),
	(172 , happyReduce_172),
	(173 , happyReduce_173),
	(174 , happyReduce_174),
	(175 , happyReduce_175),
	(176 , happyReduce_176),
	(177 , happyReduce_177),
	(178 , happyReduce_178),
	(179 , happyReduce_179),
	(180 , happyReduce_180),
	(181 , happyReduce_181),
	(182 , happyReduce_182),
	(183 , happyReduce_183),
	(184 , happyReduce_184),
	(185 , happyReduce_185),
	(186 , happyReduce_186),
	(187 , happyReduce_187),
	(188 , happyReduce_188),
	(189 , happyReduce_189),
	(190 , happyReduce_190),
	(191 , happyReduce_191),
	(192 , happyReduce_192),
	(193 , happyReduce_193),
	(194 , happyReduce_194),
	(195 , happyReduce_195),
	(196 , happyReduce_196),
	(197 , happyReduce_197),
	(198 , happyReduce_198),
	(199 , happyReduce_199),
	(200 , happyReduce_200),
	(201 , happyReduce_201),
	(202 , happyReduce_202),
	(203 , happyReduce_203),
	(204 , happyReduce_204),
	(205 , happyReduce_205),
	(206 , happyReduce_206),
	(207 , happyReduce_207),
	(208 , happyReduce_208),
	(209 , happyReduce_209),
	(210 , happyReduce_210),
	(211 , happyReduce_211),
	(212 , happyReduce_212),
	(213 , happyReduce_213),
	(214 , happyReduce_214),
	(215 , happyReduce_215),
	(216 , happyReduce_216),
	(217 , happyReduce_217),
	(218 , happyReduce_218),
	(219 , happyReduce_219),
	(220 , happyReduce_220),
	(221 , happyReduce_221),
	(222 , happyReduce_222),
	(223 , happyReduce_223),
	(224 , happyReduce_224),
	(225 , happyReduce_225),
	(226 , happyReduce_226),
	(227 , happyReduce_227),
	(228 , happyReduce_228),
	(229 , happyReduce_229),
	(230 , happyReduce_230),
	(231 , happyReduce_231),
	(232 , happyReduce_232),
	(233 , happyReduce_233),
	(234 , happyReduce_234),
	(235 , happyReduce_235),
	(236 , happyReduce_236),
	(237 , happyReduce_237),
	(238 , happyReduce_238),
	(239 , happyReduce_239),
	(240 , happyReduce_240),
	(241 , happyReduce_241),
	(242 , happyReduce_242),
	(243 , happyReduce_243),
	(244 , happyReduce_244),
	(245 , happyReduce_245),
	(246 , happyReduce_246),
	(247 , happyReduce_247),
	(248 , happyReduce_248),
	(249 , happyReduce_249),
	(250 , happyReduce_250),
	(251 , happyReduce_251),
	(252 , happyReduce_252),
	(253 , happyReduce_253),
	(254 , happyReduce_254),
	(255 , happyReduce_255),
	(256 , happyReduce_256),
	(257 , happyReduce_257),
	(258 , happyReduce_258),
	(259 , happyReduce_259),
	(260 , happyReduce_260),
	(261 , happyReduce_261),
	(262 , happyReduce_262),
	(263 , happyReduce_263),
	(264 , happyReduce_264),
	(265 , happyReduce_265),
	(266 , happyReduce_266),
	(267 , happyReduce_267),
	(268 , happyReduce_268),
	(269 , happyReduce_269),
	(270 , happyReduce_270),
	(271 , happyReduce_271),
	(272 , happyReduce_272),
	(273 , happyReduce_273),
	(274 , happyReduce_274),
	(275 , happyReduce_275),
	(276 , happyReduce_276),
	(277 , happyReduce_277),
	(278 , happyReduce_278),
	(279 , happyReduce_279),
	(280 , happyReduce_280),
	(281 , happyReduce_281),
	(282 , happyReduce_282),
	(283 , happyReduce_283),
	(284 , happyReduce_284),
	(285 , happyReduce_285),
	(286 , happyReduce_286),
	(287 , happyReduce_287),
	(288 , happyReduce_288),
	(289 , happyReduce_289),
	(290 , happyReduce_290),
	(291 , happyReduce_291),
	(292 , happyReduce_292),
	(293 , happyReduce_293),
	(294 , happyReduce_294),
	(295 , happyReduce_295),
	(296 , happyReduce_296),
	(297 , happyReduce_297),
	(298 , happyReduce_298),
	(299 , happyReduce_299),
	(300 , happyReduce_300),
	(301 , happyReduce_301),
	(302 , happyReduce_302),
	(303 , happyReduce_303),
	(304 , happyReduce_304),
	(305 , happyReduce_305),
	(306 , happyReduce_306),
	(307 , happyReduce_307),
	(308 , happyReduce_308),
	(309 , happyReduce_309),
	(310 , happyReduce_310),
	(311 , happyReduce_311),
	(312 , happyReduce_312),
	(313 , happyReduce_313),
	(314 , happyReduce_314),
	(315 , happyReduce_315),
	(316 , happyReduce_316),
	(317 , happyReduce_317),
	(318 , happyReduce_318),
	(319 , happyReduce_319),
	(320 , happyReduce_320),
	(321 , happyReduce_321),
	(322 , happyReduce_322),
	(323 , happyReduce_323),
	(324 , happyReduce_324),
	(325 , happyReduce_325),
	(326 , happyReduce_326),
	(327 , happyReduce_327),
	(328 , happyReduce_328),
	(329 , happyReduce_329),
	(330 , happyReduce_330),
	(331 , happyReduce_331),
	(332 , happyReduce_332),
	(333 , happyReduce_333),
	(334 , happyReduce_334),
	(335 , happyReduce_335),
	(336 , happyReduce_336),
	(337 , happyReduce_337),
	(338 , happyReduce_338),
	(339 , happyReduce_339),
	(340 , happyReduce_340),
	(341 , happyReduce_341),
	(342 , happyReduce_342),
	(343 , happyReduce_343),
	(344 , happyReduce_344),
	(345 , happyReduce_345),
	(346 , happyReduce_346),
	(347 , happyReduce_347),
	(348 , happyReduce_348),
	(349 , happyReduce_349),
	(350 , happyReduce_350)
	]

happy_n_terms = 90 :: Int
happy_n_nonterms = 102 :: Int

happyReduce_3 = happySpecReduce_2  0# happyReduction_3
happyReduction_3 happy_x_2
	happy_x_1
	 =  case happyOut7 happy_x_2 of { happy_var_2 -> 
	happyIn6
		 (happy_var_2
	)}

happyReduce_4 = happySpecReduce_1  0# happyReduction_4
happyReduction_4 happy_x_1
	 =  case happyOut7 happy_x_1 of { happy_var_1 -> 
	happyIn6
		 (happy_var_1
	)}

happyReduce_5 = happySpecReduce_1  1# happyReduction_5
happyReduction_5 happy_x_1
	 =  case happyOut8 happy_x_1 of { happy_var_1 -> 
	happyIn7
		 (ProgramFile (MetaInfo { miVersion = Fortran77 }) (reverse happy_var_1) [ ]
	)}

happyReduce_6 = happySpecReduce_2  1# happyReduction_6
happyReduction_6 happy_x_2
	happy_x_1
	 =  case happyOut8 happy_x_1 of { happy_var_1 -> 
	case happyOut14 happy_x_2 of { happy_var_2 -> 
	happyIn7
		 (ProgramFile (MetaInfo { miVersion = Fortran77 }) (reverse happy_var_1) (reverse happy_var_2)
	)}}

happyReduce_7 = happySpecReduce_3  2# happyReduction_7
happyReduction_7 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut8 happy_x_1 of { happy_var_1 -> 
	case happyOut9 happy_x_2 of { happy_var_2 -> 
	happyIn8
		 (([ ], happy_var_2) : happy_var_1
	)}}

happyReduce_8 = happyReduce 4# 2# happyReduction_8
happyReduction_8 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut8 happy_x_1 of { happy_var_1 -> 
	case happyOut14 happy_x_2 of { happy_var_2 -> 
	case happyOut9 happy_x_3 of { happy_var_3 -> 
	happyIn8
		 ((reverse happy_var_2, happy_var_3) : happy_var_1
	) `HappyStk` happyRest}}}

happyReduce_9 = happySpecReduce_2  2# happyReduction_9
happyReduction_9 happy_x_2
	happy_x_1
	 =  case happyOut9 happy_x_1 of { happy_var_1 -> 
	happyIn8
		 ([ ([ ], happy_var_1) ]
	)}

happyReduce_10 = happySpecReduce_3  2# happyReduction_10
happyReduction_10 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut14 happy_x_1 of { happy_var_1 -> 
	case happyOut9 happy_x_2 of { happy_var_2 -> 
	happyIn8
		 ([ (reverse happy_var_1, happy_var_2) ]
	)}}

happyReduce_11 = happyReduce 5# 3# happyReduction_11
happyReduction_11 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut11 happy_x_2 of { happy_var_2 -> 
	case happyOut12 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn9
		 (PUMain () (getTransSpan happy_var_1 happy_var_5) (Just happy_var_2) (reverse happy_var_4) Nothing
	) `HappyStk` happyRest}}}}

happyReduce_12 = happyReduce 7# 3# happyReduction_12
happyReduction_12 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut102 happy_x_1 of { happy_var_1 -> 
	case happyOut11 happy_x_3 of { happy_var_3 -> 
	case happyOut10 happy_x_4 of { happy_var_4 -> 
	case happyOut12 happy_x_6 of { happy_var_6 -> 
	case happyOutTok happy_x_7 of { happy_var_7 -> 
	happyIn9
		 (PUFunction () (getTransSpan happy_var_1 happy_var_7) (Just happy_var_1) False happy_var_3 happy_var_4 Nothing (reverse happy_var_6) Nothing
	) `HappyStk` happyRest}}}}}

happyReduce_13 = happyReduce 6# 3# happyReduction_13
happyReduction_13 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut11 happy_x_2 of { happy_var_2 -> 
	case happyOut10 happy_x_3 of { happy_var_3 -> 
	case happyOut12 happy_x_5 of { happy_var_5 -> 
	case happyOutTok happy_x_6 of { happy_var_6 -> 
	happyIn9
		 (PUFunction () (getTransSpan happy_var_1 happy_var_6) Nothing False happy_var_2 happy_var_3 Nothing (reverse happy_var_5) Nothing
	) `HappyStk` happyRest}}}}}

happyReduce_14 = happyReduce 6# 3# happyReduction_14
happyReduction_14 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut11 happy_x_2 of { happy_var_2 -> 
	case happyOut10 happy_x_3 of { happy_var_3 -> 
	case happyOut12 happy_x_5 of { happy_var_5 -> 
	case happyOutTok happy_x_6 of { happy_var_6 -> 
	happyIn9
		 (PUSubroutine () (getTransSpan happy_var_1 happy_var_6) False happy_var_2 happy_var_3 (reverse happy_var_5) Nothing
	) `HappyStk` happyRest}}}}}

happyReduce_15 = happyReduce 4# 3# happyReduction_15
happyReduction_15 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut12 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_4 of { happy_var_4 -> 
	happyIn9
		 (PUBlockData () (getTransSpan happy_var_1 happy_var_4) Nothing (reverse happy_var_3)
	) `HappyStk` happyRest}}}

happyReduce_16 = happyReduce 5# 3# happyReduction_16
happyReduction_16 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut11 happy_x_2 of { happy_var_2 -> 
	case happyOut12 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn9
		 (PUBlockData () (getTransSpan happy_var_1 happy_var_5) (Just happy_var_2) (reverse happy_var_4)
	) `HappyStk` happyRest}}}}

happyReduce_17 = happySpecReduce_3  4# happyReduction_17
happyReduction_17 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut87 happy_x_2 of { happy_var_2 -> 
	happyIn10
		 (happy_var_2
	)}

happyReduce_18 = happySpecReduce_0  4# happyReduction_18
happyReduction_18  =  happyIn10
		 (Nothing
	)

happyReduce_19 = happySpecReduce_1  5# happyReduction_19
happyReduction_19 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn11
		 (let (TId _ name) = happy_var_1 in name
	)}

happyReduce_20 = happySpecReduce_2  6# happyReduction_20
happyReduction_20 happy_x_2
	happy_x_1
	 =  case happyOut12 happy_x_1 of { happy_var_1 -> 
	case happyOut13 happy_x_2 of { happy_var_2 -> 
	happyIn12
		 (happy_var_2 : happy_var_1
	)}}

happyReduce_21 = happySpecReduce_1  6# happyReduction_21
happyReduction_21 happy_x_1
	 =  case happyOut13 happy_x_1 of { happy_var_1 -> 
	happyIn12
		 ([ happy_var_1 ]
	)}

happyReduce_22 = happySpecReduce_3  7# happyReduction_22
happyReduction_22 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut100 happy_x_1 of { happy_var_1 -> 
	case happyOut18 happy_x_2 of { happy_var_2 -> 
	happyIn13
		 (BlStatement () (getTransSpan happy_var_1 happy_var_2) (Just happy_var_1) happy_var_2
	)}}

happyReduce_23 = happySpecReduce_2  7# happyReduction_23
happyReduction_23 happy_x_2
	happy_x_1
	 =  case happyOut18 happy_x_1 of { happy_var_1 -> 
	happyIn13
		 (BlStatement () (getSpan happy_var_1) Nothing happy_var_1
	)}

happyReduce_24 = happySpecReduce_1  7# happyReduction_24
happyReduction_24 happy_x_1
	 =  case happyOut15 happy_x_1 of { happy_var_1 -> 
	happyIn13
		 (happy_var_1
	)}

happyReduce_25 = happySpecReduce_2  8# happyReduction_25
happyReduction_25 happy_x_2
	happy_x_1
	 =  case happyOut14 happy_x_1 of { happy_var_1 -> 
	case happyOut15 happy_x_2 of { happy_var_2 -> 
	happyIn14
		 (happy_var_2 : happy_var_1
	)}}

happyReduce_26 = happySpecReduce_1  8# happyReduction_26
happyReduction_26 happy_x_1
	 =  case happyOut15 happy_x_1 of { happy_var_1 -> 
	happyIn14
		 ([ happy_var_1 ]
	)}

happyReduce_27 = happySpecReduce_2  9# happyReduction_27
happyReduction_27 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn15
		 (let (TComment s c) = happy_var_1 in BlComment () s c
	)}

happyReduce_28 = happySpecReduce_1  10# happyReduction_28
happyReduction_28 happy_x_1
	 =  case happyOut17 happy_x_1 of { happy_var_1 -> 
	happyIn16
		 (Just happy_var_1
	)}

happyReduce_29 = happySpecReduce_0  10# happyReduction_29
happyReduction_29  =  happyIn16
		 (Nothing
	)

happyReduce_30 = happySpecReduce_2  11# happyReduction_30
happyReduction_30 happy_x_2
	happy_x_1
	 =  case happyOut17 happy_x_1 of { happy_var_1 -> 
	happyIn17
		 (happy_var_1
	)}

happyReduce_31 = happySpecReduce_1  11# happyReduction_31
happyReduction_31 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn17
		 (happy_var_1
	)}

happyReduce_32 = happySpecReduce_1  12# happyReduction_32
happyReduction_32 happy_x_1
	 =  case happyOut19 happy_x_1 of { happy_var_1 -> 
	happyIn18
		 (happy_var_1
	)}

happyReduce_33 = happySpecReduce_1  12# happyReduction_33
happyReduction_33 happy_x_1
	 =  case happyOut20 happy_x_1 of { happy_var_1 -> 
	happyIn18
		 (happy_var_1
	)}

happyReduce_34 = happySpecReduce_1  12# happyReduction_34
happyReduction_34 happy_x_1
	 =  case happyOut22 happy_x_1 of { happy_var_1 -> 
	happyIn18
		 (happy_var_1
	)}

happyReduce_35 = happySpecReduce_1  12# happyReduction_35
happyReduction_35 happy_x_1
	 =  case happyOut39 happy_x_1 of { happy_var_1 -> 
	happyIn18
		 (happy_var_1
	)}

happyReduce_36 = happyReduce 5# 13# happyReduction_36
happyReduction_36 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	case happyOut22 happy_x_5 of { happy_var_5 -> 
	happyIn19
		 (StIfLogical () (getTransSpan happy_var_1 happy_var_5) happy_var_3 happy_var_5
	) `HappyStk` happyRest}}}

happyReduce_37 = happySpecReduce_3  14# happyReduction_37
happyReduction_37 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut101 happy_x_2 of { happy_var_2 -> 
	case happyOut21 happy_x_3 of { happy_var_3 -> 
	happyIn20
		 (StDo () (getTransSpan happy_var_1 happy_var_3) Nothing (Just happy_var_2) (Just happy_var_3)
	)}}}

happyReduce_38 = happyReduce 4# 14# happyReduction_38
happyReduction_38 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut101 happy_x_2 of { happy_var_2 -> 
	case happyOut21 happy_x_4 of { happy_var_4 -> 
	happyIn20
		 (StDo () (getTransSpan happy_var_1 happy_var_4) Nothing (Just happy_var_2) (Just happy_var_4)
	) `HappyStk` happyRest}}}

happyReduce_39 = happySpecReduce_2  14# happyReduction_39
happyReduction_39 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut21 happy_x_2 of { happy_var_2 -> 
	happyIn20
		 (StDo () (getTransSpan happy_var_1 happy_var_2) Nothing Nothing (Just happy_var_2)
	)}}

happyReduce_40 = happyReduce 5# 15# happyReduction_40
happyReduction_40 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut38 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	case happyOut75 happy_x_5 of { happy_var_5 -> 
	happyIn21
		 (DoSpecification () (getTransSpan happy_var_1 happy_var_5) happy_var_1 happy_var_3 (Just happy_var_5)
	) `HappyStk` happyRest}}}

happyReduce_41 = happySpecReduce_3  15# happyReduction_41
happyReduction_41 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut38 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn21
		 (DoSpecification () (getTransSpan happy_var_1 happy_var_3) happy_var_1 happy_var_3 Nothing
	)}}

happyReduce_42 = happySpecReduce_1  16# happyReduction_42
happyReduction_42 happy_x_1
	 =  case happyOut38 happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (happy_var_1
	)}

happyReduce_43 = happyReduce 4# 16# happyReduction_43
happyReduction_43 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut101 happy_x_2 of { happy_var_2 -> 
	case happyOut89 happy_x_4 of { happy_var_4 -> 
	happyIn22
		 (StLabelAssign () (getTransSpan happy_var_1 happy_var_4) happy_var_2 happy_var_4
	) `HappyStk` happyRest}}}

happyReduce_44 = happySpecReduce_1  16# happyReduction_44
happyReduction_44 happy_x_1
	 =  case happyOut37 happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (happy_var_1
	)}

happyReduce_45 = happyReduce 9# 16# happyReduction_45
happyReduction_45 (happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	case happyOut101 happy_x_5 of { happy_var_5 -> 
	case happyOut101 happy_x_7 of { happy_var_7 -> 
	case happyOut101 happy_x_9 of { happy_var_9 -> 
	happyIn22
		 (StIfArithmetic () (getTransSpan happy_var_1 happy_var_9) happy_var_3 happy_var_5 happy_var_7 happy_var_9
	) `HappyStk` happyRest}}}}}

happyReduce_46 = happyReduce 5# 16# happyReduction_46
happyReduction_46 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn22
		 (StIfThen () (getTransSpan happy_var_1 happy_var_5) Nothing happy_var_3
	) `HappyStk` happyRest}}}

happyReduce_47 = happyReduce 5# 16# happyReduction_47
happyReduction_47 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn22
		 (StElsif () (getTransSpan happy_var_1 happy_var_5) Nothing happy_var_3
	) `HappyStk` happyRest}}}

happyReduce_48 = happySpecReduce_1  16# happyReduction_48
happyReduction_48 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (StElse () (getSpan happy_var_1) Nothing
	)}

happyReduce_49 = happySpecReduce_1  16# happyReduction_49
happyReduction_49 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (StEndif () (getSpan happy_var_1) Nothing
	)}

happyReduce_50 = happyReduce 4# 16# happyReduction_50
happyReduction_50 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_4 of { happy_var_4 -> 
	happyIn22
		 (StDoWhile () (getTransSpan happy_var_1 happy_var_4) Nothing Nothing happy_var_3
	) `HappyStk` happyRest}}}

happyReduce_51 = happySpecReduce_1  16# happyReduction_51
happyReduction_51 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (StEnddo () (getSpan happy_var_1) Nothing
	)}

happyReduce_52 = happySpecReduce_3  16# happyReduction_52
happyReduction_52 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut89 happy_x_2 of { happy_var_2 -> 
	case happyOut72 happy_x_3 of { happy_var_3 -> 
	happyIn22
		 (StCall () (getTransSpan happy_var_1 happy_var_3) happy_var_2 $ Just happy_var_3
	)}}}

happyReduce_53 = happySpecReduce_2  16# happyReduction_53
happyReduction_53 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut89 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StCall () (getTransSpan happy_var_1 happy_var_2) happy_var_2 Nothing
	)}}

happyReduce_54 = happySpecReduce_1  16# happyReduction_54
happyReduction_54 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (StReturn () (getSpan happy_var_1) Nothing
	)}

happyReduce_55 = happySpecReduce_2  16# happyReduction_55
happyReduction_55 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StReturn () (getTransSpan happy_var_1 happy_var_2) $ Just happy_var_2
	)}}

happyReduce_56 = happySpecReduce_2  16# happyReduction_56
happyReduction_56 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut33 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StSave () (getSpan (happy_var_1, happy_var_2)) happy_var_2
	)}}

happyReduce_57 = happySpecReduce_1  16# happyReduction_57
happyReduction_57 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (StContinue () $ getSpan happy_var_1
	)}

happyReduce_58 = happySpecReduce_2  16# happyReduction_58
happyReduction_58 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut36 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StStop () (getTransSpan happy_var_1 happy_var_2) $ Just happy_var_2
	)}}

happyReduce_59 = happySpecReduce_1  16# happyReduction_59
happyReduction_59 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (StStop () (getSpan happy_var_1) Nothing
	)}

happyReduce_60 = happySpecReduce_1  16# happyReduction_60
happyReduction_60 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (StExit () (getSpan happy_var_1) Nothing
	)}

happyReduce_61 = happySpecReduce_2  16# happyReduction_61
happyReduction_61 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut36 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StPause () (getTransSpan happy_var_1 happy_var_2) $ Just happy_var_2
	)}}

happyReduce_62 = happySpecReduce_1  16# happyReduction_62
happyReduction_62 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (StPause () (getSpan happy_var_1) Nothing
	)}

happyReduce_63 = happySpecReduce_3  16# happyReduction_63
happyReduction_63 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	case happyOut30 happy_x_3 of { happy_var_3 -> 
	happyIn22
		 (StRead () (getTransSpan happy_var_1 happy_var_3) happy_var_2 (Just $ aReverse happy_var_3)
	)}}}

happyReduce_64 = happySpecReduce_2  16# happyReduction_64
happyReduction_64 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StRead () (getTransSpan happy_var_1 happy_var_2) happy_var_2 Nothing
	)}}

happyReduce_65 = happyReduce 4# 16# happyReduction_65
happyReduction_65 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut23 happy_x_2 of { happy_var_2 -> 
	case happyOut30 happy_x_4 of { happy_var_4 -> 
	happyIn22
		 (StRead2 () (getTransSpan happy_var_1 happy_var_4) happy_var_2 (Just $ aReverse happy_var_4)
	) `HappyStk` happyRest}}}

happyReduce_66 = happySpecReduce_2  16# happyReduction_66
happyReduction_66 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut23 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StRead2 () (getTransSpan happy_var_1 happy_var_2) happy_var_2 Nothing
	)}}

happyReduce_67 = happySpecReduce_3  16# happyReduction_67
happyReduction_67 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	case happyOut32 happy_x_3 of { happy_var_3 -> 
	happyIn22
		 (StWrite () (getTransSpan happy_var_1 happy_var_3) happy_var_2 (Just $ aReverse happy_var_3)
	)}}}

happyReduce_68 = happySpecReduce_2  16# happyReduction_68
happyReduction_68 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StWrite () (getTransSpan happy_var_1 happy_var_2) happy_var_2 Nothing
	)}}

happyReduce_69 = happyReduce 4# 16# happyReduction_69
happyReduction_69 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut23 happy_x_2 of { happy_var_2 -> 
	case happyOut32 happy_x_4 of { happy_var_4 -> 
	happyIn22
		 (StPrint () (getTransSpan happy_var_1 happy_var_4) happy_var_2 (Just $ aReverse happy_var_4)
	) `HappyStk` happyRest}}}

happyReduce_70 = happySpecReduce_2  16# happyReduction_70
happyReduction_70 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut23 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StPrint () (getTransSpan happy_var_1 happy_var_2) happy_var_2 Nothing
	)}}

happyReduce_71 = happySpecReduce_2  16# happyReduction_71
happyReduction_71 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StOpen () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_72 = happySpecReduce_2  16# happyReduction_72
happyReduction_72 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StClose () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_73 = happySpecReduce_2  16# happyReduction_73
happyReduction_73 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StInquire () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_74 = happySpecReduce_2  16# happyReduction_74
happyReduction_74 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StRewind () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_75 = happySpecReduce_2  16# happyReduction_75
happyReduction_75 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut24 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StRewind2 () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_76 = happySpecReduce_2  16# happyReduction_76
happyReduction_76 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StEndfile () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_77 = happySpecReduce_2  16# happyReduction_77
happyReduction_77 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut24 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StEndfile2 () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_78 = happySpecReduce_2  16# happyReduction_78
happyReduction_78 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StBackspace () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_79 = happySpecReduce_2  16# happyReduction_79
happyReduction_79 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut24 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StBackspace2 () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_80 = happyReduce 4# 17# happyReduction_80
happyReduction_80 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut23 happy_x_1 of { happy_var_1 -> 
	case happyOut23 happy_x_4 of { happy_var_4 -> 
	happyIn23
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_4) Concatenation happy_var_1 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_81 = happySpecReduce_1  17# happyReduction_81
happyReduction_81 happy_x_1
	 =  case happyOut90 happy_x_1 of { happy_var_1 -> 
	happyIn23
		 (happy_var_1
	)}

happyReduce_82 = happySpecReduce_1  17# happyReduction_82
happyReduction_82 happy_x_1
	 =  case happyOut78 happy_x_1 of { happy_var_1 -> 
	happyIn23
		 (happy_var_1
	)}

happyReduce_83 = happySpecReduce_1  17# happyReduction_83
happyReduction_83 happy_x_1
	 =  case happyOut82 happy_x_1 of { happy_var_1 -> 
	happyIn23
		 (happy_var_1
	)}

happyReduce_84 = happySpecReduce_1  17# happyReduction_84
happyReduction_84 happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	happyIn23
		 (happy_var_1
	)}

happyReduce_85 = happySpecReduce_1  17# happyReduction_85
happyReduction_85 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn23
		 (ExpValue () (getSpan happy_var_1) ValStar
	)}

happyReduce_86 = happySpecReduce_1  18# happyReduction_86
happyReduction_86 happy_x_1
	 =  case happyOut90 happy_x_1 of { happy_var_1 -> 
	happyIn24
		 (happy_var_1
	)}

happyReduce_87 = happySpecReduce_1  18# happyReduction_87
happyReduction_87 happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	happyIn24
		 (happy_var_1
	)}

happyReduce_88 = happySpecReduce_1  18# happyReduction_88
happyReduction_88 happy_x_1
	 =  case happyOut82 happy_x_1 of { happy_var_1 -> 
	happyIn24
		 (happy_var_1
	)}

happyReduce_89 = happySpecReduce_1  18# happyReduction_89
happyReduction_89 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn24
		 (ExpValue () (getSpan happy_var_1) ValStar
	)}

happyReduce_90 = happyReduce 7# 19# happyReduction_90
happyReduction_90 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut24 happy_x_2 of { happy_var_2 -> 
	case happyOut23 happy_x_4 of { happy_var_4 -> 
	case happyOut26 happy_x_6 of { happy_var_6 -> 
	case happyOutTok happy_x_7 of { happy_var_7 -> 
	happyIn25
		 (let { cp1 = ControlPair () (getSpan happy_var_2) Nothing happy_var_2;
        cp2 = ControlPair () (getSpan happy_var_4) Nothing happy_var_4 }
  in setSpan (getTransSpan happy_var_1 happy_var_7) $ cp1 `aCons` cp2 `aCons` aReverse happy_var_6
	) `HappyStk` happyRest}}}}}

happyReduce_91 = happyReduce 5# 19# happyReduction_91
happyReduction_91 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut24 happy_x_2 of { happy_var_2 -> 
	case happyOut23 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn25
		 (let { cp1 = ControlPair () (getSpan happy_var_2) Nothing happy_var_2;
        cp2 = ControlPair () (getSpan happy_var_4) Nothing happy_var_4 }
        in AList () (getTransSpan happy_var_1 happy_var_5) [ cp1,  cp2 ]
	) `HappyStk` happyRest}}}}

happyReduce_92 = happyReduce 5# 19# happyReduction_92
happyReduction_92 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut24 happy_x_2 of { happy_var_2 -> 
	case happyOut26 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn25
		 (let cp1 = ControlPair () (getSpan happy_var_2) Nothing happy_var_2
        in setSpan (getTransSpan happy_var_1 happy_var_5) $ cp1 `aCons` aReverse happy_var_4
	) `HappyStk` happyRest}}}}

happyReduce_93 = happySpecReduce_3  19# happyReduction_93
happyReduction_93 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut24 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn25
		 (let cp1 = ControlPair () (getSpan happy_var_2) Nothing happy_var_2
  in AList () (getTransSpan happy_var_1 happy_var_3) [ cp1 ]
	)}}}

happyReduce_94 = happySpecReduce_3  19# happyReduction_94
happyReduction_94 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut26 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn25
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ aReverse happy_var_2
	)}}}

happyReduce_95 = happySpecReduce_3  20# happyReduction_95
happyReduction_95 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut26 happy_x_1 of { happy_var_1 -> 
	case happyOut27 happy_x_3 of { happy_var_3 -> 
	happyIn26
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_96 = happySpecReduce_1  20# happyReduction_96
happyReduction_96 happy_x_1
	 =  case happyOut27 happy_x_1 of { happy_var_1 -> 
	happyIn26
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_97 = happySpecReduce_3  21# happyReduction_97
happyReduction_97 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut28 happy_x_3 of { happy_var_3 -> 
	happyIn27
		 (let (TId s id) = happy_var_1 in ControlPair () (getTransSpan s happy_var_3) (Just id) happy_var_3
	)}}

happyReduce_98 = happySpecReduce_1  22# happyReduction_98
happyReduction_98 happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	happyIn28
		 (happy_var_1
	)}

happyReduce_99 = happySpecReduce_1  22# happyReduction_99
happyReduction_99 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn28
		 (ExpValue () (getSpan happy_var_1) ValStar
	)}

happyReduce_100 = happySpecReduce_3  23# happyReduction_100
happyReduction_100 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_3 of { happy_var_3 -> 
	happyIn29
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Addition happy_var_1 happy_var_3
	)}}

happyReduce_101 = happySpecReduce_3  23# happyReduction_101
happyReduction_101 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_3 of { happy_var_3 -> 
	happyIn29
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Subtraction happy_var_1 happy_var_3
	)}}

happyReduce_102 = happySpecReduce_3  23# happyReduction_102
happyReduction_102 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_3 of { happy_var_3 -> 
	happyIn29
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Multiplication happy_var_1 happy_var_3
	)}}

happyReduce_103 = happySpecReduce_3  23# happyReduction_103
happyReduction_103 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_3 of { happy_var_3 -> 
	happyIn29
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Division happy_var_1 happy_var_3
	)}}

happyReduce_104 = happySpecReduce_3  23# happyReduction_104
happyReduction_104 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_3 of { happy_var_3 -> 
	happyIn29
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Exponentiation happy_var_1 happy_var_3
	)}}

happyReduce_105 = happyReduce 4# 23# happyReduction_105
happyReduction_105 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_4 of { happy_var_4 -> 
	happyIn29
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_4) Concatenation happy_var_1 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_106 = happySpecReduce_2  23# happyReduction_106
happyReduction_106 happy_x_2
	happy_x_1
	 =  case happyOut86 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_2 of { happy_var_2 -> 
	happyIn29
		 (ExpUnary () (getTransSpan (fst happy_var_1) happy_var_2) (snd happy_var_1) happy_var_2
	)}}

happyReduce_107 = happySpecReduce_3  23# happyReduction_107
happyReduction_107 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_3 of { happy_var_3 -> 
	happyIn29
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Or happy_var_1 happy_var_3
	)}}

happyReduce_108 = happySpecReduce_3  23# happyReduction_108
happyReduction_108 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_3 of { happy_var_3 -> 
	happyIn29
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) And happy_var_1 happy_var_3
	)}}

happyReduce_109 = happySpecReduce_2  23# happyReduction_109
happyReduction_109 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_2 of { happy_var_2 -> 
	happyIn29
		 (ExpUnary () (getTransSpan happy_var_1 happy_var_2) Not happy_var_2
	)}}

happyReduce_110 = happySpecReduce_3  23# happyReduction_110
happyReduction_110 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_3 of { happy_var_3 -> 
	happyIn29
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Equivalent happy_var_1 happy_var_3
	)}}

happyReduce_111 = happySpecReduce_3  23# happyReduction_111
happyReduction_111 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_3 of { happy_var_3 -> 
	happyIn29
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) NotEquivalent happy_var_1 happy_var_3
	)}}

happyReduce_112 = happySpecReduce_3  23# happyReduction_112
happyReduction_112 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut81 happy_x_2 of { happy_var_2 -> 
	case happyOut29 happy_x_3 of { happy_var_3 -> 
	happyIn29
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) happy_var_2 happy_var_1 happy_var_3
	)}}}

happyReduce_113 = happySpecReduce_3  23# happyReduction_113
happyReduction_113 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn29
		 (setSpan (getTransSpan happy_var_1 happy_var_3) happy_var_2
	)}}}

happyReduce_114 = happySpecReduce_1  23# happyReduction_114
happyReduction_114 happy_x_1
	 =  case happyOut90 happy_x_1 of { happy_var_1 -> 
	happyIn29
		 (happy_var_1
	)}

happyReduce_115 = happySpecReduce_1  23# happyReduction_115
happyReduction_115 happy_x_1
	 =  case happyOut96 happy_x_1 of { happy_var_1 -> 
	happyIn29
		 (happy_var_1
	)}

happyReduce_116 = happySpecReduce_1  23# happyReduction_116
happyReduction_116 happy_x_1
	 =  case happyOut78 happy_x_1 of { happy_var_1 -> 
	happyIn29
		 (happy_var_1
	)}

happyReduce_117 = happySpecReduce_1  23# happyReduction_117
happyReduction_117 happy_x_1
	 =  case happyOut82 happy_x_1 of { happy_var_1 -> 
	happyIn29
		 (happy_var_1
	)}

happyReduce_118 = happySpecReduce_1  23# happyReduction_118
happyReduction_118 happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	happyIn29
		 (happy_var_1
	)}

happyReduce_119 = happySpecReduce_3  24# happyReduction_119
happyReduction_119 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut30 happy_x_1 of { happy_var_1 -> 
	case happyOut31 happy_x_3 of { happy_var_3 -> 
	happyIn30
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_120 = happySpecReduce_1  24# happyReduction_120
happyReduction_120 happy_x_1
	 =  case happyOut31 happy_x_1 of { happy_var_1 -> 
	happyIn30
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_121 = happySpecReduce_1  25# happyReduction_121
happyReduction_121 happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	happyIn31
		 (happy_var_1
	)}

happyReduce_122 = happySpecReduce_1  25# happyReduction_122
happyReduction_122 happy_x_1
	 =  case happyOut82 happy_x_1 of { happy_var_1 -> 
	happyIn31
		 (happy_var_1
	)}

happyReduce_123 = happyReduce 5# 25# happyReduction_123
happyReduction_123 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut30 happy_x_2 of { happy_var_2 -> 
	case happyOut21 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn31
		 (ExpImpliedDo () (getTransSpan happy_var_1 happy_var_5) (aReverse happy_var_2) happy_var_4
	) `HappyStk` happyRest}}}}

happyReduce_124 = happySpecReduce_3  26# happyReduction_124
happyReduction_124 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut32 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn32
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_125 = happySpecReduce_1  26# happyReduction_125
happyReduction_125 happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	happyIn32
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_126 = happySpecReduce_1  27# happyReduction_126
happyReduction_126 happy_x_1
	 =  case happyOut34 happy_x_1 of { happy_var_1 -> 
	happyIn33
		 (Just $ fromReverseList happy_var_1
	)}

happyReduce_127 = happySpecReduce_0  27# happyReduction_127
happyReduction_127  =  happyIn33
		 (Nothing
	)

happyReduce_128 = happySpecReduce_3  28# happyReduction_128
happyReduction_128 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut34 happy_x_1 of { happy_var_1 -> 
	case happyOut35 happy_x_3 of { happy_var_3 -> 
	happyIn34
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_129 = happySpecReduce_1  28# happyReduction_129
happyReduction_129 happy_x_1
	 =  case happyOut35 happy_x_1 of { happy_var_1 -> 
	happyIn34
		 ([ happy_var_1 ]
	)}

happyReduce_130 = happySpecReduce_1  29# happyReduction_130
happyReduction_130 happy_x_1
	 =  case happyOut62 happy_x_1 of { happy_var_1 -> 
	happyIn35
		 (happy_var_1
	)}

happyReduce_131 = happySpecReduce_1  29# happyReduction_131
happyReduction_131 happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	happyIn35
		 (happy_var_1
	)}

happyReduce_132 = happySpecReduce_1  30# happyReduction_132
happyReduction_132 happy_x_1
	 =  case happyOut78 happy_x_1 of { happy_var_1 -> 
	happyIn36
		 (happy_var_1
	)}

happyReduce_133 = happySpecReduce_1  30# happyReduction_133
happyReduction_133 happy_x_1
	 =  case happyOut90 happy_x_1 of { happy_var_1 -> 
	happyIn36
		 (happy_var_1
	)}

happyReduce_134 = happySpecReduce_2  31# happyReduction_134
happyReduction_134 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut101 happy_x_2 of { happy_var_2 -> 
	happyIn37
		 (StGotoUnconditional () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_135 = happySpecReduce_3  31# happyReduction_135
happyReduction_135 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut89 happy_x_2 of { happy_var_2 -> 
	case happyOut98 happy_x_3 of { happy_var_3 -> 
	happyIn37
		 (StGotoAssigned () (getTransSpan happy_var_1 happy_var_3) happy_var_2 happy_var_3
	)}}}

happyReduce_136 = happyReduce 4# 31# happyReduction_136
happyReduction_136 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut89 happy_x_2 of { happy_var_2 -> 
	case happyOut98 happy_x_4 of { happy_var_4 -> 
	happyIn37
		 (StGotoAssigned () (getTransSpan happy_var_1 happy_var_4) happy_var_2 happy_var_4
	) `HappyStk` happyRest}}}

happyReduce_137 = happySpecReduce_3  31# happyReduction_137
happyReduction_137 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut98 happy_x_2 of { happy_var_2 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn37
		 (StGotoComputed () (getTransSpan happy_var_1 happy_var_3) happy_var_2 happy_var_3
	)}}}

happyReduce_138 = happyReduce 4# 31# happyReduction_138
happyReduction_138 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut98 happy_x_2 of { happy_var_2 -> 
	case happyOut75 happy_x_4 of { happy_var_4 -> 
	happyIn37
		 (StGotoComputed () (getTransSpan happy_var_1 happy_var_4) happy_var_2 happy_var_4
	) `HappyStk` happyRest}}}

happyReduce_139 = happySpecReduce_3  32# happyReduction_139
happyReduction_139 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut50 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn38
		 (StExpressionAssign () (getTransSpan happy_var_1 happy_var_3) happy_var_1 happy_var_3
	)}}

happyReduce_140 = happySpecReduce_2  33# happyReduction_140
happyReduction_140 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut71 happy_x_2 of { happy_var_2 -> 
	happyIn39
		 (StExternal () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)}}

happyReduce_141 = happySpecReduce_2  33# happyReduction_141
happyReduction_141 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut71 happy_x_2 of { happy_var_2 -> 
	happyIn39
		 (StIntrinsic () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)}}

happyReduce_142 = happySpecReduce_2  33# happyReduction_142
happyReduction_142 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut66 happy_x_2 of { happy_var_2 -> 
	happyIn39
		 (StDimension () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)}}

happyReduce_143 = happySpecReduce_2  33# happyReduction_143
happyReduction_143 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut59 happy_x_2 of { happy_var_2 -> 
	happyIn39
		 (StCommon () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)}}

happyReduce_144 = happySpecReduce_2  33# happyReduction_144
happyReduction_144 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut58 happy_x_2 of { happy_var_2 -> 
	happyIn39
		 (StEquivalence () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)}}

happyReduce_145 = happySpecReduce_2  33# happyReduction_145
happyReduction_145 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut54 happy_x_2 of { happy_var_2 -> 
	happyIn39
		 (StData () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)}}

happyReduce_146 = happySpecReduce_3  33# happyReduction_146
happyReduction_146 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut51 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn39
		 (StFormat () (getTransSpan happy_var_1 happy_var_3) (aReverse happy_var_2)
	)}}}

happyReduce_147 = happySpecReduce_1  33# happyReduction_147
happyReduction_147 happy_x_1
	 =  case happyOut45 happy_x_1 of { happy_var_1 -> 
	happyIn39
		 (happy_var_1
	)}

happyReduce_148 = happySpecReduce_2  33# happyReduction_148
happyReduction_148 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	happyIn39
		 (StImplicit () (getTransSpan happy_var_1 happy_var_2) Nothing
	)}}

happyReduce_149 = happySpecReduce_2  33# happyReduction_149
happyReduction_149 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut46 happy_x_2 of { happy_var_2 -> 
	happyIn39
		 (StImplicit () (getTransSpan happy_var_1 happy_var_2) $ Just $ aReverse happy_var_2
	)}}

happyReduce_150 = happyReduce 4# 33# happyReduction_150
happyReduction_150 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut43 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_4 of { happy_var_4 -> 
	happyIn39
		 (StParameter () (getTransSpan happy_var_1 happy_var_4) $ fromReverseList happy_var_3
	) `HappyStk` happyRest}}}

happyReduce_151 = happySpecReduce_2  33# happyReduction_151
happyReduction_151 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut89 happy_x_2 of { happy_var_2 -> 
	happyIn39
		 (StEntry () (getTransSpan happy_var_1 happy_var_2) happy_var_2 Nothing Nothing
	)}}

happyReduce_152 = happySpecReduce_3  33# happyReduction_152
happyReduction_152 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut89 happy_x_2 of { happy_var_2 -> 
	case happyOut40 happy_x_3 of { happy_var_3 -> 
	happyIn39
		 (StEntry () (getTransSpan happy_var_1 happy_var_3) happy_var_2 (Just happy_var_3) Nothing
	)}}}

happyReduce_153 = happySpecReduce_2  33# happyReduction_153
happyReduction_153 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut78 happy_x_2 of { happy_var_2 -> 
	happyIn39
		 (StInclude () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_154 = happySpecReduce_2  34# happyReduction_154
happyReduction_154 happy_x_2
	happy_x_1
	 =  case happyOut41 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	happyIn40
		 (setSpan (getTransSpan happy_var_1 happy_var_2) $ aReverse happy_var_1
	)}}

happyReduce_155 = happySpecReduce_3  35# happyReduction_155
happyReduction_155 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut41 happy_x_1 of { happy_var_1 -> 
	case happyOut42 happy_x_3 of { happy_var_3 -> 
	happyIn41
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_156 = happySpecReduce_2  35# happyReduction_156
happyReduction_156 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut42 happy_x_2 of { happy_var_2 -> 
	happyIn41
		 (AList () (getTransSpan happy_var_1 happy_var_2) [ happy_var_2 ]
	)}}

happyReduce_157 = happySpecReduce_1  35# happyReduction_157
happyReduction_157 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn41
		 (AList () (getSpan happy_var_1) [ ]
	)}

happyReduce_158 = happySpecReduce_1  36# happyReduction_158
happyReduction_158 happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	happyIn42
		 (happy_var_1
	)}

happyReduce_159 = happySpecReduce_1  36# happyReduction_159
happyReduction_159 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn42
		 (ExpValue () (getSpan happy_var_1) ValStar
	)}

happyReduce_160 = happySpecReduce_3  37# happyReduction_160
happyReduction_160 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut43 happy_x_1 of { happy_var_1 -> 
	case happyOut44 happy_x_3 of { happy_var_3 -> 
	happyIn43
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_161 = happySpecReduce_1  37# happyReduction_161
happyReduction_161 happy_x_1
	 =  case happyOut44 happy_x_1 of { happy_var_1 -> 
	happyIn43
		 ([ happy_var_1 ]
	)}

happyReduce_162 = happySpecReduce_3  38# happyReduction_162
happyReduction_162 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	case happyOut79 happy_x_3 of { happy_var_3 -> 
	happyIn44
		 (DeclVariable () (getTransSpan happy_var_1 happy_var_3) happy_var_1 Nothing (Just happy_var_3)
	)}}

happyReduce_163 = happySpecReduce_2  39# happyReduction_163
happyReduction_163 happy_x_2
	happy_x_1
	 =  case happyOut102 happy_x_1 of { happy_var_1 -> 
	case happyOut64 happy_x_2 of { happy_var_2 -> 
	happyIn45
		 (StDeclaration () (getTransSpan happy_var_1 happy_var_2) happy_var_1 Nothing happy_var_2
	)}}

happyReduce_164 = happySpecReduce_3  40# happyReduction_164
happyReduction_164 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut46 happy_x_1 of { happy_var_1 -> 
	case happyOut47 happy_x_3 of { happy_var_3 -> 
	happyIn46
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_165 = happySpecReduce_1  40# happyReduction_165
happyReduction_165 happy_x_1
	 =  case happyOut47 happy_x_1 of { happy_var_1 -> 
	happyIn46
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_166 = happyReduce 4# 41# happyReduction_166
happyReduction_166 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut106 happy_x_1 of { happy_var_1 -> 
	case happyOut48 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_4 of { happy_var_4 -> 
	happyIn47
		 (ImpList () (getTransSpan happy_var_1 happy_var_4) happy_var_1 $ aReverse happy_var_3
	) `HappyStk` happyRest}}}

happyReduce_167 = happySpecReduce_3  42# happyReduction_167
happyReduction_167 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut48 happy_x_1 of { happy_var_1 -> 
	case happyOut49 happy_x_3 of { happy_var_3 -> 
	happyIn48
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_168 = happySpecReduce_1  42# happyReduction_168
happyReduction_168 happy_x_1
	 =  case happyOut49 happy_x_1 of { happy_var_1 -> 
	happyIn48
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_169 = happyMonadReduce 1# 43# happyReduction_169
happyReduction_169 (happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOutTok happy_x_1 of { happy_var_1 -> 
	( do
      let (TId s id) = happy_var_1
      if length id /= 1
      then fail "Implicit argument must be a character."
      else return $ ImpCharacter () s id)}
	) (\r -> happyReturn (happyIn49 r))

happyReduce_170 = happyMonadReduce 3# 43# happyReduction_170
happyReduction_170 (happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	( do
             let (TId _ id1) = happy_var_1
             let (TId _ id2) = happy_var_3
             if length id1 /= 1 || length id2 /= 1
             then fail "Implicit argument must be a character."
             else return $ ImpRange () (getTransSpan happy_var_1 happy_var_3) id1 id2)}}
	) (\r -> happyReturn (happyIn49 r))

happyReduce_171 = happySpecReduce_1  44# happyReduction_171
happyReduction_171 happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	happyIn50
		 (happy_var_1
	)}

happyReduce_172 = happySpecReduce_1  44# happyReduction_172
happyReduction_172 happy_x_1
	 =  case happyOut82 happy_x_1 of { happy_var_1 -> 
	happyIn50
		 (happy_var_1
	)}

happyReduce_173 = happySpecReduce_3  45# happyReduction_173
happyReduction_173 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut51 happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_3 of { happy_var_3 -> 
	happyIn51
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_174 = happySpecReduce_3  45# happyReduction_174
happyReduction_174 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut51 happy_x_1 of { happy_var_1 -> 
	case happyOut52 happy_x_3 of { happy_var_3 -> 
	happyIn51
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_175 = happySpecReduce_2  45# happyReduction_175
happyReduction_175 happy_x_2
	happy_x_1
	 =  case happyOut51 happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_2 of { happy_var_2 -> 
	happyIn51
		 (setSpan (getTransSpan happy_var_1 happy_var_2) $ happy_var_2 `aCons` happy_var_1
	)}}

happyReduce_176 = happySpecReduce_2  45# happyReduction_176
happyReduction_176 happy_x_2
	happy_x_1
	 =  case happyOut51 happy_x_1 of { happy_var_1 -> 
	case happyOut52 happy_x_2 of { happy_var_2 -> 
	happyIn51
		 (setSpan (getTransSpan happy_var_1 happy_var_2) $ happy_var_2 `aCons` happy_var_1
	)}}

happyReduce_177 = happySpecReduce_1  45# happyReduction_177
happyReduction_177 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn51
		 (AList () (getSpan happy_var_1) [ ]
	)}

happyReduce_178 = happySpecReduce_1  46# happyReduction_178
happyReduction_178 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn52
		 (FIDelimiter () (getSpan happy_var_1)
	)}

happyReduce_179 = happySpecReduce_3  47# happyReduction_179
happyReduction_179 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut51 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn53
		 (FIFormatList () (getTransSpan happy_var_1 happy_var_3) (let (TInt _ s) = happy_var_1 in Just s) (aReverse happy_var_2)
	)}}}

happyReduce_180 = happySpecReduce_2  47# happyReduction_180
happyReduction_180 happy_x_2
	happy_x_1
	 =  case happyOut51 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	happyIn53
		 (FIFormatList () (getTransSpan happy_var_1 happy_var_2) Nothing (aReverse happy_var_1)
	)}}

happyReduce_181 = happySpecReduce_1  47# happyReduction_181
happyReduction_181 happy_x_1
	 =  case happyOut97 happy_x_1 of { happy_var_1 -> 
	happyIn53
		 (let (ExpValue _ s val) = happy_var_1 in FIHollerith () s val
	)}

happyReduce_182 = happySpecReduce_1  47# happyReduction_182
happyReduction_182 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn53
		 (let (TFieldDescriptorDEFG s a b c d) = happy_var_1 in FIFieldDescriptorDEFG () s a b c d
	)}

happyReduce_183 = happySpecReduce_1  47# happyReduction_183
happyReduction_183 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn53
		 (let (TFieldDescriptorAIL s a b c) = happy_var_1 in FIFieldDescriptorAIL () s a b c
	)}

happyReduce_184 = happySpecReduce_1  47# happyReduction_184
happyReduction_184 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn53
		 (let (TBlankDescriptor s w) = happy_var_1 in FIBlankDescriptor () s w
	)}

happyReduce_185 = happySpecReduce_1  47# happyReduction_185
happyReduction_185 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn53
		 (let (TScaleFactor s sf) = happy_var_1 in FIScaleFactor () s sf
	)}

happyReduce_186 = happyReduce 6# 48# happyReduction_186
happyReduction_186 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut54 happy_x_1 of { happy_var_1 -> 
	case happyOut63 happy_x_3 of { happy_var_3 -> 
	case happyOut55 happy_x_5 of { happy_var_5 -> 
	case happyOutTok happy_x_6 of { happy_var_6 -> 
	happyIn54
		 (setSpan (getTransSpan happy_var_1 happy_var_6) $ (DataGroup () (getTransSpan happy_var_3 happy_var_6) (aReverse happy_var_3) (aReverse happy_var_5)) `aCons` happy_var_1
	) `HappyStk` happyRest}}}}

happyReduce_187 = happyReduce 4# 48# happyReduction_187
happyReduction_187 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut63 happy_x_1 of { happy_var_1 -> 
	case happyOut55 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_4 of { happy_var_4 -> 
	happyIn54
		 (AList () (getTransSpan happy_var_1 happy_var_4) [ DataGroup () (getTransSpan happy_var_1 happy_var_4) (aReverse happy_var_1) (aReverse happy_var_3) ]
	) `HappyStk` happyRest}}}

happyReduce_188 = happySpecReduce_3  49# happyReduction_188
happyReduction_188 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut55 happy_x_1 of { happy_var_1 -> 
	case happyOut56 happy_x_3 of { happy_var_3 -> 
	happyIn55
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_189 = happySpecReduce_1  49# happyReduction_189
happyReduction_189 happy_x_1
	 =  case happyOut56 happy_x_1 of { happy_var_1 -> 
	happyIn55
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_190 = happySpecReduce_3  50# happyReduction_190
happyReduction_190 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut90 happy_x_1 of { happy_var_1 -> 
	case happyOut57 happy_x_3 of { happy_var_3 -> 
	happyIn56
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Multiplication happy_var_1 happy_var_3
	)}}

happyReduce_191 = happySpecReduce_1  50# happyReduction_191
happyReduction_191 happy_x_1
	 =  case happyOut57 happy_x_1 of { happy_var_1 -> 
	happyIn56
		 (happy_var_1
	)}

happyReduce_192 = happySpecReduce_1  51# happyReduction_192
happyReduction_192 happy_x_1
	 =  case happyOut94 happy_x_1 of { happy_var_1 -> 
	happyIn57
		 (happy_var_1
	)}

happyReduce_193 = happyReduce 5# 51# happyReduction_193
happyReduction_193 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut94 happy_x_2 of { happy_var_2 -> 
	case happyOut94 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn57
		 (ExpValue () (getTransSpan happy_var_1 happy_var_5) (ValComplex happy_var_2 happy_var_4)
	) `HappyStk` happyRest}}}}

happyReduce_194 = happySpecReduce_1  51# happyReduction_194
happyReduction_194 happy_x_1
	 =  case happyOut96 happy_x_1 of { happy_var_1 -> 
	happyIn57
		 (happy_var_1
	)}

happyReduce_195 = happySpecReduce_1  51# happyReduction_195
happyReduction_195 happy_x_1
	 =  case happyOut78 happy_x_1 of { happy_var_1 -> 
	happyIn57
		 (happy_var_1
	)}

happyReduce_196 = happyReduce 5# 52# happyReduction_196
happyReduction_196 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut58 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	case happyOut63 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn58
		 (setSpan (getTransSpan happy_var_1 happy_var_5) $ (setSpan (getTransSpan happy_var_3 happy_var_5) $ aReverse happy_var_4) `aCons` happy_var_1
	) `HappyStk` happyRest}}}}

happyReduce_197 = happySpecReduce_3  52# happyReduction_197
happyReduction_197 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut63 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn58
		 (let s = (getTransSpan happy_var_1 happy_var_3) in AList () s [ setSpan s $ aReverse happy_var_2 ]
	)}}}

happyReduce_198 = happySpecReduce_2  53# happyReduction_198
happyReduction_198 happy_x_2
	happy_x_1
	 =  case happyOut59 happy_x_1 of { happy_var_1 -> 
	case happyOut60 happy_x_2 of { happy_var_2 -> 
	happyIn59
		 (setSpan (getTransSpan happy_var_1 happy_var_2) $ happy_var_2 `aCons` happy_var_1
	)}}

happyReduce_199 = happySpecReduce_1  53# happyReduction_199
happyReduction_199 happy_x_1
	 =  case happyOut61 happy_x_1 of { happy_var_1 -> 
	happyIn59
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_200 = happySpecReduce_2  54# happyReduction_200
happyReduction_200 happy_x_2
	happy_x_1
	 =  case happyOut62 happy_x_1 of { happy_var_1 -> 
	case happyOut63 happy_x_2 of { happy_var_2 -> 
	happyIn60
		 (CommonGroup () (getTransSpan happy_var_1 happy_var_2) (Just happy_var_1) $ aReverse happy_var_2
	)}}

happyReduce_201 = happySpecReduce_3  54# happyReduction_201
happyReduction_201 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut63 happy_x_3 of { happy_var_3 -> 
	happyIn60
		 (CommonGroup () (getTransSpan happy_var_1 happy_var_3) Nothing $ aReverse happy_var_3
	)}}

happyReduce_202 = happySpecReduce_2  55# happyReduction_202
happyReduction_202 happy_x_2
	happy_x_1
	 =  case happyOut62 happy_x_1 of { happy_var_1 -> 
	case happyOut63 happy_x_2 of { happy_var_2 -> 
	happyIn61
		 (CommonGroup () (getTransSpan happy_var_1 happy_var_2) (Just happy_var_1) $ aReverse happy_var_2
	)}}

happyReduce_203 = happySpecReduce_3  55# happyReduction_203
happyReduction_203 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut63 happy_x_3 of { happy_var_3 -> 
	happyIn61
		 (CommonGroup () (getTransSpan happy_var_1 happy_var_3) Nothing $ aReverse happy_var_3
	)}}

happyReduce_204 = happySpecReduce_1  55# happyReduction_204
happyReduction_204 happy_x_1
	 =  case happyOut63 happy_x_1 of { happy_var_1 -> 
	happyIn61
		 (CommonGroup () (getSpan happy_var_1) Nothing $ aReverse happy_var_1
	)}

happyReduce_205 = happySpecReduce_3  56# happyReduction_205
happyReduction_205 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut89 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn62
		 (setSpan (getTransSpan happy_var_1 happy_var_3) happy_var_2
	)}}}

happyReduce_206 = happySpecReduce_3  57# happyReduction_206
happyReduction_206 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut63 happy_x_1 of { happy_var_1 -> 
	case happyOut50 happy_x_3 of { happy_var_3 -> 
	happyIn63
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_207 = happySpecReduce_1  57# happyReduction_207
happyReduction_207 happy_x_1
	 =  case happyOut50 happy_x_1 of { happy_var_1 -> 
	happyIn63
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_208 = happySpecReduce_3  58# happyReduction_208
happyReduction_208 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut64 happy_x_1 of { happy_var_1 -> 
	case happyOut65 happy_x_3 of { happy_var_3 -> 
	happyIn64
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_209 = happySpecReduce_1  58# happyReduction_209
happyReduction_209 happy_x_1
	 =  case happyOut65 happy_x_1 of { happy_var_1 -> 
	happyIn64
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_210 = happySpecReduce_1  59# happyReduction_210
happyReduction_210 happy_x_1
	 =  case happyOut67 happy_x_1 of { happy_var_1 -> 
	happyIn65
		 (happy_var_1
	)}

happyReduce_211 = happySpecReduce_1  59# happyReduction_211
happyReduction_211 happy_x_1
	 =  case happyOut68 happy_x_1 of { happy_var_1 -> 
	happyIn65
		 (happy_var_1
	)}

happyReduce_212 = happySpecReduce_3  60# happyReduction_212
happyReduction_212 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut66 happy_x_1 of { happy_var_1 -> 
	case happyOut67 happy_x_3 of { happy_var_3 -> 
	happyIn66
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_213 = happySpecReduce_1  60# happyReduction_213
happyReduction_213 happy_x_1
	 =  case happyOut67 happy_x_1 of { happy_var_1 -> 
	happyIn66
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_214 = happyReduce 4# 61# happyReduction_214
happyReduction_214 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut89 happy_x_1 of { happy_var_1 -> 
	case happyOut69 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_4 of { happy_var_4 -> 
	happyIn67
		 (DeclArray () (getTransSpan happy_var_1 happy_var_4) happy_var_1 (aReverse happy_var_3) Nothing Nothing
	) `HappyStk` happyRest}}}

happyReduce_215 = happySpecReduce_1  62# happyReduction_215
happyReduction_215 happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	happyIn68
		 (DeclVariable () (getSpan happy_var_1) happy_var_1 Nothing Nothing
	)}

happyReduce_216 = happySpecReduce_3  63# happyReduction_216
happyReduction_216 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut69 happy_x_1 of { happy_var_1 -> 
	case happyOut70 happy_x_3 of { happy_var_3 -> 
	happyIn69
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_217 = happySpecReduce_1  63# happyReduction_217
happyReduction_217 happy_x_1
	 =  case happyOut70 happy_x_1 of { happy_var_1 -> 
	happyIn69
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_218 = happySpecReduce_3  64# happyReduction_218
happyReduction_218 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn70
		 (DimensionDeclarator () (getTransSpan happy_var_1 happy_var_3) (Just happy_var_1) (Just happy_var_3)
	)}}

happyReduce_219 = happySpecReduce_1  64# happyReduction_219
happyReduction_219 happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	happyIn70
		 (DimensionDeclarator () (getSpan happy_var_1) Nothing (Just happy_var_1)
	)}

happyReduce_220 = happySpecReduce_3  64# happyReduction_220
happyReduction_220 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn70
		 (DimensionDeclarator () (getTransSpan happy_var_1 happy_var_3) (Just happy_var_1) (Just $ ExpValue () (getSpan happy_var_3) ValStar)
	)}}

happyReduce_221 = happySpecReduce_1  64# happyReduction_221
happyReduction_221 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn70
		 (DimensionDeclarator () (getSpan happy_var_1) Nothing (Just $ ExpValue () (getSpan happy_var_1) ValStar)
	)}

happyReduce_222 = happySpecReduce_3  65# happyReduction_222
happyReduction_222 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut71 happy_x_1 of { happy_var_1 -> 
	case happyOut89 happy_x_3 of { happy_var_3 -> 
	happyIn71
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_223 = happySpecReduce_1  65# happyReduction_223
happyReduction_223 happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	happyIn71
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_224 = happySpecReduce_2  66# happyReduction_224
happyReduction_224 happy_x_2
	happy_x_1
	 =  case happyOut73 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	happyIn72
		 (setSpan (getTransSpan happy_var_1 happy_var_2) $ aReverse happy_var_1
	)}}

happyReduce_225 = happySpecReduce_3  67# happyReduction_225
happyReduction_225 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut73 happy_x_1 of { happy_var_1 -> 
	case happyOut74 happy_x_3 of { happy_var_3 -> 
	happyIn73
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_226 = happySpecReduce_2  67# happyReduction_226
happyReduction_226 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut74 happy_x_2 of { happy_var_2 -> 
	happyIn73
		 (AList () (getTransSpan happy_var_1 happy_var_2) [ happy_var_2 ]
	)}}

happyReduce_227 = happySpecReduce_1  67# happyReduction_227
happyReduction_227 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn73
		 (AList () (getSpan happy_var_1) [ ]
	)}

happyReduce_228 = happySpecReduce_1  68# happyReduction_228
happyReduction_228 happy_x_1
	 =  case happyOut97 happy_x_1 of { happy_var_1 -> 
	happyIn74
		 (Argument () (getSpan happy_var_1) Nothing happy_var_1
	)}

happyReduce_229 = happySpecReduce_1  68# happyReduction_229
happyReduction_229 happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	happyIn74
		 (Argument () (getSpan happy_var_1) Nothing happy_var_1
	)}

happyReduce_230 = happySpecReduce_3  69# happyReduction_230
happyReduction_230 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn75
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Addition happy_var_1 happy_var_3
	)}}

happyReduce_231 = happySpecReduce_3  69# happyReduction_231
happyReduction_231 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn75
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Subtraction happy_var_1 happy_var_3
	)}}

happyReduce_232 = happySpecReduce_3  69# happyReduction_232
happyReduction_232 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn75
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Multiplication happy_var_1 happy_var_3
	)}}

happyReduce_233 = happySpecReduce_3  69# happyReduction_233
happyReduction_233 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn75
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Division happy_var_1 happy_var_3
	)}}

happyReduce_234 = happySpecReduce_3  69# happyReduction_234
happyReduction_234 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn75
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Exponentiation happy_var_1 happy_var_3
	)}}

happyReduce_235 = happyReduce 4# 69# happyReduction_235
happyReduction_235 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_4 of { happy_var_4 -> 
	happyIn75
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_4) Concatenation happy_var_1 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_236 = happySpecReduce_2  69# happyReduction_236
happyReduction_236 happy_x_2
	happy_x_1
	 =  case happyOut86 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_2 of { happy_var_2 -> 
	happyIn75
		 (ExpUnary () (getTransSpan (fst happy_var_1) happy_var_2) (snd happy_var_1) happy_var_2
	)}}

happyReduce_237 = happySpecReduce_3  69# happyReduction_237
happyReduction_237 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn75
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Or happy_var_1 happy_var_3
	)}}

happyReduce_238 = happySpecReduce_3  69# happyReduction_238
happyReduction_238 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn75
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) And happy_var_1 happy_var_3
	)}}

happyReduce_239 = happySpecReduce_2  69# happyReduction_239
happyReduction_239 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_2 of { happy_var_2 -> 
	happyIn75
		 (ExpUnary () (getTransSpan happy_var_1 happy_var_2) Not happy_var_2
	)}}

happyReduce_240 = happySpecReduce_3  69# happyReduction_240
happyReduction_240 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn75
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Equivalent happy_var_1 happy_var_3
	)}}

happyReduce_241 = happySpecReduce_3  69# happyReduction_241
happyReduction_241 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn75
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) NotEquivalent happy_var_1 happy_var_3
	)}}

happyReduce_242 = happySpecReduce_3  69# happyReduction_242
happyReduction_242 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut81 happy_x_2 of { happy_var_2 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn75
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) happy_var_2 happy_var_1 happy_var_3
	)}}}

happyReduce_243 = happySpecReduce_3  69# happyReduction_243
happyReduction_243 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn75
		 (setSpan (getTransSpan happy_var_1 happy_var_3) happy_var_2
	)}}}

happyReduce_244 = happySpecReduce_1  69# happyReduction_244
happyReduction_244 happy_x_1
	 =  case happyOut95 happy_x_1 of { happy_var_1 -> 
	happyIn75
		 (happy_var_1
	)}

happyReduce_245 = happyReduce 5# 69# happyReduction_245
happyReduction_245 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_2 of { happy_var_2 -> 
	case happyOut75 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn75
		 (ExpValue () (getTransSpan happy_var_1 happy_var_5) (ValComplex happy_var_2 happy_var_4)
	) `HappyStk` happyRest}}}}

happyReduce_246 = happySpecReduce_1  69# happyReduction_246
happyReduction_246 happy_x_1
	 =  case happyOut96 happy_x_1 of { happy_var_1 -> 
	happyIn75
		 (happy_var_1
	)}

happyReduce_247 = happySpecReduce_1  69# happyReduction_247
happyReduction_247 happy_x_1
	 =  case happyOut78 happy_x_1 of { happy_var_1 -> 
	happyIn75
		 (happy_var_1
	)}

happyReduce_248 = happySpecReduce_1  69# happyReduction_248
happyReduction_248 happy_x_1
	 =  case happyOut82 happy_x_1 of { happy_var_1 -> 
	happyIn75
		 (happy_var_1
	)}

happyReduce_249 = happySpecReduce_1  69# happyReduction_249
happyReduction_249 happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	happyIn75
		 (happy_var_1
	)}

happyReduce_250 = happySpecReduce_1  69# happyReduction_250
happyReduction_250 happy_x_1
	 =  case happyOut76 happy_x_1 of { happy_var_1 -> 
	happyIn75
		 (happy_var_1
	)}

happyReduce_251 = happySpecReduce_3  69# happyReduction_251
happyReduction_251 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut77 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn75
		 (let { exps = reverse happy_var_2;
          expList = AList () (getSpan exps) exps }
    in ExpInitialisation () (getTransSpan happy_var_1 happy_var_3) expList
	)}}}

happyReduce_252 = happyReduce 5# 70# happyReduction_252
happyReduction_252 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_2 of { happy_var_2 -> 
	case happyOut21 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn76
		 (let expList = AList () (getSpan happy_var_2) [ happy_var_2 ]
          in ExpImpliedDo () (getTransSpan happy_var_1 happy_var_5) expList happy_var_4
	) `HappyStk` happyRest}}}}

happyReduce_253 = happyReduce 7# 70# happyReduction_253
happyReduction_253 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_2 of { happy_var_2 -> 
	case happyOut75 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	case happyOut21 happy_x_6 of { happy_var_6 -> 
	happyIn76
		 (let expList = AList () (getTransSpan happy_var_2 happy_var_4) [ happy_var_2, happy_var_4 ]
          in ExpImpliedDo () (getTransSpan happy_var_1 happy_var_5) expList happy_var_6
	) `HappyStk` happyRest}}}}}

happyReduce_254 = happyReduce 9# 70# happyReduction_254
happyReduction_254 (happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_2 of { happy_var_2 -> 
	case happyOut75 happy_x_4 of { happy_var_4 -> 
	case happyOut77 happy_x_6 of { happy_var_6 -> 
	case happyOut21 happy_x_8 of { happy_var_8 -> 
	case happyOutTok happy_x_9 of { happy_var_9 -> 
	happyIn76
		 (let { exps =  reverse happy_var_6;
          expList = AList () (getTransSpan happy_var_2 exps) (happy_var_2 : happy_var_4 : reverse happy_var_6) }
    in ExpImpliedDo () (getTransSpan happy_var_1 happy_var_9) expList happy_var_8
	) `HappyStk` happyRest}}}}}}

happyReduce_255 = happySpecReduce_3  71# happyReduction_255
happyReduction_255 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut77 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn77
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_256 = happySpecReduce_1  71# happyReduction_256
happyReduction_256 happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	happyIn77
		 ([ happy_var_1 ]
	)}

happyReduce_257 = happySpecReduce_1  72# happyReduction_257
happyReduction_257 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn78
		 (let (TString s cs) = happy_var_1 in ExpValue () s (ValString cs)
	)}

happyReduce_258 = happySpecReduce_3  73# happyReduction_258
happyReduction_258 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut79 happy_x_1 of { happy_var_1 -> 
	case happyOut79 happy_x_3 of { happy_var_3 -> 
	happyIn79
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Addition happy_var_1 happy_var_3
	)}}

happyReduce_259 = happySpecReduce_3  73# happyReduction_259
happyReduction_259 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut79 happy_x_1 of { happy_var_1 -> 
	case happyOut79 happy_x_3 of { happy_var_3 -> 
	happyIn79
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Subtraction happy_var_1 happy_var_3
	)}}

happyReduce_260 = happySpecReduce_3  73# happyReduction_260
happyReduction_260 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut79 happy_x_1 of { happy_var_1 -> 
	case happyOut79 happy_x_3 of { happy_var_3 -> 
	happyIn79
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Multiplication happy_var_1 happy_var_3
	)}}

happyReduce_261 = happySpecReduce_3  73# happyReduction_261
happyReduction_261 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut79 happy_x_1 of { happy_var_1 -> 
	case happyOut79 happy_x_3 of { happy_var_3 -> 
	happyIn79
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Division happy_var_1 happy_var_3
	)}}

happyReduce_262 = happySpecReduce_3  73# happyReduction_262
happyReduction_262 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut79 happy_x_1 of { happy_var_1 -> 
	case happyOut79 happy_x_3 of { happy_var_3 -> 
	happyIn79
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Exponentiation happy_var_1 happy_var_3
	)}}

happyReduce_263 = happyReduce 4# 73# happyReduction_263
happyReduction_263 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut79 happy_x_1 of { happy_var_1 -> 
	case happyOut79 happy_x_4 of { happy_var_4 -> 
	happyIn79
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_4) Concatenation happy_var_1 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_264 = happySpecReduce_2  73# happyReduction_264
happyReduction_264 happy_x_2
	happy_x_1
	 =  case happyOut86 happy_x_1 of { happy_var_1 -> 
	case happyOut79 happy_x_2 of { happy_var_2 -> 
	happyIn79
		 (ExpUnary () (getTransSpan (fst happy_var_1) happy_var_2) (snd happy_var_1) happy_var_2
	)}}

happyReduce_265 = happySpecReduce_3  73# happyReduction_265
happyReduction_265 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut79 happy_x_1 of { happy_var_1 -> 
	case happyOut79 happy_x_3 of { happy_var_3 -> 
	happyIn79
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Or happy_var_1 happy_var_3
	)}}

happyReduce_266 = happySpecReduce_3  73# happyReduction_266
happyReduction_266 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut79 happy_x_1 of { happy_var_1 -> 
	case happyOut79 happy_x_3 of { happy_var_3 -> 
	happyIn79
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) And happy_var_1 happy_var_3
	)}}

happyReduce_267 = happySpecReduce_2  73# happyReduction_267
happyReduction_267 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut79 happy_x_2 of { happy_var_2 -> 
	happyIn79
		 (ExpUnary () (getTransSpan happy_var_1 happy_var_2) Not happy_var_2
	)}}

happyReduce_268 = happySpecReduce_3  73# happyReduction_268
happyReduction_268 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut79 happy_x_1 of { happy_var_1 -> 
	case happyOut81 happy_x_2 of { happy_var_2 -> 
	case happyOut79 happy_x_3 of { happy_var_3 -> 
	happyIn79
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) happy_var_2 happy_var_1 happy_var_3
	)}}}

happyReduce_269 = happySpecReduce_3  73# happyReduction_269
happyReduction_269 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut79 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn79
		 (setSpan (getTransSpan happy_var_1 happy_var_3) happy_var_2
	)}}}

happyReduce_270 = happySpecReduce_1  73# happyReduction_270
happyReduction_270 happy_x_1
	 =  case happyOut95 happy_x_1 of { happy_var_1 -> 
	happyIn79
		 (happy_var_1
	)}

happyReduce_271 = happyReduce 5# 73# happyReduction_271
happyReduction_271 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut79 happy_x_2 of { happy_var_2 -> 
	case happyOut79 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn79
		 (ExpValue () (getTransSpan happy_var_1 happy_var_5) (ValComplex happy_var_2 happy_var_4)
	) `HappyStk` happyRest}}}}

happyReduce_272 = happySpecReduce_1  73# happyReduction_272
happyReduction_272 happy_x_1
	 =  case happyOut96 happy_x_1 of { happy_var_1 -> 
	happyIn79
		 (happy_var_1
	)}

happyReduce_273 = happySpecReduce_1  73# happyReduction_273
happyReduction_273 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn79
		 (let (TString s cs) = happy_var_1 in ExpValue () s (ValString cs)
	)}

happyReduce_274 = happySpecReduce_1  73# happyReduction_274
happyReduction_274 happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	happyIn79
		 (happy_var_1
	)}

happyReduce_275 = happySpecReduce_3  74# happyReduction_275
happyReduction_275 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut80 happy_x_1 of { happy_var_1 -> 
	case happyOut80 happy_x_3 of { happy_var_3 -> 
	happyIn80
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Addition happy_var_1 happy_var_3
	)}}

happyReduce_276 = happySpecReduce_3  74# happyReduction_276
happyReduction_276 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut80 happy_x_1 of { happy_var_1 -> 
	case happyOut80 happy_x_3 of { happy_var_3 -> 
	happyIn80
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Subtraction happy_var_1 happy_var_3
	)}}

happyReduce_277 = happySpecReduce_3  74# happyReduction_277
happyReduction_277 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut80 happy_x_1 of { happy_var_1 -> 
	case happyOut80 happy_x_3 of { happy_var_3 -> 
	happyIn80
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Multiplication happy_var_1 happy_var_3
	)}}

happyReduce_278 = happySpecReduce_3  74# happyReduction_278
happyReduction_278 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut80 happy_x_1 of { happy_var_1 -> 
	case happyOut80 happy_x_3 of { happy_var_3 -> 
	happyIn80
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Division happy_var_1 happy_var_3
	)}}

happyReduce_279 = happySpecReduce_3  74# happyReduction_279
happyReduction_279 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut80 happy_x_1 of { happy_var_1 -> 
	case happyOut80 happy_x_3 of { happy_var_3 -> 
	happyIn80
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Exponentiation happy_var_1 happy_var_3
	)}}

happyReduce_280 = happySpecReduce_2  74# happyReduction_280
happyReduction_280 happy_x_2
	happy_x_1
	 =  case happyOut86 happy_x_1 of { happy_var_1 -> 
	case happyOut80 happy_x_2 of { happy_var_2 -> 
	happyIn80
		 (ExpUnary () (getTransSpan (fst happy_var_1) happy_var_2) (snd happy_var_1) happy_var_2
	)}}

happyReduce_281 = happySpecReduce_3  74# happyReduction_281
happyReduction_281 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut80 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn80
		 (setSpan (getTransSpan happy_var_1 happy_var_3) happy_var_2
	)}}}

happyReduce_282 = happySpecReduce_1  74# happyReduction_282
happyReduction_282 happy_x_1
	 =  case happyOut95 happy_x_1 of { happy_var_1 -> 
	happyIn80
		 (happy_var_1
	)}

happyReduce_283 = happyReduce 5# 74# happyReduction_283
happyReduction_283 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut80 happy_x_2 of { happy_var_2 -> 
	case happyOut80 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn80
		 (ExpValue () (getTransSpan happy_var_1 happy_var_5) (ValComplex happy_var_2 happy_var_4)
	) `HappyStk` happyRest}}}}

happyReduce_284 = happySpecReduce_1  74# happyReduction_284
happyReduction_284 happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	happyIn80
		 (happy_var_1
	)}

happyReduce_285 = happySpecReduce_1  75# happyReduction_285
happyReduction_285 happy_x_1
	 =  happyIn81
		 (EQ
	)

happyReduce_286 = happySpecReduce_1  75# happyReduction_286
happyReduction_286 happy_x_1
	 =  happyIn81
		 (NE
	)

happyReduce_287 = happySpecReduce_1  75# happyReduction_287
happyReduction_287 happy_x_1
	 =  happyIn81
		 (GT
	)

happyReduce_288 = happySpecReduce_1  75# happyReduction_288
happyReduction_288 happy_x_1
	 =  happyIn81
		 (GTE
	)

happyReduce_289 = happySpecReduce_1  75# happyReduction_289
happyReduction_289 happy_x_1
	 =  happyIn81
		 (LT
	)

happyReduce_290 = happySpecReduce_1  75# happyReduction_290
happyReduction_290 happy_x_1
	 =  happyIn81
		 (LTE
	)

happyReduce_291 = happySpecReduce_3  76# happyReduction_291
happyReduction_291 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn82
		 (ExpFunctionCall () (getTransSpan happy_var_1 happy_var_3) happy_var_1 Nothing
	)}}

happyReduce_292 = happyReduce 4# 76# happyReduction_292
happyReduction_292 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut89 happy_x_1 of { happy_var_1 -> 
	case happyOut83 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_4 of { happy_var_4 -> 
	happyIn82
		 (ExpSubscript () (getTransSpan happy_var_1 happy_var_4) happy_var_1 (fromReverseList happy_var_3)
	) `HappyStk` happyRest}}}

happyReduce_293 = happyReduce 7# 76# happyReduction_293
happyReduction_293 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut89 happy_x_1 of { happy_var_1 -> 
	case happyOut83 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_4 of { happy_var_4 -> 
	case happyOut83 happy_x_6 of { happy_var_6 -> 
	case happyOutTok happy_x_7 of { happy_var_7 -> 
	happyIn82
		 (let innerSub = ExpSubscript () (getTransSpan happy_var_1 happy_var_4) happy_var_1 (fromReverseList happy_var_3)
    in ExpSubscript () (getTransSpan happy_var_1 happy_var_7) innerSub (fromReverseList happy_var_6)
	) `HappyStk` happyRest}}}}}

happyReduce_294 = happySpecReduce_3  77# happyReduction_294
happyReduction_294 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut83 happy_x_1 of { happy_var_1 -> 
	case happyOut84 happy_x_3 of { happy_var_3 -> 
	happyIn83
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_295 = happySpecReduce_1  77# happyReduction_295
happyReduction_295 happy_x_1
	 =  case happyOut84 happy_x_1 of { happy_var_1 -> 
	happyIn83
		 ([ happy_var_1 ]
	)}

happyReduce_296 = happySpecReduce_1  78# happyReduction_296
happyReduction_296 happy_x_1
	 =  case happyOut85 happy_x_1 of { happy_var_1 -> 
	happyIn84
		 (happy_var_1
	)}

happyReduce_297 = happySpecReduce_1  78# happyReduction_297
happyReduction_297 happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	happyIn84
		 (IxSingle () (getSpan happy_var_1) Nothing happy_var_1
	)}

happyReduce_298 = happySpecReduce_1  79# happyReduction_298
happyReduction_298 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn85
		 (IxRange () (getSpan happy_var_1) Nothing Nothing Nothing
	)}

happyReduce_299 = happySpecReduce_2  79# happyReduction_299
happyReduction_299 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_2 of { happy_var_2 -> 
	happyIn85
		 (IxRange () (getTransSpan happy_var_1 happy_var_2) Nothing (Just happy_var_2) Nothing
	)}}

happyReduce_300 = happySpecReduce_2  79# happyReduction_300
happyReduction_300 happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	happyIn85
		 (IxRange () (getTransSpan happy_var_1 happy_var_2) (Just happy_var_1) Nothing Nothing
	)}}

happyReduce_301 = happySpecReduce_3  79# happyReduction_301
happyReduction_301 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut75 happy_x_3 of { happy_var_3 -> 
	happyIn85
		 (IxRange () (getTransSpan happy_var_1 happy_var_3) (Just happy_var_1) (Just happy_var_3) Nothing
	)}}

happyReduce_302 = happySpecReduce_1  80# happyReduction_302
happyReduction_302 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn86
		 ((getSpan happy_var_1, Minus)
	)}

happyReduce_303 = happySpecReduce_1  80# happyReduction_303
happyReduction_303 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn86
		 ((getSpan happy_var_1, Plus)
	)}

happyReduce_304 = happySpecReduce_1  81# happyReduction_304
happyReduction_304 happy_x_1
	 =  case happyOut88 happy_x_1 of { happy_var_1 -> 
	happyIn87
		 (Just $ fromReverseList happy_var_1
	)}

happyReduce_305 = happySpecReduce_0  81# happyReduction_305
happyReduction_305  =  happyIn87
		 (Nothing
	)

happyReduce_306 = happySpecReduce_3  82# happyReduction_306
happyReduction_306 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut88 happy_x_1 of { happy_var_1 -> 
	case happyOut89 happy_x_3 of { happy_var_3 -> 
	happyIn88
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_307 = happySpecReduce_1  82# happyReduction_307
happyReduction_307 happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	happyIn88
		 ([ happy_var_1 ]
	)}

happyReduce_308 = happySpecReduce_1  83# happyReduction_308
happyReduction_308 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn89
		 (ExpValue () (getSpan happy_var_1) $ let (TId _ s) = happy_var_1 in ValVariable s
	)}

happyReduce_309 = happySpecReduce_1  84# happyReduction_309
happyReduction_309 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn90
		 (ExpValue () (getSpan happy_var_1) $ let (TInt _ i) = happy_var_1 in ValInteger i
	)}

happyReduce_310 = happySpecReduce_2  85# happyReduction_310
happyReduction_310 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut93 happy_x_2 of { happy_var_2 -> 
	happyIn91
		 (makeReal (Just happy_var_1) Nothing Nothing (Just happy_var_2)
	)}}

happyReduce_311 = happySpecReduce_3  85# happyReduction_311
happyReduction_311 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	case happyOut92 happy_x_3 of { happy_var_3 -> 
	happyIn91
		 (makeReal (Just happy_var_1) (Just happy_var_2) Nothing happy_var_3
	)}}}

happyReduce_312 = happySpecReduce_3  85# happyReduction_312
happyReduction_312 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	case happyOut92 happy_x_3 of { happy_var_3 -> 
	happyIn91
		 (makeReal Nothing (Just happy_var_1) (Just happy_var_2) happy_var_3
	)}}}

happyReduce_313 = happyReduce 4# 85# happyReduction_313
happyReduction_313 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	case happyOut92 happy_x_4 of { happy_var_4 -> 
	happyIn91
		 (makeReal (Just happy_var_1) (Just happy_var_2) (Just happy_var_3) happy_var_4
	) `HappyStk` happyRest}}}}

happyReduce_314 = happySpecReduce_1  86# happyReduction_314
happyReduction_314 happy_x_1
	 =  case happyOut93 happy_x_1 of { happy_var_1 -> 
	happyIn92
		 (Just happy_var_1
	)}

happyReduce_315 = happySpecReduce_0  86# happyReduction_315
happyReduction_315  =  happyIn92
		 (Nothing
	)

happyReduce_316 = happySpecReduce_1  87# happyReduction_316
happyReduction_316 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn93
		 (let (TExponent s exp) = happy_var_1 in (s, exp)
	)}

happyReduce_317 = happySpecReduce_2  88# happyReduction_317
happyReduction_317 happy_x_2
	happy_x_1
	 =  case happyOut86 happy_x_1 of { happy_var_1 -> 
	case happyOut95 happy_x_2 of { happy_var_2 -> 
	happyIn94
		 (ExpUnary () (getTransSpan (fst happy_var_1) happy_var_2) Minus happy_var_2
	)}}

happyReduce_318 = happySpecReduce_1  88# happyReduction_318
happyReduction_318 happy_x_1
	 =  case happyOut95 happy_x_1 of { happy_var_1 -> 
	happyIn94
		 (happy_var_1
	)}

happyReduce_319 = happySpecReduce_1  89# happyReduction_319
happyReduction_319 happy_x_1
	 =  case happyOut90 happy_x_1 of { happy_var_1 -> 
	happyIn95
		 (happy_var_1
	)}

happyReduce_320 = happySpecReduce_1  89# happyReduction_320
happyReduction_320 happy_x_1
	 =  case happyOut91 happy_x_1 of { happy_var_1 -> 
	happyIn95
		 (happy_var_1
	)}

happyReduce_321 = happySpecReduce_1  90# happyReduction_321
happyReduction_321 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn96
		 (let TBool s b = happy_var_1 in ExpValue () s $ ValLogical b
	)}

happyReduce_322 = happySpecReduce_1  91# happyReduction_322
happyReduction_322 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn97
		 (ExpValue () (getSpan happy_var_1) $ let (THollerith _ h) = happy_var_1 in ValHollerith h
	)}

happyReduce_323 = happySpecReduce_2  92# happyReduction_323
happyReduction_323 happy_x_2
	happy_x_1
	 =  case happyOut99 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	happyIn98
		 (setSpan (getTransSpan happy_var_1 happy_var_2) $ aReverse happy_var_1
	)}}

happyReduce_324 = happySpecReduce_3  93# happyReduction_324
happyReduction_324 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut99 happy_x_1 of { happy_var_1 -> 
	case happyOut101 happy_x_3 of { happy_var_3 -> 
	happyIn99
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_325 = happySpecReduce_2  93# happyReduction_325
happyReduction_325 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut101 happy_x_2 of { happy_var_2 -> 
	happyIn99
		 (AList () (getTransSpan happy_var_1 happy_var_2) [ happy_var_2 ]
	)}}

happyReduce_326 = happySpecReduce_1  94# happyReduction_326
happyReduction_326 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn100
		 (ExpValue () (getSpan happy_var_1) (let (TLabel _ l) = happy_var_1 in ValInteger l)
	)}

happyReduce_327 = happySpecReduce_1  95# happyReduction_327
happyReduction_327 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn101
		 (ExpValue () (getSpan happy_var_1) (let (TInt _ l) = happy_var_1 in ValInteger l)
	)}

happyReduce_328 = happySpecReduce_2  96# happyReduction_328
happyReduction_328 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn102
		 (TypeSpec () (getSpan happy_var_1) TypeInteger Nothing
	)}

happyReduce_329 = happySpecReduce_2  96# happyReduction_329
happyReduction_329 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn102
		 (TypeSpec () (getSpan happy_var_1) TypeReal Nothing
	)}

happyReduce_330 = happySpecReduce_2  96# happyReduction_330
happyReduction_330 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn102
		 (TypeSpec () (getSpan happy_var_1) TypeDoublePrecision Nothing
	)}

happyReduce_331 = happySpecReduce_2  96# happyReduction_331
happyReduction_331 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn102
		 (TypeSpec () (getSpan happy_var_1) TypeLogical Nothing
	)}

happyReduce_332 = happySpecReduce_2  96# happyReduction_332
happyReduction_332 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn102
		 (TypeSpec () (getSpan happy_var_1) TypeComplex Nothing
	)}

happyReduce_333 = happySpecReduce_2  96# happyReduction_333
happyReduction_333 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn102
		 (TypeSpec () (getSpan happy_var_1) TypeDoubleComplex Nothing
	)}

happyReduce_334 = happySpecReduce_2  96# happyReduction_334
happyReduction_334 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut104 happy_x_2 of { happy_var_2 -> 
	happyIn102
		 (TypeSpec () (getSpan (happy_var_1, happy_var_2)) TypeCharacter happy_var_2
	)}}

happyReduce_335 = happySpecReduce_2  97# happyReduction_335
happyReduction_335 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut80 happy_x_2 of { happy_var_2 -> 
	happyIn103
		 (Just $ Selector () (getTransSpan happy_var_1 happy_var_2) Nothing (Just happy_var_2)
	)}}

happyReduce_336 = happyReduce 4# 97# happyReduction_336
happyReduction_336 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut107 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_4 of { happy_var_4 -> 
	happyIn103
		 (Just $ Selector () (getTransSpan happy_var_1 happy_var_4) Nothing (Just happy_var_3)
	) `HappyStk` happyRest}}}

happyReduce_337 = happySpecReduce_0  97# happyReduction_337
happyReduction_337  =  happyIn103
		 (Nothing
	)

happyReduce_338 = happySpecReduce_3  98# happyReduction_338
happyReduction_338 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut80 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn104
		 (Just $ Selector () (getTransSpan happy_var_1 happy_var_3) (Just happy_var_2) Nothing
	)}}}

happyReduce_339 = happySpecReduce_1  98# happyReduction_339
happyReduction_339 happy_x_1
	 =  case happyOut105 happy_x_1 of { happy_var_1 -> 
	happyIn104
		 (happy_var_1
	)}

happyReduce_340 = happySpecReduce_2  99# happyReduction_340
happyReduction_340 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut80 happy_x_2 of { happy_var_2 -> 
	happyIn105
		 (Just $ Selector () (getTransSpan happy_var_1 happy_var_2) (Just happy_var_2) Nothing
	)}}

happyReduce_341 = happyReduce 4# 99# happyReduction_341
happyReduction_341 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut107 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_4 of { happy_var_4 -> 
	happyIn105
		 (Just $ Selector () (getTransSpan happy_var_1 happy_var_4) (Just happy_var_3) Nothing
	) `HappyStk` happyRest}}}

happyReduce_342 = happySpecReduce_0  99# happyReduction_342
happyReduction_342  =  happyIn105
		 (Nothing
	)

happyReduce_343 = happySpecReduce_1  100# happyReduction_343
happyReduction_343 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn106
		 (TypeSpec () (getSpan happy_var_1) TypeInteger Nothing
	)}

happyReduce_344 = happySpecReduce_1  100# happyReduction_344
happyReduction_344 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn106
		 (TypeSpec () (getSpan happy_var_1) TypeReal Nothing
	)}

happyReduce_345 = happySpecReduce_1  100# happyReduction_345
happyReduction_345 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn106
		 (TypeSpec () (getSpan happy_var_1) TypeDoublePrecision Nothing
	)}

happyReduce_346 = happySpecReduce_1  100# happyReduction_346
happyReduction_346 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn106
		 (TypeSpec () (getSpan happy_var_1) TypeLogical Nothing
	)}

happyReduce_347 = happySpecReduce_1  100# happyReduction_347
happyReduction_347 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn106
		 (TypeSpec () (getSpan happy_var_1) TypeComplex Nothing
	)}

happyReduce_348 = happySpecReduce_1  100# happyReduction_348
happyReduction_348 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn106
		 (TypeSpec () (getSpan happy_var_1) TypeDoubleComplex Nothing
	)}

happyReduce_349 = happySpecReduce_2  100# happyReduction_349
happyReduction_349 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut105 happy_x_2 of { happy_var_2 -> 
	happyIn106
		 (TypeSpec () (getSpan (happy_var_1, happy_var_2)) TypeCharacter happy_var_2
	)}}

happyReduce_350 = happySpecReduce_1  101# happyReduction_350
happyReduction_350 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn107
		 (ExpValue () (getSpan happy_var_1) ValStar
	)}

happyNewToken action sts stk
	= lexer(\tk -> 
	let cont i = happyDoAction i tk action sts stk in
	case tk of {
	TEOF _ -> happyDoAction 89# tk action sts stk;
	TLeftPar _ -> cont 1#;
	TRightPar _ -> cont 2#;
	TLeftArrayPar _ -> cont 3#;
	TRightArrayPar _ -> cont 4#;
	TComma _ -> cont 5#;
	TDot _ -> cont 6#;
	TColon _ -> cont 7#;
	TInclude _ -> cont 8#;
	TProgram _ -> cont 9#;
	TFunction _ -> cont 10#;
	TSubroutine _ -> cont 11#;
	TBlockData _ -> cont 12#;
	TEnd _ -> cont 13#;
	TOpAssign _ -> cont 14#;
	TAssign _ -> cont 15#;
	TTo _ -> cont 16#;
	TGoto _ -> cont 17#;
	TIf _ -> cont 18#;
	TThen _ -> cont 19#;
	TElse _ -> cont 20#;
	TElsif _ -> cont 21#;
	TEndif _ -> cont 22#;
	TCall _ -> cont 23#;
	TReturn _ -> cont 24#;
	TSave _ -> cont 25#;
	TContinue _ -> cont 26#;
	TStop _ -> cont 27#;
	TExit _ -> cont 28#;
	TPause _ -> cont 29#;
	TDo _ -> cont 30#;
	TDoWhile _ -> cont 31#;
	TEndDo _ -> cont 32#;
	TRead _ -> cont 33#;
	TWrite _ -> cont 34#;
	TPrint _ -> cont 35#;
	TOpen _ -> cont 36#;
	TClose _ -> cont 37#;
	TInquire _ -> cont 38#;
	TRewind _ -> cont 39#;
	TBackspace _ -> cont 40#;
	TEndfile _ -> cont 41#;
	TCommon _ -> cont 42#;
	TEquivalence _ -> cont 43#;
	TExternal _ -> cont 44#;
	TDimension _ -> cont 45#;
	TType _ "character" -> cont 46#;
	TType _ "integer" -> cont 47#;
	TType _ "real" -> cont 48#;
	TType _ "doubleprecision" -> cont 49#;
	TType _ "logical" -> cont 50#;
	TType _ "complex" -> cont 51#;
	TType _ "doublecomplex" -> cont 52#;
	TIntrinsic _ -> cont 53#;
	TImplicit _ -> cont 54#;
	TParameter _ -> cont 55#;
	TEntry _ -> cont 56#;
	TNone _ -> cont 57#;
	TData _ -> cont 58#;
	TFormat _ -> cont 59#;
	TFieldDescriptorDEFG _ _ _ _ _ -> cont 60#;
	TFieldDescriptorAIL _ _ _ _ -> cont 61#;
	TBlankDescriptor _ _ -> cont 62#;
	TScaleFactor _ _ -> cont 63#;
	TInt _ _ -> cont 64#;
	TExponent _ _ -> cont 65#;
	TBool _ _ -> cont 66#;
	TOpPlus _ -> cont 67#;
	TOpMinus _ -> cont 68#;
	TOpExp _ -> cont 69#;
	TStar _ -> cont 70#;
	TSlash _ -> cont 71#;
	TOpEquivalent _ -> cont 72#;
	TOpNotEquivalent _ -> cont 73#;
	TOpOr _ -> cont 74#;
	TOpAnd _ -> cont 75#;
	TOpNot _ -> cont 76#;
	TOpLT _ -> cont 77#;
	TOpLE _ -> cont 78#;
	TOpGT _ -> cont 79#;
	TOpGE _ -> cont 80#;
	TOpEQ _ -> cont 81#;
	TOpNE _ -> cont 82#;
	TId _ _ -> cont 83#;
	TComment _ _ -> cont 84#;
	THollerith _ _ -> cont 85#;
	TString _ _ -> cont 86#;
	TLabel _ _ -> cont 87#;
	TNewline _ -> cont 88#;
	_ -> happyError' tk
	})

happyError_ 89# tk = happyError' tk
happyError_ _ tk = happyError' tk

happyThen :: () => LexAction a -> (a -> LexAction b) -> LexAction b
happyThen = (>>=)
happyReturn :: () => a -> LexAction a
happyReturn = (return)
happyThen1 = happyThen
happyReturn1 :: () => a -> LexAction a
happyReturn1 = happyReturn
happyError' :: () => (Token) -> LexAction a
happyError' tk = parseError tk

programParser = happySomeParser where
  happySomeParser = happyThen (happyParse 0#) (\x -> happyReturn (happyOut6 x))

statementParser = happySomeParser where
  happySomeParser = happyThen (happyParse 1#) (\x -> happyReturn (happyOut18 x))

expressionParser = happySomeParser where
  happySomeParser = happyThen (happyParse 2#) (\x -> happyReturn (happyOut75 x))

happySeq = happyDontSeq


makeReal :: Maybe Token -> Maybe Token -> Maybe Token -> Maybe (SrcSpan, String) -> Expression A0
makeReal i1 dot i2 exp =
  let span1   = getSpan (i1, dot, i2)
      span2   = case exp of
                  Just e -> getTransSpan span1 (fst e)
                  Nothing -> span1
      i1Str   = case i1 of { Just (TInt _ s) -> s ; _ -> "" }
      dotStr  = case dot of { Just (TDot _) -> "." ; _ -> "" }
      i2Str   = case i2 of { Just (TInt _ s) -> s ; _ -> "" }
      expStr  = case exp of { Just (_, s) -> s ; _ -> "" } in
    ExpValue () span2 (ValReal $ i1Str ++ dotStr ++ i2Str ++ expStr)

parse = evalParse programParser

transformations77 =
  [ GroupLabeledDo
  , GroupIf
  , DisambiguateFunction
  ]
fortran77Parser :: B.ByteString -> String -> ProgramFile A0
fortran77Parser sourceCode filename =
    transform transformations77 $ parse parseState
  where
    parseState = initParseState sourceCode Fortran77Extended filename

transformations77Extended =
  [ GroupLabeledDo
  , GroupDo
  , GroupIf
  , DisambiguateFunction
  ]
extended77Parser :: B.ByteString -> String -> ProgramFile A0
extended77Parser sourceCode filename =
    transform transformations77Extended $ parse parseState
  where
    parseState = initParseState sourceCode Fortran77Extended filename

parseError :: Token -> LexAction a
parseError _ = fail "Parsing failed."
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 19 "<built-in>" #-}
{-# LINE 1 "/usr/local/lib/ghc-7.10.2/include/ghcversion.h" #-}


















{-# LINE 20 "<built-in>" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 


{-# LINE 13 "templates/GenericTemplate.hs" #-}





-- Do not remove this comment. Required to fix CPP parsing when using GCC and a clang-compiled alex.
#if __GLASGOW_HASKELL__ > 706
#define LT(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.<# m)) :: Bool)
#define GTE(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.>=# m)) :: Bool)
#define EQ(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.==# m)) :: Bool)
#else
#define LT(n,m) (n Happy_GHC_Exts.<# m)
#define GTE(n,m) (n Happy_GHC_Exts.>=# m)
#define EQ(n,m) (n Happy_GHC_Exts.==# m)
#endif

{-# LINE 46 "templates/GenericTemplate.hs" #-}


data Happy_IntList = HappyCons Happy_GHC_Exts.Int# Happy_IntList






{-# LINE 67 "templates/GenericTemplate.hs" #-}


{-# LINE 77 "templates/GenericTemplate.hs" #-}










infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is 0#, it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept 0# tk st sts (_ `HappyStk` ans `HappyStk` _) =
        happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
        (happyTcHack j (happyTcHack st)) (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action



happyDoAction i tk st
        = {- nothing -}
          

          case action of
                0#           -> {- nothing -}
                                     happyFail i tk st
                -1#          -> {- nothing -}
                                     happyAccept i tk st
                n | LT(n,(0# :: Happy_GHC_Exts.Int#)) -> {- nothing -}
                                                   
                                                   (happyReduceArr Happy_Data_Array.! rule) i tk st
                                                   where rule = (Happy_GHC_Exts.I# ((Happy_GHC_Exts.negateInt# ((n Happy_GHC_Exts.+# (1# :: Happy_GHC_Exts.Int#))))))
                n                 -> {- nothing -}
                                     

                                     happyShift new_state i tk st
                                     where new_state = (n Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#))
   where off    = indexShortOffAddr happyActOffsets st
         off_i  = (off Happy_GHC_Exts.+# i)
         check  = if GTE(off_i,(0# :: Happy_GHC_Exts.Int#))
                  then EQ(indexShortOffAddr happyCheck off_i, i)
                  else False
         action
          | check     = indexShortOffAddr happyTable off_i
          | otherwise = indexShortOffAddr happyDefActions st


indexShortOffAddr (HappyA# arr) off =
        Happy_GHC_Exts.narrow16Int# i
  where
        i = Happy_GHC_Exts.word2Int# (Happy_GHC_Exts.or# (Happy_GHC_Exts.uncheckedShiftL# high 8#) low)
        high = Happy_GHC_Exts.int2Word# (Happy_GHC_Exts.ord# (Happy_GHC_Exts.indexCharOffAddr# arr (off' Happy_GHC_Exts.+# 1#)))
        low  = Happy_GHC_Exts.int2Word# (Happy_GHC_Exts.ord# (Happy_GHC_Exts.indexCharOffAddr# arr off'))
        off' = off Happy_GHC_Exts.*# 2#





data HappyAddr = HappyA# Happy_GHC_Exts.Addr#




-----------------------------------------------------------------------------
-- HappyState data type (not arrays)


{-# LINE 170 "templates/GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state 0# tk st sts stk@(x `HappyStk` _) =
     let i = (case Happy_GHC_Exts.unsafeCoerce# x of { (Happy_GHC_Exts.I# (i)) -> i }) in
--     trace "shifting the error token" $
     happyDoAction i tk new_state (HappyCons (st) (sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state (HappyCons (st) (sts)) ((happyInTok (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_0 nt fn j tk st@((action)) sts stk
     = happyGoto nt j tk st (HappyCons (st) (sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@((HappyCons (st@(action)) (_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_2 nt fn j tk _ (HappyCons (_) (sts@((HappyCons (st@(action)) (_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_3 nt fn j tk _ (HappyCons (_) ((HappyCons (_) (sts@((HappyCons (st@(action)) (_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#)) sts of
         sts1@((HappyCons (st1@(action)) (_))) ->
                let r = fn stk in  -- it doesn't hurt to always seq here...
                happyDoSeq r (happyGoto nt j tk st1 sts1 r)

happyMonadReduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
      case happyDrop k (HappyCons (st) (sts)) of
        sts1@((HappyCons (st1@(action)) (_))) ->
          let drop_stk = happyDropStk k stk in
          happyThen1 (fn stk tk) (\r -> happyGoto nt j tk st1 sts1 (r `HappyStk` drop_stk))

happyMonad2Reduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
      case happyDrop k (HappyCons (st) (sts)) of
        sts1@((HappyCons (st1@(action)) (_))) ->
         let drop_stk = happyDropStk k stk

             off = indexShortOffAddr happyGotoOffsets st1
             off_i = (off Happy_GHC_Exts.+# nt)
             new_state = indexShortOffAddr happyTable off_i



          in
          happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))

happyDrop 0# l = l
happyDrop n (HappyCons (_) (t)) = happyDrop (n Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#)) t

happyDropStk 0# l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n Happy_GHC_Exts.-# (1#::Happy_GHC_Exts.Int#)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction


happyGoto nt j tk st = 
   {- nothing -}
   happyDoAction j tk new_state
   where off = indexShortOffAddr happyGotoOffsets st
         off_i = (off Happy_GHC_Exts.+# nt)
         new_state = indexShortOffAddr happyTable off_i




-----------------------------------------------------------------------------
-- Error recovery (0# is the error token)

-- parse error if we are in recovery and we fail again
happyFail 0# tk old_st _ stk@(x `HappyStk` _) =
     let i = (case Happy_GHC_Exts.unsafeCoerce# x of { (Happy_GHC_Exts.I# (i)) -> i }) in
--      trace "failing" $ 
        happyError_ i tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  0# tk old_st (HappyCons ((action)) (sts)) 
                                                (saved_tok `HappyStk` _ `HappyStk` stk) =
--      trace ("discarding state, depth " ++ show (length stk))  $
        happyDoAction 0# tk action sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (action) sts stk =
--      trace "entering error recovery" $
        happyDoAction 0# tk action sts ( (Happy_GHC_Exts.unsafeCoerce# (Happy_GHC_Exts.I# (i))) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll :: a
notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions


happyTcHack :: Happy_GHC_Exts.Int# -> a -> a
happyTcHack x y = y
{-# INLINE happyTcHack #-}


-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--      happySeq = happyDoSeq
-- otherwise it emits
--      happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.


{-# NOINLINE happyDoAction #-}
{-# NOINLINE happyTable #-}
{-# NOINLINE happyCheck #-}
{-# NOINLINE happyActOffsets #-}
{-# NOINLINE happyGotoOffsets #-}
{-# NOINLINE happyDefActions #-}

{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.

