{-# OPTIONS_GHC -w #-}
module Language.Fortran.Parser.Fortran66(expressionParser,
                               statementParser,
                               fortran66Parser) where

import Prelude hiding (EQ,LT,GT) -- Same constructors exist in the AST

import Data.Maybe (isNothing, fromJust)

import Language.Fortran.Util.Position
import Language.Fortran.ParserMonad
import Language.Fortran.Lexer.FixedForm
import Language.Fortran.Transformer (transform, Transformation(..))
import Language.Fortran.AST
import Control.Applicative(Applicative(..))
import Control.Monad (ap)

-- parser produced by Happy Version 1.19.5

data HappyAbsSyn 
	= HappyTerminal (Token)
	| HappyErrorToken Int
	| HappyAbsSyn6 (ProgramFile A0)
	| HappyAbsSyn7 ([ ([ Block A0 ], ProgramUnit A0) ])
	| HappyAbsSyn8 (ProgramUnit A0)
	| HappyAbsSyn10 (Maybe (AList Expression A0))
	| HappyAbsSyn11 (Name)
	| HappyAbsSyn12 ([ Block A0 ])
	| HappyAbsSyn13 (Block A0)
	| HappyAbsSyn14 (Token)
	| HappyAbsSyn15 (Statement A0)
	| HappyAbsSyn18 (DoSpecification A0)
	| HappyAbsSyn19 (Expression A0)
	| HappyAbsSyn23 ((AList ControlPair A0, Maybe (AList Expression A0)))
	| HappyAbsSyn26 (AList Expression A0)
	| HappyAbsSyn29 (AList FormatItem A0)
	| HappyAbsSyn30 (FormatItem A0)
	| HappyAbsSyn32 (AList DataGroup A0)
	| HappyAbsSyn36 (AList (AList Expression) A0)
	| HappyAbsSyn37 (AList CommonGroup A0)
	| HappyAbsSyn38 (CommonGroup A0)
	| HappyAbsSyn43 (AList Declarator A0)
	| HappyAbsSyn44 (Declarator A0)
	| HappyAbsSyn47 (AList DimensionDeclarator A0)
	| HappyAbsSyn48 (DimensionDeclarator A0)
	| HappyAbsSyn51 (AList Argument A0)
	| HappyAbsSyn53 (Argument A0)
	| HappyAbsSyn55 (BinaryOp)
	| HappyAbsSyn57 ([ Index A0 ])
	| HappyAbsSyn58 ((SrcSpan, UnaryOp))
	| HappyAbsSyn60 ([ Expression A0 ])
	| HappyAbsSyn66 (Maybe (SrcSpan, String))
	| HappyAbsSyn67 ((SrcSpan, String))
	| HappyAbsSyn76 (TypeSpec A0)

{- to allow type-synonyms as our monads (likely
 - with explicitly-specified bind and return)
 - in Haskell98, it seems that with
 - /type M a = .../, then /(HappyReduction M)/
 - is not allowed.  But Happy is a
 - code-generator that can just substitute it.
type HappyReduction m = 
	   Int 
	-> (Token)
	-> HappyState (Token) (HappyStk HappyAbsSyn -> m HappyAbsSyn)
	-> [HappyState (Token) (HappyStk HappyAbsSyn -> m HappyAbsSyn)] 
	-> HappyStk HappyAbsSyn 
	-> m HappyAbsSyn
-}

action_0,
 action_1,
 action_2,
 action_3,
 action_4,
 action_5,
 action_6,
 action_7,
 action_8,
 action_9,
 action_10,
 action_11,
 action_12,
 action_13,
 action_14,
 action_15,
 action_16,
 action_17,
 action_18,
 action_19,
 action_20,
 action_21,
 action_22,
 action_23,
 action_24,
 action_25,
 action_26,
 action_27,
 action_28,
 action_29,
 action_30,
 action_31,
 action_32,
 action_33,
 action_34,
 action_35,
 action_36,
 action_37,
 action_38,
 action_39,
 action_40,
 action_41,
 action_42,
 action_43,
 action_44,
 action_45,
 action_46,
 action_47,
 action_48,
 action_49,
 action_50,
 action_51,
 action_52,
 action_53,
 action_54,
 action_55,
 action_56,
 action_57,
 action_58,
 action_59,
 action_60,
 action_61,
 action_62,
 action_63,
 action_64,
 action_65,
 action_66,
 action_67,
 action_68,
 action_69,
 action_70,
 action_71,
 action_72,
 action_73,
 action_74,
 action_75,
 action_76,
 action_77,
 action_78,
 action_79,
 action_80,
 action_81,
 action_82,
 action_83,
 action_84,
 action_85,
 action_86,
 action_87,
 action_88,
 action_89,
 action_90,
 action_91,
 action_92,
 action_93,
 action_94,
 action_95,
 action_96,
 action_97,
 action_98,
 action_99,
 action_100,
 action_101,
 action_102,
 action_103,
 action_104,
 action_105,
 action_106,
 action_107,
 action_108,
 action_109,
 action_110,
 action_111,
 action_112,
 action_113,
 action_114,
 action_115,
 action_116,
 action_117,
 action_118,
 action_119,
 action_120,
 action_121,
 action_122,
 action_123,
 action_124,
 action_125,
 action_126,
 action_127,
 action_128,
 action_129,
 action_130,
 action_131,
 action_132,
 action_133,
 action_134,
 action_135,
 action_136,
 action_137,
 action_138,
 action_139,
 action_140,
 action_141,
 action_142,
 action_143,
 action_144,
 action_145,
 action_146,
 action_147,
 action_148,
 action_149,
 action_150,
 action_151,
 action_152,
 action_153,
 action_154,
 action_155,
 action_156,
 action_157,
 action_158,
 action_159,
 action_160,
 action_161,
 action_162,
 action_163,
 action_164,
 action_165,
 action_166,
 action_167,
 action_168,
 action_169,
 action_170,
 action_171,
 action_172,
 action_173,
 action_174,
 action_175,
 action_176,
 action_177,
 action_178,
 action_179,
 action_180,
 action_181,
 action_182,
 action_183,
 action_184,
 action_185,
 action_186,
 action_187,
 action_188,
 action_189,
 action_190,
 action_191,
 action_192,
 action_193,
 action_194,
 action_195,
 action_196,
 action_197,
 action_198,
 action_199,
 action_200,
 action_201,
 action_202,
 action_203,
 action_204,
 action_205,
 action_206,
 action_207,
 action_208,
 action_209,
 action_210,
 action_211,
 action_212,
 action_213,
 action_214,
 action_215,
 action_216,
 action_217,
 action_218,
 action_219,
 action_220,
 action_221,
 action_222,
 action_223,
 action_224,
 action_225,
 action_226,
 action_227,
 action_228,
 action_229,
 action_230,
 action_231,
 action_232,
 action_233,
 action_234,
 action_235,
 action_236,
 action_237,
 action_238,
 action_239,
 action_240,
 action_241,
 action_242,
 action_243,
 action_244,
 action_245,
 action_246,
 action_247,
 action_248,
 action_249,
 action_250,
 action_251,
 action_252,
 action_253,
 action_254,
 action_255,
 action_256,
 action_257,
 action_258,
 action_259,
 action_260,
 action_261,
 action_262,
 action_263,
 action_264,
 action_265,
 action_266,
 action_267,
 action_268,
 action_269,
 action_270,
 action_271,
 action_272,
 action_273,
 action_274,
 action_275,
 action_276,
 action_277,
 action_278,
 action_279,
 action_280,
 action_281,
 action_282,
 action_283,
 action_284,
 action_285,
 action_286,
 action_287,
 action_288,
 action_289,
 action_290,
 action_291,
 action_292,
 action_293,
 action_294,
 action_295,
 action_296,
 action_297,
 action_298,
 action_299,
 action_300,
 action_301,
 action_302,
 action_303,
 action_304,
 action_305,
 action_306,
 action_307,
 action_308,
 action_309,
 action_310,
 action_311,
 action_312,
 action_313,
 action_314,
 action_315,
 action_316,
 action_317,
 action_318,
 action_319,
 action_320,
 action_321,
 action_322,
 action_323,
 action_324,
 action_325,
 action_326,
 action_327,
 action_328,
 action_329,
 action_330,
 action_331,
 action_332,
 action_333,
 action_334,
 action_335,
 action_336,
 action_337,
 action_338,
 action_339,
 action_340,
 action_341,
 action_342,
 action_343,
 action_344,
 action_345,
 action_346,
 action_347,
 action_348 :: () => Int -> ({-HappyReduction (LexAction) = -}
	   Int 
	-> (Token)
	-> HappyState (Token) (HappyStk HappyAbsSyn -> (LexAction) HappyAbsSyn)
	-> [HappyState (Token) (HappyStk HappyAbsSyn -> (LexAction) HappyAbsSyn)] 
	-> HappyStk HappyAbsSyn 
	-> (LexAction) HappyAbsSyn)

happyReduce_3,
 happyReduce_4,
 happyReduce_5,
 happyReduce_6,
 happyReduce_7,
 happyReduce_8,
 happyReduce_9,
 happyReduce_10,
 happyReduce_11,
 happyReduce_12,
 happyReduce_13,
 happyReduce_14,
 happyReduce_15,
 happyReduce_16,
 happyReduce_17,
 happyReduce_18,
 happyReduce_19,
 happyReduce_20,
 happyReduce_21,
 happyReduce_22,
 happyReduce_23,
 happyReduce_24,
 happyReduce_25,
 happyReduce_26,
 happyReduce_27,
 happyReduce_28,
 happyReduce_29,
 happyReduce_30,
 happyReduce_31,
 happyReduce_32,
 happyReduce_33,
 happyReduce_34,
 happyReduce_35,
 happyReduce_36,
 happyReduce_37,
 happyReduce_38,
 happyReduce_39,
 happyReduce_40,
 happyReduce_41,
 happyReduce_42,
 happyReduce_43,
 happyReduce_44,
 happyReduce_45,
 happyReduce_46,
 happyReduce_47,
 happyReduce_48,
 happyReduce_49,
 happyReduce_50,
 happyReduce_51,
 happyReduce_52,
 happyReduce_53,
 happyReduce_54,
 happyReduce_55,
 happyReduce_56,
 happyReduce_57,
 happyReduce_58,
 happyReduce_59,
 happyReduce_60,
 happyReduce_61,
 happyReduce_62,
 happyReduce_63,
 happyReduce_64,
 happyReduce_65,
 happyReduce_66,
 happyReduce_67,
 happyReduce_68,
 happyReduce_69,
 happyReduce_70,
 happyReduce_71,
 happyReduce_72,
 happyReduce_73,
 happyReduce_74,
 happyReduce_75,
 happyReduce_76,
 happyReduce_77,
 happyReduce_78,
 happyReduce_79,
 happyReduce_80,
 happyReduce_81,
 happyReduce_82,
 happyReduce_83,
 happyReduce_84,
 happyReduce_85,
 happyReduce_86,
 happyReduce_87,
 happyReduce_88,
 happyReduce_89,
 happyReduce_90,
 happyReduce_91,
 happyReduce_92,
 happyReduce_93,
 happyReduce_94,
 happyReduce_95,
 happyReduce_96,
 happyReduce_97,
 happyReduce_98,
 happyReduce_99,
 happyReduce_100,
 happyReduce_101,
 happyReduce_102,
 happyReduce_103,
 happyReduce_104,
 happyReduce_105,
 happyReduce_106,
 happyReduce_107,
 happyReduce_108,
 happyReduce_109,
 happyReduce_110,
 happyReduce_111,
 happyReduce_112,
 happyReduce_113,
 happyReduce_114,
 happyReduce_115,
 happyReduce_116,
 happyReduce_117,
 happyReduce_118,
 happyReduce_119,
 happyReduce_120,
 happyReduce_121,
 happyReduce_122,
 happyReduce_123,
 happyReduce_124,
 happyReduce_125,
 happyReduce_126,
 happyReduce_127,
 happyReduce_128,
 happyReduce_129,
 happyReduce_130,
 happyReduce_131,
 happyReduce_132,
 happyReduce_133,
 happyReduce_134,
 happyReduce_135,
 happyReduce_136,
 happyReduce_137,
 happyReduce_138,
 happyReduce_139,
 happyReduce_140,
 happyReduce_141,
 happyReduce_142,
 happyReduce_143,
 happyReduce_144,
 happyReduce_145,
 happyReduce_146,
 happyReduce_147,
 happyReduce_148,
 happyReduce_149,
 happyReduce_150,
 happyReduce_151,
 happyReduce_152,
 happyReduce_153,
 happyReduce_154,
 happyReduce_155,
 happyReduce_156,
 happyReduce_157,
 happyReduce_158,
 happyReduce_159,
 happyReduce_160,
 happyReduce_161,
 happyReduce_162,
 happyReduce_163,
 happyReduce_164,
 happyReduce_165,
 happyReduce_166,
 happyReduce_167,
 happyReduce_168,
 happyReduce_169,
 happyReduce_170,
 happyReduce_171,
 happyReduce_172,
 happyReduce_173,
 happyReduce_174,
 happyReduce_175,
 happyReduce_176,
 happyReduce_177,
 happyReduce_178,
 happyReduce_179,
 happyReduce_180,
 happyReduce_181,
 happyReduce_182,
 happyReduce_183,
 happyReduce_184,
 happyReduce_185,
 happyReduce_186,
 happyReduce_187,
 happyReduce_188,
 happyReduce_189,
 happyReduce_190,
 happyReduce_191,
 happyReduce_192,
 happyReduce_193,
 happyReduce_194 :: () => ({-HappyReduction (LexAction) = -}
	   Int 
	-> (Token)
	-> HappyState (Token) (HappyStk HappyAbsSyn -> (LexAction) HappyAbsSyn)
	-> [HappyState (Token) (HappyStk HappyAbsSyn -> (LexAction) HappyAbsSyn)] 
	-> HappyStk HappyAbsSyn 
	-> (LexAction) HappyAbsSyn)

action_0 (81) = happyShift action_20
action_0 (82) = happyShift action_21
action_0 (83) = happyShift action_22
action_0 (86) = happyShift action_23
action_0 (88) = happyShift action_24
action_0 (89) = happyShift action_25
action_0 (90) = happyShift action_26
action_0 (91) = happyShift action_27
action_0 (92) = happyShift action_28
action_0 (93) = happyShift action_29
action_0 (94) = happyShift action_30
action_0 (95) = happyShift action_31
action_0 (96) = happyShift action_32
action_0 (97) = happyShift action_33
action_0 (98) = happyShift action_34
action_0 (99) = happyShift action_35
action_0 (100) = happyShift action_36
action_0 (101) = happyShift action_37
action_0 (102) = happyShift action_38
action_0 (103) = happyShift action_39
action_0 (104) = happyShift action_40
action_0 (105) = happyShift action_41
action_0 (106) = happyShift action_42
action_0 (107) = happyShift action_43
action_0 (108) = happyShift action_44
action_0 (109) = happyShift action_45
action_0 (110) = happyShift action_46
action_0 (111) = happyShift action_47
action_0 (133) = happyShift action_48
action_0 (134) = happyShift action_49
action_0 (136) = happyShift action_50
action_0 (6) = happyGoto action_68
action_0 (7) = happyGoto action_69
action_0 (8) = happyGoto action_5
action_0 (9) = happyGoto action_6
action_0 (12) = happyGoto action_7
action_0 (13) = happyGoto action_8
action_0 (15) = happyGoto action_9
action_0 (16) = happyGoto action_10
action_0 (17) = happyGoto action_11
action_0 (20) = happyGoto action_12
action_0 (21) = happyGoto action_13
action_0 (22) = happyGoto action_14
action_0 (28) = happyGoto action_15
action_0 (56) = happyGoto action_16
action_0 (61) = happyGoto action_17
action_0 (74) = happyGoto action_18
action_0 (76) = happyGoto action_19
action_0 _ = happyFail

action_1 (86) = happyShift action_23
action_1 (88) = happyShift action_24
action_1 (89) = happyShift action_25
action_1 (90) = happyShift action_26
action_1 (91) = happyShift action_27
action_1 (92) = happyShift action_28
action_1 (93) = happyShift action_29
action_1 (94) = happyShift action_30
action_1 (95) = happyShift action_31
action_1 (96) = happyShift action_32
action_1 (97) = happyShift action_33
action_1 (98) = happyShift action_34
action_1 (99) = happyShift action_35
action_1 (100) = happyShift action_36
action_1 (101) = happyShift action_37
action_1 (102) = happyShift action_38
action_1 (103) = happyShift action_39
action_1 (104) = happyShift action_40
action_1 (105) = happyShift action_41
action_1 (106) = happyShift action_42
action_1 (107) = happyShift action_43
action_1 (108) = happyShift action_44
action_1 (109) = happyShift action_45
action_1 (110) = happyShift action_46
action_1 (111) = happyShift action_47
action_1 (133) = happyShift action_48
action_1 (15) = happyGoto action_66
action_1 (16) = happyGoto action_10
action_1 (17) = happyGoto action_11
action_1 (20) = happyGoto action_12
action_1 (21) = happyGoto action_13
action_1 (22) = happyGoto action_14
action_1 (28) = happyGoto action_15
action_1 (56) = happyGoto action_16
action_1 (61) = happyGoto action_17
action_1 (76) = happyGoto action_67
action_1 _ = happyFail

action_2 (77) = happyShift action_59
action_2 (80) = happyShift action_60
action_2 (116) = happyShift action_61
action_2 (118) = happyShift action_62
action_2 (119) = happyShift action_63
action_2 (120) = happyShift action_64
action_2 (126) = happyShift action_65
action_2 (133) = happyShift action_48
action_2 (54) = happyGoto action_51
action_2 (56) = happyGoto action_52
action_2 (58) = happyGoto action_53
action_2 (61) = happyGoto action_54
action_2 (63) = happyGoto action_55
action_2 (65) = happyGoto action_56
action_2 (69) = happyGoto action_57
action_2 (70) = happyGoto action_58
action_2 _ = happyFail

action_3 (81) = happyShift action_20
action_3 (82) = happyShift action_21
action_3 (83) = happyShift action_22
action_3 (86) = happyShift action_23
action_3 (88) = happyShift action_24
action_3 (89) = happyShift action_25
action_3 (90) = happyShift action_26
action_3 (91) = happyShift action_27
action_3 (92) = happyShift action_28
action_3 (93) = happyShift action_29
action_3 (94) = happyShift action_30
action_3 (95) = happyShift action_31
action_3 (96) = happyShift action_32
action_3 (97) = happyShift action_33
action_3 (98) = happyShift action_34
action_3 (99) = happyShift action_35
action_3 (100) = happyShift action_36
action_3 (101) = happyShift action_37
action_3 (102) = happyShift action_38
action_3 (103) = happyShift action_39
action_3 (104) = happyShift action_40
action_3 (105) = happyShift action_41
action_3 (106) = happyShift action_42
action_3 (107) = happyShift action_43
action_3 (108) = happyShift action_44
action_3 (109) = happyShift action_45
action_3 (110) = happyShift action_46
action_3 (111) = happyShift action_47
action_3 (133) = happyShift action_48
action_3 (134) = happyShift action_49
action_3 (136) = happyShift action_50
action_3 (7) = happyGoto action_4
action_3 (8) = happyGoto action_5
action_3 (9) = happyGoto action_6
action_3 (12) = happyGoto action_7
action_3 (13) = happyGoto action_8
action_3 (15) = happyGoto action_9
action_3 (16) = happyGoto action_10
action_3 (17) = happyGoto action_11
action_3 (20) = happyGoto action_12
action_3 (21) = happyGoto action_13
action_3 (22) = happyGoto action_14
action_3 (28) = happyGoto action_15
action_3 (56) = happyGoto action_16
action_3 (61) = happyGoto action_17
action_3 (74) = happyGoto action_18
action_3 (76) = happyGoto action_19
action_3 _ = happyFail

action_4 (81) = happyShift action_20
action_4 (82) = happyShift action_21
action_4 (83) = happyShift action_22
action_4 (86) = happyShift action_23
action_4 (88) = happyShift action_24
action_4 (89) = happyShift action_25
action_4 (90) = happyShift action_26
action_4 (91) = happyShift action_27
action_4 (92) = happyShift action_28
action_4 (93) = happyShift action_29
action_4 (94) = happyShift action_30
action_4 (95) = happyShift action_31
action_4 (96) = happyShift action_32
action_4 (97) = happyShift action_33
action_4 (98) = happyShift action_34
action_4 (99) = happyShift action_35
action_4 (100) = happyShift action_36
action_4 (101) = happyShift action_37
action_4 (102) = happyShift action_38
action_4 (103) = happyShift action_39
action_4 (104) = happyShift action_40
action_4 (105) = happyShift action_41
action_4 (106) = happyShift action_42
action_4 (107) = happyShift action_43
action_4 (108) = happyShift action_44
action_4 (109) = happyShift action_45
action_4 (110) = happyShift action_46
action_4 (111) = happyShift action_47
action_4 (133) = happyShift action_48
action_4 (134) = happyShift action_49
action_4 (136) = happyShift action_50
action_4 (8) = happyGoto action_70
action_4 (9) = happyGoto action_71
action_4 (12) = happyGoto action_159
action_4 (13) = happyGoto action_8
action_4 (15) = happyGoto action_9
action_4 (16) = happyGoto action_10
action_4 (17) = happyGoto action_11
action_4 (20) = happyGoto action_12
action_4 (21) = happyGoto action_13
action_4 (22) = happyGoto action_14
action_4 (28) = happyGoto action_15
action_4 (56) = happyGoto action_16
action_4 (61) = happyGoto action_17
action_4 (74) = happyGoto action_18
action_4 (76) = happyGoto action_19
action_4 _ = happyFail

action_5 _ = happyReduce_8

action_6 _ = happyReduce_9

action_7 (81) = happyShift action_20
action_7 (82) = happyShift action_21
action_7 (83) = happyShift action_22
action_7 (84) = happyShift action_158
action_7 (86) = happyShift action_23
action_7 (88) = happyShift action_24
action_7 (89) = happyShift action_25
action_7 (90) = happyShift action_26
action_7 (91) = happyShift action_27
action_7 (92) = happyShift action_28
action_7 (93) = happyShift action_29
action_7 (94) = happyShift action_30
action_7 (95) = happyShift action_31
action_7 (96) = happyShift action_32
action_7 (97) = happyShift action_33
action_7 (98) = happyShift action_34
action_7 (99) = happyShift action_35
action_7 (100) = happyShift action_36
action_7 (101) = happyShift action_37
action_7 (102) = happyShift action_38
action_7 (103) = happyShift action_39
action_7 (104) = happyShift action_40
action_7 (105) = happyShift action_41
action_7 (106) = happyShift action_42
action_7 (107) = happyShift action_43
action_7 (108) = happyShift action_44
action_7 (109) = happyShift action_45
action_7 (110) = happyShift action_46
action_7 (111) = happyShift action_47
action_7 (133) = happyShift action_48
action_7 (134) = happyShift action_49
action_7 (136) = happyShift action_50
action_7 (9) = happyGoto action_156
action_7 (13) = happyGoto action_157
action_7 (15) = happyGoto action_9
action_7 (16) = happyGoto action_10
action_7 (17) = happyGoto action_11
action_7 (20) = happyGoto action_12
action_7 (21) = happyGoto action_13
action_7 (22) = happyGoto action_14
action_7 (28) = happyGoto action_15
action_7 (56) = happyGoto action_16
action_7 (61) = happyGoto action_17
action_7 (74) = happyGoto action_18
action_7 (76) = happyGoto action_19
action_7 _ = happyFail

action_8 _ = happyReduce_20

action_9 (137) = happyShift action_107
action_9 (14) = happyGoto action_155
action_9 _ = happyFail

action_10 _ = happyReduce_26

action_11 _ = happyReduce_27

action_12 _ = happyReduce_28

action_13 _ = happyReduce_36

action_14 _ = happyReduce_29

action_15 (85) = happyShift action_154
action_15 _ = happyFail

action_16 _ = happyReduce_77

action_17 (77) = happyShift action_90
action_17 _ = happyReduce_76

action_18 (86) = happyShift action_23
action_18 (88) = happyShift action_24
action_18 (89) = happyShift action_25
action_18 (90) = happyShift action_26
action_18 (91) = happyShift action_27
action_18 (92) = happyShift action_28
action_18 (93) = happyShift action_29
action_18 (94) = happyShift action_30
action_18 (95) = happyShift action_31
action_18 (96) = happyShift action_32
action_18 (97) = happyShift action_33
action_18 (98) = happyShift action_34
action_18 (99) = happyShift action_35
action_18 (100) = happyShift action_36
action_18 (101) = happyShift action_37
action_18 (102) = happyShift action_38
action_18 (103) = happyShift action_39
action_18 (104) = happyShift action_40
action_18 (105) = happyShift action_41
action_18 (106) = happyShift action_42
action_18 (107) = happyShift action_43
action_18 (108) = happyShift action_44
action_18 (109) = happyShift action_45
action_18 (110) = happyShift action_46
action_18 (111) = happyShift action_47
action_18 (133) = happyShift action_48
action_18 (15) = happyGoto action_153
action_18 (16) = happyGoto action_10
action_18 (17) = happyGoto action_11
action_18 (20) = happyGoto action_12
action_18 (21) = happyGoto action_13
action_18 (22) = happyGoto action_14
action_18 (28) = happyGoto action_15
action_18 (56) = happyGoto action_16
action_18 (61) = happyGoto action_17
action_18 (76) = happyGoto action_67
action_18 _ = happyFail

action_19 (81) = happyShift action_152
action_19 (133) = happyShift action_48
action_19 (43) = happyGoto action_73
action_19 (44) = happyGoto action_74
action_19 (46) = happyGoto action_75
action_19 (49) = happyGoto action_76
action_19 (61) = happyGoto action_77
action_19 _ = happyFail

action_20 (133) = happyShift action_150
action_20 (11) = happyGoto action_151
action_20 _ = happyFail

action_21 (133) = happyShift action_150
action_21 (11) = happyGoto action_149
action_21 _ = happyFail

action_22 (137) = happyShift action_107
action_22 (14) = happyGoto action_148
action_22 _ = happyFail

action_23 (116) = happyShift action_137
action_23 (75) = happyGoto action_147
action_23 _ = happyFail

action_24 (77) = happyShift action_146
action_24 (116) = happyShift action_137
action_24 (133) = happyShift action_48
action_24 (61) = happyGoto action_142
action_24 (72) = happyGoto action_143
action_24 (73) = happyGoto action_144
action_24 (75) = happyGoto action_145
action_24 _ = happyFail

action_25 (77) = happyShift action_141
action_25 _ = happyFail

action_26 (133) = happyShift action_48
action_26 (61) = happyGoto action_140
action_26 _ = happyFail

action_27 _ = happyReduce_44

action_28 _ = happyReduce_45

action_29 (116) = happyShift action_130
action_29 (63) = happyGoto action_139
action_29 _ = happyReduce_47

action_30 (116) = happyShift action_130
action_30 (63) = happyGoto action_138
action_30 _ = happyReduce_49

action_31 (116) = happyShift action_137
action_31 (75) = happyGoto action_136
action_31 _ = happyFail

action_32 (77) = happyShift action_134
action_32 (23) = happyGoto action_135
action_32 _ = happyFail

action_33 (77) = happyShift action_134
action_33 (23) = happyGoto action_133
action_33 _ = happyFail

action_34 (116) = happyShift action_130
action_34 (133) = happyShift action_48
action_34 (24) = happyGoto action_132
action_34 (61) = happyGoto action_128
action_34 (63) = happyGoto action_129
action_34 _ = happyFail

action_35 (116) = happyShift action_130
action_35 (133) = happyShift action_48
action_35 (24) = happyGoto action_131
action_35 (61) = happyGoto action_128
action_35 (63) = happyGoto action_129
action_35 _ = happyFail

action_36 (116) = happyShift action_130
action_36 (133) = happyShift action_48
action_36 (24) = happyGoto action_127
action_36 (61) = happyGoto action_128
action_36 (63) = happyGoto action_129
action_36 _ = happyFail

action_37 (123) = happyShift action_126
action_37 (133) = happyShift action_48
action_37 (37) = happyGoto action_122
action_37 (39) = happyGoto action_123
action_37 (40) = happyGoto action_124
action_37 (41) = happyGoto action_125
action_37 (42) = happyGoto action_112
action_37 (56) = happyGoto action_113
action_37 (61) = happyGoto action_114
action_37 _ = happyFail

action_38 (77) = happyShift action_121
action_38 (36) = happyGoto action_120
action_38 _ = happyFail

action_39 (133) = happyShift action_48
action_39 (50) = happyGoto action_118
action_39 (61) = happyGoto action_119
action_39 _ = happyFail

action_40 (133) = happyShift action_48
action_40 (45) = happyGoto action_115
action_40 (46) = happyGoto action_116
action_40 (61) = happyGoto action_117
action_40 _ = happyFail

action_41 _ = happyReduce_190

action_42 _ = happyReduce_191

action_43 _ = happyReduce_192

action_44 _ = happyReduce_193

action_45 _ = happyReduce_194

action_46 (133) = happyShift action_48
action_46 (32) = happyGoto action_110
action_46 (41) = happyGoto action_111
action_46 (42) = happyGoto action_112
action_46 (56) = happyGoto action_113
action_46 (61) = happyGoto action_114
action_46 _ = happyFail

action_47 (77) = happyShift action_109
action_47 (29) = happyGoto action_108
action_47 _ = happyFail

action_48 _ = happyReduce_167

action_49 (137) = happyShift action_107
action_49 (14) = happyGoto action_106
action_49 _ = happyFail

action_50 _ = happyReduce_188

action_51 (119) = happyShift action_93
action_51 (120) = happyShift action_94
action_51 (121) = happyShift action_95
action_51 (122) = happyShift action_96
action_51 (123) = happyShift action_97
action_51 (124) = happyShift action_98
action_51 (125) = happyShift action_99
action_51 (127) = happyShift action_100
action_51 (128) = happyShift action_101
action_51 (129) = happyShift action_102
action_51 (130) = happyShift action_103
action_51 (131) = happyShift action_104
action_51 (132) = happyShift action_105
action_51 (138) = happyAccept
action_51 (55) = happyGoto action_92
action_51 _ = happyFail

action_52 _ = happyReduce_149

action_53 (77) = happyShift action_59
action_53 (80) = happyShift action_60
action_53 (116) = happyShift action_61
action_53 (118) = happyShift action_62
action_53 (119) = happyShift action_63
action_53 (120) = happyShift action_64
action_53 (126) = happyShift action_65
action_53 (133) = happyShift action_48
action_53 (54) = happyGoto action_91
action_53 (56) = happyGoto action_52
action_53 (58) = happyGoto action_53
action_53 (61) = happyGoto action_54
action_53 (63) = happyGoto action_55
action_53 (65) = happyGoto action_56
action_53 (69) = happyGoto action_57
action_53 (70) = happyGoto action_58
action_53 _ = happyFail

action_54 (77) = happyShift action_90
action_54 _ = happyReduce_150

action_55 _ = happyReduce_145

action_56 _ = happyReduce_146

action_57 _ = happyReduce_147

action_58 _ = happyReduce_148

action_59 (77) = happyShift action_59
action_59 (80) = happyShift action_60
action_59 (116) = happyShift action_61
action_59 (118) = happyShift action_62
action_59 (119) = happyShift action_63
action_59 (120) = happyShift action_64
action_59 (126) = happyShift action_65
action_59 (133) = happyShift action_48
action_59 (54) = happyGoto action_83
action_59 (56) = happyGoto action_52
action_59 (58) = happyGoto action_84
action_59 (61) = happyGoto action_54
action_59 (62) = happyGoto action_85
action_59 (63) = happyGoto action_86
action_59 (64) = happyGoto action_87
action_59 (65) = happyGoto action_88
action_59 (68) = happyGoto action_89
action_59 (69) = happyGoto action_57
action_59 (70) = happyGoto action_58
action_59 _ = happyFail

action_60 (116) = happyShift action_82
action_60 _ = happyFail

action_61 (80) = happyShift action_80
action_61 (117) = happyShift action_81
action_61 (67) = happyGoto action_79
action_61 _ = happyReduce_170

action_62 _ = happyReduce_183

action_63 _ = happyReduce_162

action_64 _ = happyReduce_161

action_65 (77) = happyShift action_59
action_65 (80) = happyShift action_60
action_65 (116) = happyShift action_61
action_65 (118) = happyShift action_62
action_65 (119) = happyShift action_63
action_65 (120) = happyShift action_64
action_65 (126) = happyShift action_65
action_65 (133) = happyShift action_48
action_65 (54) = happyGoto action_78
action_65 (56) = happyGoto action_52
action_65 (58) = happyGoto action_53
action_65 (61) = happyGoto action_54
action_65 (63) = happyGoto action_55
action_65 (65) = happyGoto action_56
action_65 (69) = happyGoto action_57
action_65 (70) = happyGoto action_58
action_65 _ = happyFail

action_66 (138) = happyAccept
action_66 _ = happyFail

action_67 (133) = happyShift action_48
action_67 (43) = happyGoto action_73
action_67 (44) = happyGoto action_74
action_67 (46) = happyGoto action_75
action_67 (49) = happyGoto action_76
action_67 (61) = happyGoto action_77
action_67 _ = happyFail

action_68 (138) = happyAccept
action_68 _ = happyFail

action_69 (81) = happyShift action_20
action_69 (82) = happyShift action_21
action_69 (83) = happyShift action_22
action_69 (86) = happyShift action_23
action_69 (88) = happyShift action_24
action_69 (89) = happyShift action_25
action_69 (90) = happyShift action_26
action_69 (91) = happyShift action_27
action_69 (92) = happyShift action_28
action_69 (93) = happyShift action_29
action_69 (94) = happyShift action_30
action_69 (95) = happyShift action_31
action_69 (96) = happyShift action_32
action_69 (97) = happyShift action_33
action_69 (98) = happyShift action_34
action_69 (99) = happyShift action_35
action_69 (100) = happyShift action_36
action_69 (101) = happyShift action_37
action_69 (102) = happyShift action_38
action_69 (103) = happyShift action_39
action_69 (104) = happyShift action_40
action_69 (105) = happyShift action_41
action_69 (106) = happyShift action_42
action_69 (107) = happyShift action_43
action_69 (108) = happyShift action_44
action_69 (109) = happyShift action_45
action_69 (110) = happyShift action_46
action_69 (111) = happyShift action_47
action_69 (133) = happyShift action_48
action_69 (134) = happyShift action_49
action_69 (136) = happyShift action_50
action_69 (8) = happyGoto action_70
action_69 (9) = happyGoto action_71
action_69 (12) = happyGoto action_72
action_69 (13) = happyGoto action_8
action_69 (15) = happyGoto action_9
action_69 (16) = happyGoto action_10
action_69 (17) = happyGoto action_11
action_69 (20) = happyGoto action_12
action_69 (21) = happyGoto action_13
action_69 (22) = happyGoto action_14
action_69 (28) = happyGoto action_15
action_69 (56) = happyGoto action_16
action_69 (61) = happyGoto action_17
action_69 (74) = happyGoto action_18
action_69 (76) = happyGoto action_19
action_69 _ = happyReduce_3

action_70 _ = happyReduce_5

action_71 _ = happyReduce_6

action_72 (81) = happyShift action_20
action_72 (82) = happyShift action_21
action_72 (83) = happyShift action_22
action_72 (84) = happyShift action_158
action_72 (86) = happyShift action_23
action_72 (88) = happyShift action_24
action_72 (89) = happyShift action_25
action_72 (90) = happyShift action_26
action_72 (91) = happyShift action_27
action_72 (92) = happyShift action_28
action_72 (93) = happyShift action_29
action_72 (94) = happyShift action_30
action_72 (95) = happyShift action_31
action_72 (96) = happyShift action_32
action_72 (97) = happyShift action_33
action_72 (98) = happyShift action_34
action_72 (99) = happyShift action_35
action_72 (100) = happyShift action_36
action_72 (101) = happyShift action_37
action_72 (102) = happyShift action_38
action_72 (103) = happyShift action_39
action_72 (104) = happyShift action_40
action_72 (105) = happyShift action_41
action_72 (106) = happyShift action_42
action_72 (107) = happyShift action_43
action_72 (108) = happyShift action_44
action_72 (109) = happyShift action_45
action_72 (110) = happyShift action_46
action_72 (111) = happyShift action_47
action_72 (133) = happyShift action_48
action_72 (134) = happyShift action_49
action_72 (136) = happyShift action_50
action_72 (9) = happyGoto action_160
action_72 (13) = happyGoto action_157
action_72 (15) = happyGoto action_9
action_72 (16) = happyGoto action_10
action_72 (17) = happyGoto action_11
action_72 (20) = happyGoto action_12
action_72 (21) = happyGoto action_13
action_72 (22) = happyGoto action_14
action_72 (28) = happyGoto action_15
action_72 (56) = happyGoto action_16
action_72 (61) = happyGoto action_17
action_72 (74) = happyGoto action_18
action_72 (76) = happyGoto action_19
action_72 _ = happyReduce_4

action_73 (79) = happyShift action_229
action_73 _ = happyReduce_62

action_74 _ = happyReduce_116

action_75 _ = happyReduce_117

action_76 _ = happyReduce_118

action_77 (77) = happyShift action_193
action_77 _ = happyReduce_125

action_78 (119) = happyShift action_93
action_78 (120) = happyShift action_94
action_78 (121) = happyShift action_95
action_78 (122) = happyShift action_96
action_78 (123) = happyShift action_97
action_78 (127) = happyShift action_100
action_78 (128) = happyShift action_101
action_78 (129) = happyShift action_102
action_78 (130) = happyShift action_103
action_78 (131) = happyShift action_104
action_78 (132) = happyShift action_105
action_78 (55) = happyGoto action_92
action_78 _ = happyReduce_142

action_79 _ = happyReduce_173

action_80 (116) = happyShift action_228
action_80 (117) = happyShift action_81
action_80 (66) = happyGoto action_227
action_80 (67) = happyGoto action_226
action_80 _ = happyReduce_178

action_81 _ = happyReduce_179

action_82 (117) = happyShift action_81
action_82 (66) = happyGoto action_225
action_82 (67) = happyGoto action_226
action_82 _ = happyReduce_178

action_83 (78) = happyShift action_224
action_83 (119) = happyShift action_93
action_83 (120) = happyShift action_94
action_83 (121) = happyShift action_95
action_83 (122) = happyShift action_96
action_83 (123) = happyShift action_97
action_83 (124) = happyShift action_98
action_83 (125) = happyShift action_99
action_83 (127) = happyShift action_100
action_83 (128) = happyShift action_101
action_83 (129) = happyShift action_102
action_83 (130) = happyShift action_103
action_83 (131) = happyShift action_104
action_83 (132) = happyShift action_105
action_83 (55) = happyGoto action_92
action_83 _ = happyFail

action_84 (77) = happyShift action_59
action_84 (80) = happyShift action_60
action_84 (116) = happyShift action_61
action_84 (118) = happyShift action_62
action_84 (119) = happyShift action_63
action_84 (120) = happyShift action_64
action_84 (126) = happyShift action_65
action_84 (133) = happyShift action_48
action_84 (54) = happyGoto action_91
action_84 (56) = happyGoto action_52
action_84 (58) = happyGoto action_53
action_84 (61) = happyGoto action_54
action_84 (63) = happyGoto action_222
action_84 (65) = happyGoto action_223
action_84 (69) = happyGoto action_57
action_84 (70) = happyGoto action_58
action_84 _ = happyFail

action_85 _ = happyReduce_180

action_86 (79) = happyReduce_169
action_86 _ = happyReduce_145

action_87 _ = happyReduce_181

action_88 (79) = happyReduce_172
action_88 _ = happyReduce_146

action_89 (79) = happyShift action_221
action_89 _ = happyFail

action_90 (77) = happyShift action_59
action_90 (78) = happyShift action_220
action_90 (80) = happyShift action_60
action_90 (116) = happyShift action_61
action_90 (118) = happyShift action_62
action_90 (119) = happyShift action_63
action_90 (120) = happyShift action_64
action_90 (126) = happyShift action_65
action_90 (133) = happyShift action_48
action_90 (54) = happyGoto action_218
action_90 (56) = happyGoto action_52
action_90 (57) = happyGoto action_219
action_90 (58) = happyGoto action_53
action_90 (61) = happyGoto action_54
action_90 (63) = happyGoto action_55
action_90 (65) = happyGoto action_56
action_90 (69) = happyGoto action_57
action_90 (70) = happyGoto action_58
action_90 _ = happyFail

action_91 (121) = happyShift action_95
action_91 (55) = happyGoto action_92
action_91 _ = happyReduce_139

action_92 (77) = happyShift action_59
action_92 (80) = happyShift action_60
action_92 (116) = happyShift action_61
action_92 (118) = happyShift action_62
action_92 (119) = happyShift action_63
action_92 (120) = happyShift action_64
action_92 (126) = happyShift action_65
action_92 (133) = happyShift action_48
action_92 (54) = happyGoto action_217
action_92 (56) = happyGoto action_52
action_92 (58) = happyGoto action_53
action_92 (61) = happyGoto action_54
action_92 (63) = happyGoto action_55
action_92 (65) = happyGoto action_56
action_92 (69) = happyGoto action_57
action_92 (70) = happyGoto action_58
action_92 _ = happyFail

action_93 (77) = happyShift action_59
action_93 (80) = happyShift action_60
action_93 (116) = happyShift action_61
action_93 (118) = happyShift action_62
action_93 (119) = happyShift action_63
action_93 (120) = happyShift action_64
action_93 (126) = happyShift action_65
action_93 (133) = happyShift action_48
action_93 (54) = happyGoto action_216
action_93 (56) = happyGoto action_52
action_93 (58) = happyGoto action_53
action_93 (61) = happyGoto action_54
action_93 (63) = happyGoto action_55
action_93 (65) = happyGoto action_56
action_93 (69) = happyGoto action_57
action_93 (70) = happyGoto action_58
action_93 _ = happyFail

action_94 (77) = happyShift action_59
action_94 (80) = happyShift action_60
action_94 (116) = happyShift action_61
action_94 (118) = happyShift action_62
action_94 (119) = happyShift action_63
action_94 (120) = happyShift action_64
action_94 (126) = happyShift action_65
action_94 (133) = happyShift action_48
action_94 (54) = happyGoto action_215
action_94 (56) = happyGoto action_52
action_94 (58) = happyGoto action_53
action_94 (61) = happyGoto action_54
action_94 (63) = happyGoto action_55
action_94 (65) = happyGoto action_56
action_94 (69) = happyGoto action_57
action_94 (70) = happyGoto action_58
action_94 _ = happyFail

action_95 (77) = happyShift action_59
action_95 (80) = happyShift action_60
action_95 (116) = happyShift action_61
action_95 (118) = happyShift action_62
action_95 (119) = happyShift action_63
action_95 (120) = happyShift action_64
action_95 (126) = happyShift action_65
action_95 (133) = happyShift action_48
action_95 (54) = happyGoto action_214
action_95 (56) = happyGoto action_52
action_95 (58) = happyGoto action_53
action_95 (61) = happyGoto action_54
action_95 (63) = happyGoto action_55
action_95 (65) = happyGoto action_56
action_95 (69) = happyGoto action_57
action_95 (70) = happyGoto action_58
action_95 _ = happyFail

action_96 (77) = happyShift action_59
action_96 (80) = happyShift action_60
action_96 (116) = happyShift action_61
action_96 (118) = happyShift action_62
action_96 (119) = happyShift action_63
action_96 (120) = happyShift action_64
action_96 (126) = happyShift action_65
action_96 (133) = happyShift action_48
action_96 (54) = happyGoto action_213
action_96 (56) = happyGoto action_52
action_96 (58) = happyGoto action_53
action_96 (61) = happyGoto action_54
action_96 (63) = happyGoto action_55
action_96 (65) = happyGoto action_56
action_96 (69) = happyGoto action_57
action_96 (70) = happyGoto action_58
action_96 _ = happyFail

action_97 (77) = happyShift action_59
action_97 (80) = happyShift action_60
action_97 (116) = happyShift action_61
action_97 (118) = happyShift action_62
action_97 (119) = happyShift action_63
action_97 (120) = happyShift action_64
action_97 (126) = happyShift action_65
action_97 (133) = happyShift action_48
action_97 (54) = happyGoto action_212
action_97 (56) = happyGoto action_52
action_97 (58) = happyGoto action_53
action_97 (61) = happyGoto action_54
action_97 (63) = happyGoto action_55
action_97 (65) = happyGoto action_56
action_97 (69) = happyGoto action_57
action_97 (70) = happyGoto action_58
action_97 _ = happyFail

action_98 (77) = happyShift action_59
action_98 (80) = happyShift action_60
action_98 (116) = happyShift action_61
action_98 (118) = happyShift action_62
action_98 (119) = happyShift action_63
action_98 (120) = happyShift action_64
action_98 (126) = happyShift action_65
action_98 (133) = happyShift action_48
action_98 (54) = happyGoto action_211
action_98 (56) = happyGoto action_52
action_98 (58) = happyGoto action_53
action_98 (61) = happyGoto action_54
action_98 (63) = happyGoto action_55
action_98 (65) = happyGoto action_56
action_98 (69) = happyGoto action_57
action_98 (70) = happyGoto action_58
action_98 _ = happyFail

action_99 (77) = happyShift action_59
action_99 (80) = happyShift action_60
action_99 (116) = happyShift action_61
action_99 (118) = happyShift action_62
action_99 (119) = happyShift action_63
action_99 (120) = happyShift action_64
action_99 (126) = happyShift action_65
action_99 (133) = happyShift action_48
action_99 (54) = happyGoto action_210
action_99 (56) = happyGoto action_52
action_99 (58) = happyGoto action_53
action_99 (61) = happyGoto action_54
action_99 (63) = happyGoto action_55
action_99 (65) = happyGoto action_56
action_99 (69) = happyGoto action_57
action_99 (70) = happyGoto action_58
action_99 _ = happyFail

action_100 _ = happyReduce_155

action_101 _ = happyReduce_156

action_102 _ = happyReduce_153

action_103 _ = happyReduce_154

action_104 _ = happyReduce_151

action_105 _ = happyReduce_152

action_106 (137) = happyShift action_162
action_106 _ = happyReduce_23

action_107 _ = happyReduce_25

action_108 (77) = happyShift action_109
action_108 (78) = happyShift action_201
action_108 (79) = happyShift action_202
action_108 (112) = happyShift action_203
action_108 (113) = happyShift action_204
action_108 (114) = happyShift action_205
action_108 (115) = happyShift action_206
action_108 (116) = happyShift action_207
action_108 (123) = happyShift action_208
action_108 (135) = happyShift action_209
action_108 (29) = happyGoto action_197
action_108 (30) = happyGoto action_198
action_108 (31) = happyGoto action_199
action_108 (71) = happyGoto action_200
action_108 _ = happyFail

action_109 _ = happyReduce_82

action_110 (79) = happyShift action_196
action_110 _ = happyReduce_60

action_111 (79) = happyShift action_185
action_111 (123) = happyShift action_195
action_111 _ = happyFail

action_112 _ = happyReduce_112

action_113 _ = happyReduce_114

action_114 (77) = happyShift action_90
action_114 _ = happyReduce_113

action_115 (79) = happyShift action_194
action_115 _ = happyReduce_57

action_116 _ = happyReduce_120

action_117 (77) = happyShift action_193
action_117 _ = happyFail

action_118 (79) = happyShift action_192
action_118 _ = happyReduce_56

action_119 _ = happyReduce_127

action_120 (79) = happyShift action_191
action_120 _ = happyReduce_59

action_121 (133) = happyShift action_48
action_121 (41) = happyGoto action_190
action_121 (42) = happyGoto action_112
action_121 (56) = happyGoto action_113
action_121 (61) = happyGoto action_114
action_121 _ = happyFail

action_122 (123) = happyShift action_189
action_122 (38) = happyGoto action_187
action_122 (40) = happyGoto action_188
action_122 _ = happyReduce_58

action_123 _ = happyReduce_104

action_124 (133) = happyShift action_48
action_124 (41) = happyGoto action_186
action_124 (42) = happyGoto action_112
action_124 (56) = happyGoto action_113
action_124 (61) = happyGoto action_114
action_124 _ = happyFail

action_125 (79) = happyShift action_185
action_125 _ = happyReduce_109

action_126 (123) = happyShift action_184
action_126 (133) = happyShift action_48
action_126 (61) = happyGoto action_183
action_126 _ = happyFail

action_127 _ = happyReduce_52

action_128 _ = happyReduce_68

action_129 _ = happyReduce_67

action_130 _ = happyReduce_170

action_131 _ = happyReduce_51

action_132 _ = happyReduce_50

action_133 _ = happyReduce_53

action_134 (116) = happyShift action_130
action_134 (133) = happyShift action_48
action_134 (24) = happyGoto action_182
action_134 (61) = happyGoto action_128
action_134 (63) = happyGoto action_129
action_134 _ = happyFail

action_135 _ = happyReduce_54

action_136 (133) = happyShift action_48
action_136 (18) = happyGoto action_180
action_136 (21) = happyGoto action_181
action_136 (28) = happyGoto action_15
action_136 (56) = happyGoto action_16
action_136 (61) = happyGoto action_17
action_136 _ = happyFail

action_137 _ = happyReduce_189

action_138 _ = happyReduce_48

action_139 _ = happyReduce_46

action_140 (77) = happyShift action_179
action_140 (51) = happyGoto action_177
action_140 (52) = happyGoto action_178
action_140 _ = happyReduce_43

action_141 (77) = happyShift action_59
action_141 (80) = happyShift action_60
action_141 (116) = happyShift action_61
action_141 (118) = happyShift action_62
action_141 (119) = happyShift action_63
action_141 (120) = happyShift action_64
action_141 (126) = happyShift action_65
action_141 (133) = happyShift action_48
action_141 (54) = happyGoto action_176
action_141 (56) = happyGoto action_52
action_141 (58) = happyGoto action_53
action_141 (61) = happyGoto action_54
action_141 (63) = happyGoto action_55
action_141 (65) = happyGoto action_56
action_141 (69) = happyGoto action_57
action_141 (70) = happyGoto action_58
action_141 _ = happyFail

action_142 (77) = happyShift action_146
action_142 (72) = happyGoto action_175
action_142 (73) = happyGoto action_144
action_142 _ = happyFail

action_143 (133) = happyShift action_48
action_143 (61) = happyGoto action_174
action_143 _ = happyFail

action_144 (78) = happyShift action_172
action_144 (79) = happyShift action_173
action_144 _ = happyFail

action_145 _ = happyReduce_38

action_146 (116) = happyShift action_137
action_146 (75) = happyGoto action_171
action_146 _ = happyFail

action_147 (87) = happyShift action_170
action_147 _ = happyFail

action_148 (86) = happyShift action_23
action_148 (88) = happyShift action_24
action_148 (89) = happyShift action_25
action_148 (90) = happyShift action_26
action_148 (91) = happyShift action_27
action_148 (92) = happyShift action_28
action_148 (93) = happyShift action_29
action_148 (94) = happyShift action_30
action_148 (95) = happyShift action_31
action_148 (96) = happyShift action_32
action_148 (97) = happyShift action_33
action_148 (98) = happyShift action_34
action_148 (99) = happyShift action_35
action_148 (100) = happyShift action_36
action_148 (101) = happyShift action_37
action_148 (102) = happyShift action_38
action_148 (103) = happyShift action_39
action_148 (104) = happyShift action_40
action_148 (105) = happyShift action_41
action_148 (106) = happyShift action_42
action_148 (107) = happyShift action_43
action_148 (108) = happyShift action_44
action_148 (109) = happyShift action_45
action_148 (110) = happyShift action_46
action_148 (111) = happyShift action_47
action_148 (133) = happyShift action_48
action_148 (134) = happyShift action_49
action_148 (136) = happyShift action_50
action_148 (137) = happyShift action_162
action_148 (12) = happyGoto action_169
action_148 (13) = happyGoto action_8
action_148 (15) = happyGoto action_9
action_148 (16) = happyGoto action_10
action_148 (17) = happyGoto action_11
action_148 (20) = happyGoto action_12
action_148 (21) = happyGoto action_13
action_148 (22) = happyGoto action_14
action_148 (28) = happyGoto action_15
action_148 (56) = happyGoto action_16
action_148 (61) = happyGoto action_17
action_148 (74) = happyGoto action_18
action_148 (76) = happyGoto action_67
action_148 _ = happyFail

action_149 (77) = happyShift action_167
action_149 (10) = happyGoto action_168
action_149 _ = happyReduce_17

action_150 _ = happyReduce_18

action_151 (77) = happyShift action_167
action_151 (10) = happyGoto action_166
action_151 _ = happyReduce_17

action_152 (133) = happyShift action_150
action_152 (11) = happyGoto action_165
action_152 _ = happyFail

action_153 (137) = happyShift action_107
action_153 (14) = happyGoto action_164
action_153 _ = happyFail

action_154 (77) = happyShift action_59
action_154 (80) = happyShift action_60
action_154 (116) = happyShift action_61
action_154 (118) = happyShift action_62
action_154 (119) = happyShift action_63
action_154 (120) = happyShift action_64
action_154 (126) = happyShift action_65
action_154 (133) = happyShift action_48
action_154 (54) = happyGoto action_163
action_154 (56) = happyGoto action_52
action_154 (58) = happyGoto action_53
action_154 (61) = happyGoto action_54
action_154 (63) = happyGoto action_55
action_154 (65) = happyGoto action_56
action_154 (69) = happyGoto action_57
action_154 (70) = happyGoto action_58
action_154 _ = happyFail

action_155 (137) = happyShift action_162
action_155 _ = happyReduce_22

action_156 _ = happyReduce_10

action_157 _ = happyReduce_19

action_158 (137) = happyShift action_107
action_158 (14) = happyGoto action_161
action_158 _ = happyFail

action_159 (81) = happyShift action_20
action_159 (82) = happyShift action_21
action_159 (83) = happyShift action_22
action_159 (84) = happyShift action_158
action_159 (86) = happyShift action_23
action_159 (88) = happyShift action_24
action_159 (89) = happyShift action_25
action_159 (90) = happyShift action_26
action_159 (91) = happyShift action_27
action_159 (92) = happyShift action_28
action_159 (93) = happyShift action_29
action_159 (94) = happyShift action_30
action_159 (95) = happyShift action_31
action_159 (96) = happyShift action_32
action_159 (97) = happyShift action_33
action_159 (98) = happyShift action_34
action_159 (99) = happyShift action_35
action_159 (100) = happyShift action_36
action_159 (101) = happyShift action_37
action_159 (102) = happyShift action_38
action_159 (103) = happyShift action_39
action_159 (104) = happyShift action_40
action_159 (105) = happyShift action_41
action_159 (106) = happyShift action_42
action_159 (107) = happyShift action_43
action_159 (108) = happyShift action_44
action_159 (109) = happyShift action_45
action_159 (110) = happyShift action_46
action_159 (111) = happyShift action_47
action_159 (133) = happyShift action_48
action_159 (134) = happyShift action_49
action_159 (136) = happyShift action_50
action_159 (9) = happyGoto action_160
action_159 (13) = happyGoto action_157
action_159 (15) = happyGoto action_9
action_159 (16) = happyGoto action_10
action_159 (17) = happyGoto action_11
action_159 (20) = happyGoto action_12
action_159 (21) = happyGoto action_13
action_159 (22) = happyGoto action_14
action_159 (28) = happyGoto action_15
action_159 (56) = happyGoto action_16
action_159 (61) = happyGoto action_17
action_159 (74) = happyGoto action_18
action_159 (76) = happyGoto action_19
action_159 _ = happyFail

action_160 _ = happyReduce_7

action_161 (137) = happyShift action_162
action_161 _ = happyReduce_11

action_162 _ = happyReduce_24

action_163 (119) = happyShift action_93
action_163 (120) = happyShift action_94
action_163 (121) = happyShift action_95
action_163 (122) = happyShift action_96
action_163 (123) = happyShift action_97
action_163 (124) = happyShift action_98
action_163 (125) = happyShift action_99
action_163 (127) = happyShift action_100
action_163 (128) = happyShift action_101
action_163 (129) = happyShift action_102
action_163 (130) = happyShift action_103
action_163 (131) = happyShift action_104
action_163 (132) = happyShift action_105
action_163 (55) = happyGoto action_92
action_163 _ = happyReduce_55

action_164 (137) = happyShift action_162
action_164 _ = happyReduce_21

action_165 (77) = happyShift action_167
action_165 (10) = happyGoto action_281
action_165 _ = happyReduce_17

action_166 (137) = happyShift action_107
action_166 (14) = happyGoto action_280
action_166 _ = happyFail

action_167 (133) = happyShift action_48
action_167 (59) = happyGoto action_277
action_167 (60) = happyGoto action_278
action_167 (61) = happyGoto action_279
action_167 _ = happyReduce_164

action_168 (137) = happyShift action_107
action_168 (14) = happyGoto action_276
action_168 _ = happyFail

action_169 (84) = happyShift action_275
action_169 (86) = happyShift action_23
action_169 (88) = happyShift action_24
action_169 (89) = happyShift action_25
action_169 (90) = happyShift action_26
action_169 (91) = happyShift action_27
action_169 (92) = happyShift action_28
action_169 (93) = happyShift action_29
action_169 (94) = happyShift action_30
action_169 (95) = happyShift action_31
action_169 (96) = happyShift action_32
action_169 (97) = happyShift action_33
action_169 (98) = happyShift action_34
action_169 (99) = happyShift action_35
action_169 (100) = happyShift action_36
action_169 (101) = happyShift action_37
action_169 (102) = happyShift action_38
action_169 (103) = happyShift action_39
action_169 (104) = happyShift action_40
action_169 (105) = happyShift action_41
action_169 (106) = happyShift action_42
action_169 (107) = happyShift action_43
action_169 (108) = happyShift action_44
action_169 (109) = happyShift action_45
action_169 (110) = happyShift action_46
action_169 (111) = happyShift action_47
action_169 (133) = happyShift action_48
action_169 (134) = happyShift action_49
action_169 (136) = happyShift action_50
action_169 (13) = happyGoto action_157
action_169 (15) = happyGoto action_9
action_169 (16) = happyGoto action_10
action_169 (17) = happyGoto action_11
action_169 (20) = happyGoto action_12
action_169 (21) = happyGoto action_13
action_169 (22) = happyGoto action_14
action_169 (28) = happyGoto action_15
action_169 (56) = happyGoto action_16
action_169 (61) = happyGoto action_17
action_169 (74) = happyGoto action_18
action_169 (76) = happyGoto action_67
action_169 _ = happyFail

action_170 (133) = happyShift action_48
action_170 (61) = happyGoto action_274
action_170 _ = happyFail

action_171 _ = happyReduce_187

action_172 _ = happyReduce_185

action_173 (116) = happyShift action_137
action_173 (75) = happyGoto action_273
action_173 _ = happyFail

action_174 _ = happyReduce_40

action_175 _ = happyReduce_39

action_176 (78) = happyShift action_272
action_176 (119) = happyShift action_93
action_176 (120) = happyShift action_94
action_176 (121) = happyShift action_95
action_176 (122) = happyShift action_96
action_176 (123) = happyShift action_97
action_176 (124) = happyShift action_98
action_176 (125) = happyShift action_99
action_176 (127) = happyShift action_100
action_176 (128) = happyShift action_101
action_176 (129) = happyShift action_102
action_176 (130) = happyShift action_103
action_176 (131) = happyShift action_104
action_176 (132) = happyShift action_105
action_176 (55) = happyGoto action_92
action_176 _ = happyFail

action_177 _ = happyReduce_42

action_178 (78) = happyShift action_270
action_178 (79) = happyShift action_271
action_178 _ = happyFail

action_179 (77) = happyShift action_59
action_179 (80) = happyShift action_60
action_179 (116) = happyShift action_61
action_179 (118) = happyShift action_62
action_179 (119) = happyShift action_63
action_179 (120) = happyShift action_64
action_179 (126) = happyShift action_65
action_179 (133) = happyShift action_48
action_179 (135) = happyShift action_209
action_179 (53) = happyGoto action_267
action_179 (54) = happyGoto action_268
action_179 (56) = happyGoto action_52
action_179 (58) = happyGoto action_53
action_179 (61) = happyGoto action_54
action_179 (63) = happyGoto action_55
action_179 (65) = happyGoto action_56
action_179 (69) = happyGoto action_57
action_179 (70) = happyGoto action_58
action_179 (71) = happyGoto action_269
action_179 _ = happyReduce_131

action_180 _ = happyReduce_31

action_181 (79) = happyShift action_266
action_181 _ = happyFail

action_182 (78) = happyShift action_264
action_182 (79) = happyShift action_265
action_182 _ = happyFail

action_183 (123) = happyShift action_263
action_183 _ = happyFail

action_184 (133) = happyShift action_48
action_184 (41) = happyGoto action_262
action_184 (42) = happyGoto action_112
action_184 (56) = happyGoto action_113
action_184 (61) = happyGoto action_114
action_184 _ = happyFail

action_185 (133) = happyShift action_48
action_185 (42) = happyGoto action_261
action_185 (56) = happyGoto action_113
action_185 (61) = happyGoto action_114
action_185 _ = happyFail

action_186 (79) = happyShift action_185
action_186 _ = happyReduce_107

action_187 _ = happyReduce_103

action_188 (133) = happyShift action_48
action_188 (41) = happyGoto action_260
action_188 (42) = happyGoto action_112
action_188 (56) = happyGoto action_113
action_188 (61) = happyGoto action_114
action_188 _ = happyFail

action_189 (123) = happyShift action_259
action_189 (133) = happyShift action_48
action_189 (61) = happyGoto action_183
action_189 _ = happyFail

action_190 (78) = happyShift action_258
action_190 (79) = happyShift action_185
action_190 _ = happyFail

action_191 (77) = happyShift action_257
action_191 _ = happyFail

action_192 (133) = happyShift action_48
action_192 (61) = happyGoto action_256
action_192 _ = happyFail

action_193 (77) = happyShift action_59
action_193 (80) = happyShift action_60
action_193 (116) = happyShift action_61
action_193 (118) = happyShift action_62
action_193 (119) = happyShift action_63
action_193 (120) = happyShift action_64
action_193 (126) = happyShift action_65
action_193 (133) = happyShift action_48
action_193 (47) = happyGoto action_253
action_193 (48) = happyGoto action_254
action_193 (54) = happyGoto action_255
action_193 (56) = happyGoto action_52
action_193 (58) = happyGoto action_53
action_193 (61) = happyGoto action_54
action_193 (63) = happyGoto action_55
action_193 (65) = happyGoto action_56
action_193 (69) = happyGoto action_57
action_193 (70) = happyGoto action_58
action_193 _ = happyFail

action_194 (133) = happyShift action_48
action_194 (46) = happyGoto action_252
action_194 (61) = happyGoto action_117
action_194 _ = happyFail

action_195 (77) = happyShift action_251
action_195 (80) = happyShift action_60
action_195 (116) = happyShift action_61
action_195 (118) = happyShift action_62
action_195 (119) = happyShift action_63
action_195 (120) = happyShift action_64
action_195 (135) = happyShift action_209
action_195 (33) = happyGoto action_243
action_195 (34) = happyGoto action_244
action_195 (35) = happyGoto action_245
action_195 (58) = happyGoto action_232
action_195 (62) = happyGoto action_85
action_195 (63) = happyGoto action_246
action_195 (64) = happyGoto action_87
action_195 (65) = happyGoto action_234
action_195 (68) = happyGoto action_247
action_195 (69) = happyGoto action_248
action_195 (70) = happyGoto action_249
action_195 (71) = happyGoto action_250
action_195 _ = happyFail

action_196 (133) = happyShift action_48
action_196 (41) = happyGoto action_242
action_196 (42) = happyGoto action_112
action_196 (56) = happyGoto action_113
action_196 (61) = happyGoto action_114
action_196 _ = happyFail

action_197 (77) = happyShift action_109
action_197 (78) = happyShift action_241
action_197 (79) = happyShift action_202
action_197 (112) = happyShift action_203
action_197 (113) = happyShift action_204
action_197 (114) = happyShift action_205
action_197 (115) = happyShift action_206
action_197 (116) = happyShift action_207
action_197 (123) = happyShift action_208
action_197 (135) = happyShift action_209
action_197 (29) = happyGoto action_197
action_197 (30) = happyGoto action_198
action_197 (31) = happyGoto action_199
action_197 (71) = happyGoto action_200
action_197 _ = happyFail

action_198 _ = happyReduce_81

action_199 _ = happyReduce_80

action_200 _ = happyReduce_86

action_201 _ = happyReduce_61

action_202 (77) = happyShift action_109
action_202 (112) = happyShift action_203
action_202 (113) = happyShift action_204
action_202 (114) = happyShift action_205
action_202 (115) = happyShift action_206
action_202 (116) = happyShift action_207
action_202 (123) = happyShift action_208
action_202 (135) = happyShift action_209
action_202 (29) = happyGoto action_197
action_202 (30) = happyGoto action_239
action_202 (31) = happyGoto action_240
action_202 (71) = happyGoto action_200
action_202 _ = happyFail

action_203 _ = happyReduce_87

action_204 _ = happyReduce_88

action_205 _ = happyReduce_89

action_206 _ = happyReduce_90

action_207 (77) = happyShift action_109
action_207 (29) = happyGoto action_238
action_207 _ = happyFail

action_208 _ = happyReduce_83

action_209 _ = happyReduce_184

action_210 (119) = happyShift action_93
action_210 (120) = happyShift action_94
action_210 (121) = happyShift action_95
action_210 (122) = happyShift action_96
action_210 (123) = happyShift action_97
action_210 (127) = happyShift action_100
action_210 (128) = happyShift action_101
action_210 (129) = happyShift action_102
action_210 (130) = happyShift action_103
action_210 (131) = happyShift action_104
action_210 (132) = happyShift action_105
action_210 (55) = happyGoto action_92
action_210 _ = happyReduce_141

action_211 (119) = happyShift action_93
action_211 (120) = happyShift action_94
action_211 (121) = happyShift action_95
action_211 (122) = happyShift action_96
action_211 (123) = happyShift action_97
action_211 (125) = happyShift action_99
action_211 (127) = happyShift action_100
action_211 (128) = happyShift action_101
action_211 (129) = happyShift action_102
action_211 (130) = happyShift action_103
action_211 (131) = happyShift action_104
action_211 (132) = happyShift action_105
action_211 (55) = happyGoto action_92
action_211 _ = happyReduce_140

action_212 (121) = happyShift action_95
action_212 (55) = happyGoto action_92
action_212 _ = happyReduce_137

action_213 (121) = happyShift action_95
action_213 (55) = happyGoto action_92
action_213 _ = happyReduce_136

action_214 (121) = happyShift action_95
action_214 (55) = happyGoto action_92
action_214 _ = happyReduce_138

action_215 (121) = happyShift action_95
action_215 (122) = happyShift action_96
action_215 (123) = happyShift action_97
action_215 (55) = happyGoto action_92
action_215 _ = happyReduce_135

action_216 (121) = happyShift action_95
action_216 (122) = happyShift action_96
action_216 (123) = happyShift action_97
action_216 (55) = happyGoto action_92
action_216 _ = happyReduce_134

action_217 (119) = happyShift action_93
action_217 (120) = happyShift action_94
action_217 (121) = happyShift action_95
action_217 (122) = happyShift action_96
action_217 (123) = happyShift action_97
action_217 (55) = happyGoto action_92
action_217 _ = happyReduce_143

action_218 (119) = happyShift action_93
action_218 (120) = happyShift action_94
action_218 (121) = happyShift action_95
action_218 (122) = happyShift action_96
action_218 (123) = happyShift action_97
action_218 (124) = happyShift action_98
action_218 (125) = happyShift action_99
action_218 (127) = happyShift action_100
action_218 (128) = happyShift action_101
action_218 (129) = happyShift action_102
action_218 (130) = happyShift action_103
action_218 (131) = happyShift action_104
action_218 (132) = happyShift action_105
action_218 (55) = happyGoto action_92
action_218 _ = happyReduce_160

action_219 (78) = happyShift action_236
action_219 (79) = happyShift action_237
action_219 _ = happyFail

action_220 _ = happyReduce_157

action_221 (80) = happyShift action_60
action_221 (116) = happyShift action_61
action_221 (119) = happyShift action_63
action_221 (120) = happyShift action_64
action_221 (58) = happyGoto action_232
action_221 (62) = happyGoto action_85
action_221 (63) = happyGoto action_233
action_221 (64) = happyGoto action_87
action_221 (65) = happyGoto action_234
action_221 (68) = happyGoto action_235
action_221 _ = happyFail

action_222 (79) = happyReduce_168
action_222 _ = happyReduce_145

action_223 (79) = happyReduce_171
action_223 _ = happyReduce_146

action_224 _ = happyReduce_144

action_225 _ = happyReduce_175

action_226 _ = happyReduce_177

action_227 _ = happyReduce_174

action_228 (117) = happyShift action_81
action_228 (66) = happyGoto action_231
action_228 (67) = happyGoto action_226
action_228 _ = happyReduce_178

action_229 (133) = happyShift action_48
action_229 (44) = happyGoto action_230
action_229 (46) = happyGoto action_75
action_229 (49) = happyGoto action_76
action_229 (61) = happyGoto action_77
action_229 _ = happyFail

action_230 _ = happyReduce_115

action_231 _ = happyReduce_176

action_232 (80) = happyShift action_60
action_232 (116) = happyShift action_61
action_232 (63) = happyGoto action_314
action_232 (65) = happyGoto action_315
action_232 _ = happyFail

action_233 _ = happyReduce_169

action_234 _ = happyReduce_172

action_235 (78) = happyShift action_313
action_235 _ = happyFail

action_236 _ = happyReduce_158

action_237 (77) = happyShift action_59
action_237 (80) = happyShift action_60
action_237 (116) = happyShift action_61
action_237 (118) = happyShift action_62
action_237 (119) = happyShift action_63
action_237 (120) = happyShift action_64
action_237 (126) = happyShift action_65
action_237 (133) = happyShift action_48
action_237 (54) = happyGoto action_312
action_237 (56) = happyGoto action_52
action_237 (58) = happyGoto action_53
action_237 (61) = happyGoto action_54
action_237 (63) = happyGoto action_55
action_237 (65) = happyGoto action_56
action_237 (69) = happyGoto action_57
action_237 (70) = happyGoto action_58
action_237 _ = happyFail

action_238 (77) = happyShift action_109
action_238 (78) = happyShift action_311
action_238 (79) = happyShift action_202
action_238 (112) = happyShift action_203
action_238 (113) = happyShift action_204
action_238 (114) = happyShift action_205
action_238 (115) = happyShift action_206
action_238 (116) = happyShift action_207
action_238 (123) = happyShift action_208
action_238 (135) = happyShift action_209
action_238 (29) = happyGoto action_197
action_238 (30) = happyGoto action_198
action_238 (31) = happyGoto action_199
action_238 (71) = happyGoto action_200
action_238 _ = happyFail

action_239 _ = happyReduce_79

action_240 _ = happyReduce_78

action_241 _ = happyReduce_85

action_242 (79) = happyShift action_185
action_242 (123) = happyShift action_310
action_242 _ = happyFail

action_243 (79) = happyShift action_308
action_243 (123) = happyShift action_309
action_243 _ = happyFail

action_244 _ = happyReduce_94

action_245 _ = happyReduce_96

action_246 (122) = happyShift action_307
action_246 _ = happyReduce_169

action_247 _ = happyReduce_97

action_248 _ = happyReduce_98

action_249 _ = happyReduce_99

action_250 _ = happyReduce_100

action_251 (80) = happyShift action_60
action_251 (116) = happyShift action_61
action_251 (119) = happyShift action_63
action_251 (120) = happyShift action_64
action_251 (58) = happyGoto action_232
action_251 (62) = happyGoto action_85
action_251 (63) = happyGoto action_233
action_251 (64) = happyGoto action_87
action_251 (65) = happyGoto action_234
action_251 (68) = happyGoto action_89
action_251 _ = happyFail

action_252 _ = happyReduce_119

action_253 (78) = happyShift action_305
action_253 (79) = happyShift action_306
action_253 _ = happyFail

action_254 _ = happyReduce_123

action_255 (119) = happyShift action_93
action_255 (120) = happyShift action_94
action_255 (121) = happyShift action_95
action_255 (122) = happyShift action_96
action_255 (123) = happyShift action_97
action_255 (124) = happyShift action_98
action_255 (125) = happyShift action_99
action_255 (127) = happyShift action_100
action_255 (128) = happyShift action_101
action_255 (129) = happyShift action_102
action_255 (130) = happyShift action_103
action_255 (131) = happyShift action_104
action_255 (132) = happyShift action_105
action_255 (55) = happyGoto action_92
action_255 _ = happyReduce_124

action_256 _ = happyReduce_126

action_257 (133) = happyShift action_48
action_257 (41) = happyGoto action_304
action_257 (42) = happyGoto action_112
action_257 (56) = happyGoto action_113
action_257 (61) = happyGoto action_114
action_257 _ = happyFail

action_258 _ = happyReduce_102

action_259 (133) = happyShift action_48
action_259 (41) = happyGoto action_303
action_259 (42) = happyGoto action_112
action_259 (56) = happyGoto action_113
action_259 (61) = happyGoto action_114
action_259 _ = happyFail

action_260 (79) = happyShift action_185
action_260 _ = happyReduce_105

action_261 _ = happyReduce_111

action_262 (79) = happyShift action_185
action_262 _ = happyReduce_108

action_263 _ = happyReduce_110

action_264 (77) = happyShift action_302
action_264 (133) = happyShift action_48
action_264 (26) = happyGoto action_298
action_264 (27) = happyGoto action_299
action_264 (56) = happyGoto action_300
action_264 (61) = happyGoto action_301
action_264 _ = happyReduce_65

action_265 (116) = happyShift action_137
action_265 (133) = happyShift action_48
action_265 (25) = happyGoto action_295
action_265 (61) = happyGoto action_296
action_265 (75) = happyGoto action_297
action_265 _ = happyFail

action_266 (116) = happyShift action_130
action_266 (133) = happyShift action_48
action_266 (19) = happyGoto action_292
action_266 (61) = happyGoto action_293
action_266 (63) = happyGoto action_294
action_266 _ = happyFail

action_267 _ = happyReduce_130

action_268 (119) = happyShift action_93
action_268 (120) = happyShift action_94
action_268 (121) = happyShift action_95
action_268 (122) = happyShift action_96
action_268 (123) = happyShift action_97
action_268 (124) = happyShift action_98
action_268 (125) = happyShift action_99
action_268 (127) = happyShift action_100
action_268 (128) = happyShift action_101
action_268 (129) = happyShift action_102
action_268 (130) = happyShift action_103
action_268 (131) = happyShift action_104
action_268 (132) = happyShift action_105
action_268 (55) = happyGoto action_92
action_268 _ = happyReduce_133

action_269 _ = happyReduce_132

action_270 _ = happyReduce_128

action_271 (77) = happyShift action_59
action_271 (80) = happyShift action_60
action_271 (116) = happyShift action_61
action_271 (118) = happyShift action_62
action_271 (119) = happyShift action_63
action_271 (120) = happyShift action_64
action_271 (126) = happyShift action_65
action_271 (133) = happyShift action_48
action_271 (135) = happyShift action_209
action_271 (53) = happyGoto action_291
action_271 (54) = happyGoto action_268
action_271 (56) = happyGoto action_52
action_271 (58) = happyGoto action_53
action_271 (61) = happyGoto action_54
action_271 (63) = happyGoto action_55
action_271 (65) = happyGoto action_56
action_271 (69) = happyGoto action_57
action_271 (70) = happyGoto action_58
action_271 (71) = happyGoto action_269
action_271 _ = happyFail

action_272 (86) = happyShift action_23
action_272 (88) = happyShift action_24
action_272 (89) = happyShift action_290
action_272 (90) = happyShift action_26
action_272 (91) = happyShift action_27
action_272 (92) = happyShift action_28
action_272 (93) = happyShift action_29
action_272 (94) = happyShift action_30
action_272 (96) = happyShift action_32
action_272 (97) = happyShift action_33
action_272 (98) = happyShift action_34
action_272 (99) = happyShift action_35
action_272 (100) = happyShift action_36
action_272 (116) = happyShift action_137
action_272 (133) = happyShift action_48
action_272 (20) = happyGoto action_288
action_272 (21) = happyGoto action_13
action_272 (28) = happyGoto action_15
action_272 (56) = happyGoto action_16
action_272 (61) = happyGoto action_17
action_272 (75) = happyGoto action_289
action_272 _ = happyFail

action_273 _ = happyReduce_186

action_274 _ = happyReduce_37

action_275 (137) = happyShift action_107
action_275 (14) = happyGoto action_287
action_275 _ = happyFail

action_276 (86) = happyShift action_23
action_276 (88) = happyShift action_24
action_276 (89) = happyShift action_25
action_276 (90) = happyShift action_26
action_276 (91) = happyShift action_27
action_276 (92) = happyShift action_28
action_276 (93) = happyShift action_29
action_276 (94) = happyShift action_30
action_276 (95) = happyShift action_31
action_276 (96) = happyShift action_32
action_276 (97) = happyShift action_33
action_276 (98) = happyShift action_34
action_276 (99) = happyShift action_35
action_276 (100) = happyShift action_36
action_276 (101) = happyShift action_37
action_276 (102) = happyShift action_38
action_276 (103) = happyShift action_39
action_276 (104) = happyShift action_40
action_276 (105) = happyShift action_41
action_276 (106) = happyShift action_42
action_276 (107) = happyShift action_43
action_276 (108) = happyShift action_44
action_276 (109) = happyShift action_45
action_276 (110) = happyShift action_46
action_276 (111) = happyShift action_47
action_276 (133) = happyShift action_48
action_276 (134) = happyShift action_49
action_276 (136) = happyShift action_50
action_276 (137) = happyShift action_162
action_276 (12) = happyGoto action_286
action_276 (13) = happyGoto action_8
action_276 (15) = happyGoto action_9
action_276 (16) = happyGoto action_10
action_276 (17) = happyGoto action_11
action_276 (20) = happyGoto action_12
action_276 (21) = happyGoto action_13
action_276 (22) = happyGoto action_14
action_276 (28) = happyGoto action_15
action_276 (56) = happyGoto action_16
action_276 (61) = happyGoto action_17
action_276 (74) = happyGoto action_18
action_276 (76) = happyGoto action_67
action_276 _ = happyFail

action_277 (78) = happyShift action_285
action_277 _ = happyFail

action_278 (79) = happyShift action_284
action_278 _ = happyReduce_163

action_279 _ = happyReduce_166

action_280 (86) = happyShift action_23
action_280 (88) = happyShift action_24
action_280 (89) = happyShift action_25
action_280 (90) = happyShift action_26
action_280 (91) = happyShift action_27
action_280 (92) = happyShift action_28
action_280 (93) = happyShift action_29
action_280 (94) = happyShift action_30
action_280 (95) = happyShift action_31
action_280 (96) = happyShift action_32
action_280 (97) = happyShift action_33
action_280 (98) = happyShift action_34
action_280 (99) = happyShift action_35
action_280 (100) = happyShift action_36
action_280 (101) = happyShift action_37
action_280 (102) = happyShift action_38
action_280 (103) = happyShift action_39
action_280 (104) = happyShift action_40
action_280 (105) = happyShift action_41
action_280 (106) = happyShift action_42
action_280 (107) = happyShift action_43
action_280 (108) = happyShift action_44
action_280 (109) = happyShift action_45
action_280 (110) = happyShift action_46
action_280 (111) = happyShift action_47
action_280 (133) = happyShift action_48
action_280 (134) = happyShift action_49
action_280 (136) = happyShift action_50
action_280 (137) = happyShift action_162
action_280 (12) = happyGoto action_283
action_280 (13) = happyGoto action_8
action_280 (15) = happyGoto action_9
action_280 (16) = happyGoto action_10
action_280 (17) = happyGoto action_11
action_280 (20) = happyGoto action_12
action_280 (21) = happyGoto action_13
action_280 (22) = happyGoto action_14
action_280 (28) = happyGoto action_15
action_280 (56) = happyGoto action_16
action_280 (61) = happyGoto action_17
action_280 (74) = happyGoto action_18
action_280 (76) = happyGoto action_67
action_280 _ = happyFail

action_281 (137) = happyShift action_107
action_281 (14) = happyGoto action_282
action_281 _ = happyFail

action_282 (86) = happyShift action_23
action_282 (88) = happyShift action_24
action_282 (89) = happyShift action_25
action_282 (90) = happyShift action_26
action_282 (91) = happyShift action_27
action_282 (92) = happyShift action_28
action_282 (93) = happyShift action_29
action_282 (94) = happyShift action_30
action_282 (95) = happyShift action_31
action_282 (96) = happyShift action_32
action_282 (97) = happyShift action_33
action_282 (98) = happyShift action_34
action_282 (99) = happyShift action_35
action_282 (100) = happyShift action_36
action_282 (101) = happyShift action_37
action_282 (102) = happyShift action_38
action_282 (103) = happyShift action_39
action_282 (104) = happyShift action_40
action_282 (105) = happyShift action_41
action_282 (106) = happyShift action_42
action_282 (107) = happyShift action_43
action_282 (108) = happyShift action_44
action_282 (109) = happyShift action_45
action_282 (110) = happyShift action_46
action_282 (111) = happyShift action_47
action_282 (133) = happyShift action_48
action_282 (134) = happyShift action_49
action_282 (136) = happyShift action_50
action_282 (137) = happyShift action_162
action_282 (12) = happyGoto action_330
action_282 (13) = happyGoto action_8
action_282 (15) = happyGoto action_9
action_282 (16) = happyGoto action_10
action_282 (17) = happyGoto action_11
action_282 (20) = happyGoto action_12
action_282 (21) = happyGoto action_13
action_282 (22) = happyGoto action_14
action_282 (28) = happyGoto action_15
action_282 (56) = happyGoto action_16
action_282 (61) = happyGoto action_17
action_282 (74) = happyGoto action_18
action_282 (76) = happyGoto action_67
action_282 _ = happyFail

action_283 (84) = happyShift action_329
action_283 (86) = happyShift action_23
action_283 (88) = happyShift action_24
action_283 (89) = happyShift action_25
action_283 (90) = happyShift action_26
action_283 (91) = happyShift action_27
action_283 (92) = happyShift action_28
action_283 (93) = happyShift action_29
action_283 (94) = happyShift action_30
action_283 (95) = happyShift action_31
action_283 (96) = happyShift action_32
action_283 (97) = happyShift action_33
action_283 (98) = happyShift action_34
action_283 (99) = happyShift action_35
action_283 (100) = happyShift action_36
action_283 (101) = happyShift action_37
action_283 (102) = happyShift action_38
action_283 (103) = happyShift action_39
action_283 (104) = happyShift action_40
action_283 (105) = happyShift action_41
action_283 (106) = happyShift action_42
action_283 (107) = happyShift action_43
action_283 (108) = happyShift action_44
action_283 (109) = happyShift action_45
action_283 (110) = happyShift action_46
action_283 (111) = happyShift action_47
action_283 (133) = happyShift action_48
action_283 (134) = happyShift action_49
action_283 (136) = happyShift action_50
action_283 (13) = happyGoto action_157
action_283 (15) = happyGoto action_9
action_283 (16) = happyGoto action_10
action_283 (17) = happyGoto action_11
action_283 (20) = happyGoto action_12
action_283 (21) = happyGoto action_13
action_283 (22) = happyGoto action_14
action_283 (28) = happyGoto action_15
action_283 (56) = happyGoto action_16
action_283 (61) = happyGoto action_17
action_283 (74) = happyGoto action_18
action_283 (76) = happyGoto action_67
action_283 _ = happyFail

action_284 (133) = happyShift action_48
action_284 (61) = happyGoto action_328
action_284 _ = happyFail

action_285 _ = happyReduce_16

action_286 (84) = happyShift action_327
action_286 (86) = happyShift action_23
action_286 (88) = happyShift action_24
action_286 (89) = happyShift action_25
action_286 (90) = happyShift action_26
action_286 (91) = happyShift action_27
action_286 (92) = happyShift action_28
action_286 (93) = happyShift action_29
action_286 (94) = happyShift action_30
action_286 (95) = happyShift action_31
action_286 (96) = happyShift action_32
action_286 (97) = happyShift action_33
action_286 (98) = happyShift action_34
action_286 (99) = happyShift action_35
action_286 (100) = happyShift action_36
action_286 (101) = happyShift action_37
action_286 (102) = happyShift action_38
action_286 (103) = happyShift action_39
action_286 (104) = happyShift action_40
action_286 (105) = happyShift action_41
action_286 (106) = happyShift action_42
action_286 (107) = happyShift action_43
action_286 (108) = happyShift action_44
action_286 (109) = happyShift action_45
action_286 (110) = happyShift action_46
action_286 (111) = happyShift action_47
action_286 (133) = happyShift action_48
action_286 (134) = happyShift action_49
action_286 (136) = happyShift action_50
action_286 (13) = happyGoto action_157
action_286 (15) = happyGoto action_9
action_286 (16) = happyGoto action_10
action_286 (17) = happyGoto action_11
action_286 (20) = happyGoto action_12
action_286 (21) = happyGoto action_13
action_286 (22) = happyGoto action_14
action_286 (28) = happyGoto action_15
action_286 (56) = happyGoto action_16
action_286 (61) = happyGoto action_17
action_286 (74) = happyGoto action_18
action_286 (76) = happyGoto action_67
action_286 _ = happyFail

action_287 (137) = happyShift action_162
action_287 _ = happyReduce_15

action_288 _ = happyReduce_30

action_289 (79) = happyShift action_326
action_289 _ = happyFail

action_290 (77) = happyShift action_325
action_290 _ = happyFail

action_291 _ = happyReduce_129

action_292 (79) = happyShift action_324
action_292 _ = happyReduce_33

action_293 _ = happyReduce_35

action_294 _ = happyReduce_34

action_295 (78) = happyShift action_323
action_295 _ = happyFail

action_296 _ = happyReduce_69

action_297 _ = happyReduce_70

action_298 (79) = happyShift action_322
action_298 _ = happyReduce_63

action_299 _ = happyReduce_72

action_300 _ = happyReduce_74

action_301 (77) = happyShift action_90
action_301 _ = happyReduce_73

action_302 (77) = happyShift action_302
action_302 (133) = happyShift action_48
action_302 (26) = happyGoto action_321
action_302 (27) = happyGoto action_299
action_302 (56) = happyGoto action_300
action_302 (61) = happyGoto action_301
action_302 _ = happyFail

action_303 (79) = happyShift action_185
action_303 _ = happyReduce_106

action_304 (78) = happyShift action_320
action_304 (79) = happyShift action_185
action_304 _ = happyFail

action_305 _ = happyReduce_121

action_306 (77) = happyShift action_59
action_306 (80) = happyShift action_60
action_306 (116) = happyShift action_61
action_306 (118) = happyShift action_62
action_306 (119) = happyShift action_63
action_306 (120) = happyShift action_64
action_306 (126) = happyShift action_65
action_306 (133) = happyShift action_48
action_306 (48) = happyGoto action_319
action_306 (54) = happyGoto action_255
action_306 (56) = happyGoto action_52
action_306 (58) = happyGoto action_53
action_306 (61) = happyGoto action_54
action_306 (63) = happyGoto action_55
action_306 (65) = happyGoto action_56
action_306 (69) = happyGoto action_57
action_306 (70) = happyGoto action_58
action_306 _ = happyFail

action_307 (77) = happyShift action_251
action_307 (80) = happyShift action_60
action_307 (116) = happyShift action_61
action_307 (118) = happyShift action_62
action_307 (119) = happyShift action_63
action_307 (120) = happyShift action_64
action_307 (135) = happyShift action_209
action_307 (35) = happyGoto action_318
action_307 (58) = happyGoto action_232
action_307 (62) = happyGoto action_85
action_307 (63) = happyGoto action_233
action_307 (64) = happyGoto action_87
action_307 (65) = happyGoto action_234
action_307 (68) = happyGoto action_247
action_307 (69) = happyGoto action_248
action_307 (70) = happyGoto action_249
action_307 (71) = happyGoto action_250
action_307 _ = happyFail

action_308 (77) = happyShift action_251
action_308 (80) = happyShift action_60
action_308 (116) = happyShift action_61
action_308 (118) = happyShift action_62
action_308 (119) = happyShift action_63
action_308 (120) = happyShift action_64
action_308 (135) = happyShift action_209
action_308 (34) = happyGoto action_317
action_308 (35) = happyGoto action_245
action_308 (58) = happyGoto action_232
action_308 (62) = happyGoto action_85
action_308 (63) = happyGoto action_246
action_308 (64) = happyGoto action_87
action_308 (65) = happyGoto action_234
action_308 (68) = happyGoto action_247
action_308 (69) = happyGoto action_248
action_308 (70) = happyGoto action_249
action_308 (71) = happyGoto action_250
action_308 _ = happyFail

action_309 _ = happyReduce_92

action_310 (77) = happyShift action_251
action_310 (80) = happyShift action_60
action_310 (116) = happyShift action_61
action_310 (118) = happyShift action_62
action_310 (119) = happyShift action_63
action_310 (120) = happyShift action_64
action_310 (135) = happyShift action_209
action_310 (33) = happyGoto action_316
action_310 (34) = happyGoto action_244
action_310 (35) = happyGoto action_245
action_310 (58) = happyGoto action_232
action_310 (62) = happyGoto action_85
action_310 (63) = happyGoto action_246
action_310 (64) = happyGoto action_87
action_310 (65) = happyGoto action_234
action_310 (68) = happyGoto action_247
action_310 (69) = happyGoto action_248
action_310 (70) = happyGoto action_249
action_310 (71) = happyGoto action_250
action_310 _ = happyFail

action_311 _ = happyReduce_84

action_312 (119) = happyShift action_93
action_312 (120) = happyShift action_94
action_312 (121) = happyShift action_95
action_312 (122) = happyShift action_96
action_312 (123) = happyShift action_97
action_312 (124) = happyShift action_98
action_312 (125) = happyShift action_99
action_312 (127) = happyShift action_100
action_312 (128) = happyShift action_101
action_312 (129) = happyShift action_102
action_312 (130) = happyShift action_103
action_312 (131) = happyShift action_104
action_312 (132) = happyShift action_105
action_312 (55) = happyGoto action_92
action_312 _ = happyReduce_159

action_313 _ = happyReduce_182

action_314 _ = happyReduce_168

action_315 _ = happyReduce_171

action_316 (79) = happyShift action_308
action_316 (123) = happyShift action_340
action_316 _ = happyFail

action_317 _ = happyReduce_93

action_318 _ = happyReduce_95

action_319 _ = happyReduce_122

action_320 _ = happyReduce_101

action_321 (79) = happyShift action_339
action_321 _ = happyFail

action_322 (77) = happyShift action_302
action_322 (133) = happyShift action_48
action_322 (27) = happyGoto action_338
action_322 (56) = happyGoto action_300
action_322 (61) = happyGoto action_301
action_322 _ = happyFail

action_323 (77) = happyShift action_302
action_323 (133) = happyShift action_48
action_323 (26) = happyGoto action_337
action_323 (27) = happyGoto action_299
action_323 (56) = happyGoto action_300
action_323 (61) = happyGoto action_301
action_323 _ = happyReduce_66

action_324 (116) = happyShift action_130
action_324 (133) = happyShift action_48
action_324 (19) = happyGoto action_336
action_324 (61) = happyGoto action_293
action_324 (63) = happyGoto action_294
action_324 _ = happyFail

action_325 (77) = happyShift action_59
action_325 (80) = happyShift action_60
action_325 (116) = happyShift action_61
action_325 (118) = happyShift action_62
action_325 (119) = happyShift action_63
action_325 (120) = happyShift action_64
action_325 (126) = happyShift action_65
action_325 (133) = happyShift action_48
action_325 (54) = happyGoto action_335
action_325 (56) = happyGoto action_52
action_325 (58) = happyGoto action_53
action_325 (61) = happyGoto action_54
action_325 (63) = happyGoto action_55
action_325 (65) = happyGoto action_56
action_325 (69) = happyGoto action_57
action_325 (70) = happyGoto action_58
action_325 _ = happyFail

action_326 (116) = happyShift action_137
action_326 (75) = happyGoto action_334
action_326 _ = happyFail

action_327 (137) = happyShift action_107
action_327 (14) = happyGoto action_333
action_327 _ = happyFail

action_328 _ = happyReduce_165

action_329 (137) = happyShift action_107
action_329 (14) = happyGoto action_332
action_329 _ = happyFail

action_330 (84) = happyShift action_331
action_330 (86) = happyShift action_23
action_330 (88) = happyShift action_24
action_330 (89) = happyShift action_25
action_330 (90) = happyShift action_26
action_330 (91) = happyShift action_27
action_330 (92) = happyShift action_28
action_330 (93) = happyShift action_29
action_330 (94) = happyShift action_30
action_330 (95) = happyShift action_31
action_330 (96) = happyShift action_32
action_330 (97) = happyShift action_33
action_330 (98) = happyShift action_34
action_330 (99) = happyShift action_35
action_330 (100) = happyShift action_36
action_330 (101) = happyShift action_37
action_330 (102) = happyShift action_38
action_330 (103) = happyShift action_39
action_330 (104) = happyShift action_40
action_330 (105) = happyShift action_41
action_330 (106) = happyShift action_42
action_330 (107) = happyShift action_43
action_330 (108) = happyShift action_44
action_330 (109) = happyShift action_45
action_330 (110) = happyShift action_46
action_330 (111) = happyShift action_47
action_330 (133) = happyShift action_48
action_330 (134) = happyShift action_49
action_330 (136) = happyShift action_50
action_330 (13) = happyGoto action_157
action_330 (15) = happyGoto action_9
action_330 (16) = happyGoto action_10
action_330 (17) = happyGoto action_11
action_330 (20) = happyGoto action_12
action_330 (21) = happyGoto action_13
action_330 (22) = happyGoto action_14
action_330 (28) = happyGoto action_15
action_330 (56) = happyGoto action_16
action_330 (61) = happyGoto action_17
action_330 (74) = happyGoto action_18
action_330 (76) = happyGoto action_67
action_330 _ = happyFail

action_331 (137) = happyShift action_107
action_331 (14) = happyGoto action_346
action_331 _ = happyFail

action_332 (137) = happyShift action_162
action_332 _ = happyReduce_13

action_333 (137) = happyShift action_162
action_333 _ = happyReduce_14

action_334 (79) = happyShift action_345
action_334 _ = happyFail

action_335 (78) = happyShift action_344
action_335 (119) = happyShift action_93
action_335 (120) = happyShift action_94
action_335 (121) = happyShift action_95
action_335 (122) = happyShift action_96
action_335 (123) = happyShift action_97
action_335 (124) = happyShift action_98
action_335 (125) = happyShift action_99
action_335 (127) = happyShift action_100
action_335 (128) = happyShift action_101
action_335 (129) = happyShift action_102
action_335 (130) = happyShift action_103
action_335 (131) = happyShift action_104
action_335 (132) = happyShift action_105
action_335 (55) = happyGoto action_92
action_335 _ = happyFail

action_336 _ = happyReduce_32

action_337 (79) = happyShift action_322
action_337 _ = happyReduce_64

action_338 _ = happyReduce_71

action_339 (77) = happyShift action_302
action_339 (133) = happyShift action_48
action_339 (18) = happyGoto action_341
action_339 (21) = happyGoto action_181
action_339 (27) = happyGoto action_338
action_339 (28) = happyGoto action_15
action_339 (56) = happyGoto action_342
action_339 (61) = happyGoto action_343
action_339 _ = happyFail

action_340 _ = happyReduce_91

action_341 (78) = happyShift action_348
action_341 _ = happyFail

action_342 (85) = happyReduce_77
action_342 _ = happyReduce_74

action_343 (77) = happyShift action_90
action_343 (85) = happyReduce_76
action_343 _ = happyReduce_73

action_344 (116) = happyShift action_137
action_344 (75) = happyGoto action_289
action_344 _ = happyFail

action_345 (116) = happyShift action_137
action_345 (75) = happyGoto action_347
action_345 _ = happyFail

action_346 (137) = happyShift action_162
action_346 _ = happyReduce_12

action_347 _ = happyReduce_41

action_348 _ = happyReduce_75

happyReduce_3 = happySpecReduce_1  6 happyReduction_3
happyReduction_3 (HappyAbsSyn7  happy_var_1)
	 =  HappyAbsSyn6
		 (ProgramFile (reverse happy_var_1) [ ]
	)
happyReduction_3 _  = notHappyAtAll 

happyReduce_4 = happySpecReduce_2  6 happyReduction_4
happyReduction_4 (HappyAbsSyn12  happy_var_2)
	(HappyAbsSyn7  happy_var_1)
	 =  HappyAbsSyn6
		 (ProgramFile (reverse happy_var_1) (reverse happy_var_2)
	)
happyReduction_4 _ _  = notHappyAtAll 

happyReduce_5 = happySpecReduce_2  7 happyReduction_5
happyReduction_5 (HappyAbsSyn8  happy_var_2)
	(HappyAbsSyn7  happy_var_1)
	 =  HappyAbsSyn7
		 (([ ], happy_var_2) : happy_var_1
	)
happyReduction_5 _ _  = notHappyAtAll 

happyReduce_6 = happySpecReduce_2  7 happyReduction_6
happyReduction_6 (HappyAbsSyn8  happy_var_2)
	(HappyAbsSyn7  happy_var_1)
	 =  HappyAbsSyn7
		 (([ ], happy_var_2) : happy_var_1
	)
happyReduction_6 _ _  = notHappyAtAll 

happyReduce_7 = happySpecReduce_3  7 happyReduction_7
happyReduction_7 (HappyAbsSyn8  happy_var_3)
	(HappyAbsSyn12  happy_var_2)
	(HappyAbsSyn7  happy_var_1)
	 =  HappyAbsSyn7
		 ((reverse happy_var_2, happy_var_3) : happy_var_1
	)
happyReduction_7 _ _ _  = notHappyAtAll 

happyReduce_8 = happySpecReduce_1  7 happyReduction_8
happyReduction_8 (HappyAbsSyn8  happy_var_1)
	 =  HappyAbsSyn7
		 ([ ([ ], happy_var_1) ]
	)
happyReduction_8 _  = notHappyAtAll 

happyReduce_9 = happySpecReduce_1  7 happyReduction_9
happyReduction_9 (HappyAbsSyn8  happy_var_1)
	 =  HappyAbsSyn7
		 ([ ([ ], happy_var_1) ]
	)
happyReduction_9 _  = notHappyAtAll 

happyReduce_10 = happySpecReduce_2  7 happyReduction_10
happyReduction_10 (HappyAbsSyn8  happy_var_2)
	(HappyAbsSyn12  happy_var_1)
	 =  HappyAbsSyn7
		 ([ (reverse happy_var_1, happy_var_2) ]
	)
happyReduction_10 _ _  = notHappyAtAll 

happyReduce_11 = happySpecReduce_3  8 happyReduction_11
happyReduction_11 _
	(HappyTerminal happy_var_2)
	(HappyAbsSyn12  happy_var_1)
	 =  HappyAbsSyn8
		 (let blocks = reverse happy_var_1
    in PUMain () (getTransSpan happy_var_1 happy_var_2) Nothing blocks Nothing
	)
happyReduction_11 _ _ _  = notHappyAtAll 

happyReduce_12 = happyReduce 8 9 happyReduction_12
happyReduction_12 (_ `HappyStk`
	(HappyTerminal happy_var_7) `HappyStk`
	(HappyAbsSyn12  happy_var_6) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn10  happy_var_4) `HappyStk`
	(HappyAbsSyn11  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn76  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn8
		 (PUFunction () (getTransSpan happy_var_1 happy_var_7) (Just happy_var_1) False happy_var_3 happy_var_4 Nothing (reverse happy_var_6) Nothing
	) `HappyStk` happyRest

happyReduce_13 = happyReduce 7 9 happyReduction_13
happyReduction_13 (_ `HappyStk`
	(HappyTerminal happy_var_6) `HappyStk`
	(HappyAbsSyn12  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn10  happy_var_3) `HappyStk`
	(HappyAbsSyn11  happy_var_2) `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn8
		 (PUFunction () (getTransSpan happy_var_1 happy_var_6) Nothing False happy_var_2 happy_var_3 Nothing (reverse happy_var_5) Nothing
	) `HappyStk` happyRest

happyReduce_14 = happyReduce 7 9 happyReduction_14
happyReduction_14 (_ `HappyStk`
	(HappyTerminal happy_var_6) `HappyStk`
	(HappyAbsSyn12  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn10  happy_var_3) `HappyStk`
	(HappyAbsSyn11  happy_var_2) `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn8
		 (PUSubroutine () (getTransSpan happy_var_1 happy_var_6) False happy_var_2 happy_var_3 (reverse happy_var_5) Nothing
	) `HappyStk` happyRest

happyReduce_15 = happyReduce 5 9 happyReduction_15
happyReduction_15 (_ `HappyStk`
	(HappyTerminal happy_var_4) `HappyStk`
	(HappyAbsSyn12  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn8
		 (PUBlockData () (getTransSpan happy_var_1 happy_var_4) Nothing (reverse happy_var_3)
	) `HappyStk` happyRest

happyReduce_16 = happySpecReduce_3  10 happyReduction_16
happyReduction_16 _
	(HappyAbsSyn10  happy_var_2)
	_
	 =  HappyAbsSyn10
		 (happy_var_2
	)
happyReduction_16 _ _ _  = notHappyAtAll 

happyReduce_17 = happySpecReduce_0  10 happyReduction_17
happyReduction_17  =  HappyAbsSyn10
		 (Nothing
	)

happyReduce_18 = happySpecReduce_1  11 happyReduction_18
happyReduction_18 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn11
		 (let (TId _ name) = happy_var_1 in name
	)
happyReduction_18 _  = notHappyAtAll 

happyReduce_19 = happySpecReduce_2  12 happyReduction_19
happyReduction_19 (HappyAbsSyn13  happy_var_2)
	(HappyAbsSyn12  happy_var_1)
	 =  HappyAbsSyn12
		 (happy_var_2 : happy_var_1
	)
happyReduction_19 _ _  = notHappyAtAll 

happyReduce_20 = happySpecReduce_1  12 happyReduction_20
happyReduction_20 (HappyAbsSyn13  happy_var_1)
	 =  HappyAbsSyn12
		 ([ happy_var_1 ]
	)
happyReduction_20 _  = notHappyAtAll 

happyReduce_21 = happySpecReduce_3  13 happyReduction_21
happyReduction_21 _
	(HappyAbsSyn15  happy_var_2)
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn13
		 (BlStatement () (getTransSpan happy_var_1 happy_var_2) (Just happy_var_1) happy_var_2
	)
happyReduction_21 _ _ _  = notHappyAtAll 

happyReduce_22 = happySpecReduce_2  13 happyReduction_22
happyReduction_22 _
	(HappyAbsSyn15  happy_var_1)
	 =  HappyAbsSyn13
		 (BlStatement () (getSpan happy_var_1) Nothing happy_var_1
	)
happyReduction_22 _ _  = notHappyAtAll 

happyReduce_23 = happySpecReduce_2  13 happyReduction_23
happyReduction_23 _
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn13
		 (let (TComment s c) = happy_var_1 in BlComment () s c
	)
happyReduction_23 _ _  = notHappyAtAll 

happyReduce_24 = happySpecReduce_2  14 happyReduction_24
happyReduction_24 _
	(HappyAbsSyn14  happy_var_1)
	 =  HappyAbsSyn14
		 (happy_var_1
	)
happyReduction_24 _ _  = notHappyAtAll 

happyReduce_25 = happySpecReduce_1  14 happyReduction_25
happyReduction_25 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn14
		 (happy_var_1
	)
happyReduction_25 _  = notHappyAtAll 

happyReduce_26 = happySpecReduce_1  15 happyReduction_26
happyReduction_26 (HappyAbsSyn15  happy_var_1)
	 =  HappyAbsSyn15
		 (happy_var_1
	)
happyReduction_26 _  = notHappyAtAll 

happyReduce_27 = happySpecReduce_1  15 happyReduction_27
happyReduction_27 (HappyAbsSyn15  happy_var_1)
	 =  HappyAbsSyn15
		 (happy_var_1
	)
happyReduction_27 _  = notHappyAtAll 

happyReduce_28 = happySpecReduce_1  15 happyReduction_28
happyReduction_28 (HappyAbsSyn15  happy_var_1)
	 =  HappyAbsSyn15
		 (happy_var_1
	)
happyReduction_28 _  = notHappyAtAll 

happyReduce_29 = happySpecReduce_1  15 happyReduction_29
happyReduction_29 (HappyAbsSyn15  happy_var_1)
	 =  HappyAbsSyn15
		 (happy_var_1
	)
happyReduction_29 _  = notHappyAtAll 

happyReduce_30 = happyReduce 5 16 happyReduction_30
happyReduction_30 ((HappyAbsSyn15  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn15
		 (StIfLogical () (getTransSpan happy_var_1 happy_var_5) happy_var_3 happy_var_5
	) `HappyStk` happyRest

happyReduce_31 = happySpecReduce_3  17 happyReduction_31
happyReduction_31 (HappyAbsSyn18  happy_var_3)
	(HappyAbsSyn19  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StDo () (getTransSpan happy_var_1 happy_var_3) Nothing (Just happy_var_2) (Just happy_var_3)
	)
happyReduction_31 _ _ _  = notHappyAtAll 

happyReduce_32 = happyReduce 5 18 happyReduction_32
happyReduction_32 ((HappyAbsSyn19  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn15  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn18
		 (DoSpecification () (getTransSpan happy_var_1 happy_var_5) happy_var_1 happy_var_3 (Just happy_var_5)
	) `HappyStk` happyRest

happyReduce_33 = happySpecReduce_3  18 happyReduction_33
happyReduction_33 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn15  happy_var_1)
	 =  HappyAbsSyn18
		 (DoSpecification () (getTransSpan happy_var_1 happy_var_3) happy_var_1 happy_var_3 Nothing
	)
happyReduction_33 _ _ _  = notHappyAtAll 

happyReduce_34 = happySpecReduce_1  19 happyReduction_34
happyReduction_34 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_34 _  = notHappyAtAll 

happyReduce_35 = happySpecReduce_1  19 happyReduction_35
happyReduction_35 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_35 _  = notHappyAtAll 

happyReduce_36 = happySpecReduce_1  20 happyReduction_36
happyReduction_36 (HappyAbsSyn15  happy_var_1)
	 =  HappyAbsSyn15
		 (happy_var_1
	)
happyReduction_36 _  = notHappyAtAll 

happyReduce_37 = happyReduce 4 20 happyReduction_37
happyReduction_37 ((HappyAbsSyn19  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_2) `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn15
		 (StLabelAssign () (getTransSpan happy_var_1 happy_var_4) happy_var_2 happy_var_4
	) `HappyStk` happyRest

happyReduce_38 = happySpecReduce_2  20 happyReduction_38
happyReduction_38 (HappyAbsSyn19  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StGotoUnconditional () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)
happyReduction_38 _ _  = notHappyAtAll 

happyReduce_39 = happySpecReduce_3  20 happyReduction_39
happyReduction_39 (HappyAbsSyn26  happy_var_3)
	(HappyAbsSyn19  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StGotoAssigned () (getTransSpan happy_var_1 happy_var_3) happy_var_2 happy_var_3
	)
happyReduction_39 _ _ _  = notHappyAtAll 

happyReduce_40 = happySpecReduce_3  20 happyReduction_40
happyReduction_40 (HappyAbsSyn19  happy_var_3)
	(HappyAbsSyn26  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StGotoComputed () (getTransSpan happy_var_1 happy_var_3) happy_var_2 happy_var_3
	)
happyReduction_40 _ _ _  = notHappyAtAll 

happyReduce_41 = happyReduce 9 20 happyReduction_41
happyReduction_41 ((HappyAbsSyn19  happy_var_9) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_7) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn15
		 (StIfArithmetic () (getTransSpan happy_var_1 happy_var_9) happy_var_3 happy_var_5 happy_var_7 happy_var_9
	) `HappyStk` happyRest

happyReduce_42 = happySpecReduce_3  20 happyReduction_42
happyReduction_42 (HappyAbsSyn51  happy_var_3)
	(HappyAbsSyn19  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StCall () (getTransSpan happy_var_1 happy_var_3) happy_var_2 (Just happy_var_3)
	)
happyReduction_42 _ _ _  = notHappyAtAll 

happyReduce_43 = happySpecReduce_2  20 happyReduction_43
happyReduction_43 (HappyAbsSyn19  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StCall () (getTransSpan happy_var_1 happy_var_2) happy_var_2 Nothing
	)
happyReduction_43 _ _  = notHappyAtAll 

happyReduce_44 = happySpecReduce_1  20 happyReduction_44
happyReduction_44 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StReturn () (getSpan happy_var_1) Nothing
	)
happyReduction_44 _  = notHappyAtAll 

happyReduce_45 = happySpecReduce_1  20 happyReduction_45
happyReduction_45 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StContinue () $ getSpan happy_var_1
	)
happyReduction_45 _  = notHappyAtAll 

happyReduce_46 = happySpecReduce_2  20 happyReduction_46
happyReduction_46 (HappyAbsSyn19  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StStop () (getTransSpan happy_var_1 happy_var_2) $ Just happy_var_2
	)
happyReduction_46 _ _  = notHappyAtAll 

happyReduce_47 = happySpecReduce_1  20 happyReduction_47
happyReduction_47 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StStop () (getSpan happy_var_1) Nothing
	)
happyReduction_47 _  = notHappyAtAll 

happyReduce_48 = happySpecReduce_2  20 happyReduction_48
happyReduction_48 (HappyAbsSyn19  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StPause () (getTransSpan happy_var_1 happy_var_2) $ Just happy_var_2
	)
happyReduction_48 _ _  = notHappyAtAll 

happyReduce_49 = happySpecReduce_1  20 happyReduction_49
happyReduction_49 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StPause () (getSpan happy_var_1) Nothing
	)
happyReduction_49 _  = notHappyAtAll 

happyReduce_50 = happySpecReduce_2  20 happyReduction_50
happyReduction_50 (HappyAbsSyn19  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StRewind2 () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)
happyReduction_50 _ _  = notHappyAtAll 

happyReduce_51 = happySpecReduce_2  20 happyReduction_51
happyReduction_51 (HappyAbsSyn19  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StBackspace2 () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)
happyReduction_51 _ _  = notHappyAtAll 

happyReduce_52 = happySpecReduce_2  20 happyReduction_52
happyReduction_52 (HappyAbsSyn19  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StEndfile2 () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)
happyReduction_52 _ _  = notHappyAtAll 

happyReduce_53 = happySpecReduce_2  20 happyReduction_53
happyReduction_53 (HappyAbsSyn23  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (let (cilist, iolist) = happy_var_2 in StWrite () (getTransSpan happy_var_1 happy_var_2) cilist iolist
	)
happyReduction_53 _ _  = notHappyAtAll 

happyReduce_54 = happySpecReduce_2  20 happyReduction_54
happyReduction_54 (HappyAbsSyn23  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (let (cilist, iolist) = happy_var_2 in StRead () (getTransSpan happy_var_1 happy_var_2) cilist iolist
	)
happyReduction_54 _ _  = notHappyAtAll 

happyReduce_55 = happySpecReduce_3  21 happyReduction_55
happyReduction_55 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn15
		 (StExpressionAssign () (getTransSpan happy_var_1 happy_var_3) happy_var_1 happy_var_3
	)
happyReduction_55 _ _ _  = notHappyAtAll 

happyReduce_56 = happySpecReduce_2  22 happyReduction_56
happyReduction_56 (HappyAbsSyn26  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StExternal () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)
happyReduction_56 _ _  = notHappyAtAll 

happyReduce_57 = happySpecReduce_2  22 happyReduction_57
happyReduction_57 (HappyAbsSyn43  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StDimension () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)
happyReduction_57 _ _  = notHappyAtAll 

happyReduce_58 = happySpecReduce_2  22 happyReduction_58
happyReduction_58 (HappyAbsSyn37  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StCommon () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)
happyReduction_58 _ _  = notHappyAtAll 

happyReduce_59 = happySpecReduce_2  22 happyReduction_59
happyReduction_59 (HappyAbsSyn36  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StEquivalence () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)
happyReduction_59 _ _  = notHappyAtAll 

happyReduce_60 = happySpecReduce_2  22 happyReduction_60
happyReduction_60 (HappyAbsSyn32  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StData () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)
happyReduction_60 _ _  = notHappyAtAll 

happyReduce_61 = happySpecReduce_3  22 happyReduction_61
happyReduction_61 (HappyTerminal happy_var_3)
	(HappyAbsSyn29  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn15
		 (StFormat () (getTransSpan happy_var_1 happy_var_3) (aReverse happy_var_2)
	)
happyReduction_61 _ _ _  = notHappyAtAll 

happyReduce_62 = happySpecReduce_2  22 happyReduction_62
happyReduction_62 (HappyAbsSyn43  happy_var_2)
	(HappyAbsSyn76  happy_var_1)
	 =  HappyAbsSyn15
		 (StDeclaration () (getTransSpan happy_var_1 happy_var_2) happy_var_1 Nothing (aReverse happy_var_2)
	)
happyReduction_62 _ _  = notHappyAtAll 

happyReduce_63 = happyReduce 4 23 happyReduction_63
happyReduction_63 ((HappyAbsSyn26  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn23
		 ((AList () (getSpan happy_var_2) [ ControlPair () (getSpan happy_var_2) Nothing happy_var_2 ], Just (aReverse happy_var_4))
	) `HappyStk` happyRest

happyReduce_64 = happyReduce 6 23 happyReduction_64
happyReduction_64 ((HappyAbsSyn26  happy_var_6) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn23
		 ((AList () (getTransSpan happy_var_2 happy_var_4) [ ControlPair () (getSpan happy_var_2) Nothing happy_var_2, ControlPair () (getSpan happy_var_4) Nothing happy_var_4 ], Just (aReverse happy_var_6))
	) `HappyStk` happyRest

happyReduce_65 = happySpecReduce_3  23 happyReduction_65
happyReduction_65 _
	(HappyAbsSyn19  happy_var_2)
	_
	 =  HappyAbsSyn23
		 ((AList () (getSpan happy_var_2) [ ControlPair () (getSpan happy_var_2) Nothing happy_var_2 ], Nothing)
	)
happyReduction_65 _ _ _  = notHappyAtAll 

happyReduce_66 = happyReduce 5 23 happyReduction_66
happyReduction_66 (_ `HappyStk`
	(HappyAbsSyn19  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn23
		 ((AList () (getTransSpan happy_var_2 happy_var_4) [ ControlPair () (getSpan happy_var_2) Nothing happy_var_2, ControlPair () (getSpan happy_var_4) Nothing happy_var_4 ], Nothing)
	) `HappyStk` happyRest

happyReduce_67 = happySpecReduce_1  24 happyReduction_67
happyReduction_67 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_67 _  = notHappyAtAll 

happyReduce_68 = happySpecReduce_1  24 happyReduction_68
happyReduction_68 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_68 _  = notHappyAtAll 

happyReduce_69 = happySpecReduce_1  25 happyReduction_69
happyReduction_69 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_69 _  = notHappyAtAll 

happyReduce_70 = happySpecReduce_1  25 happyReduction_70
happyReduction_70 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_70 _  = notHappyAtAll 

happyReduce_71 = happySpecReduce_3  26 happyReduction_71
happyReduction_71 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn26  happy_var_1)
	 =  HappyAbsSyn26
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)
happyReduction_71 _ _ _  = notHappyAtAll 

happyReduce_72 = happySpecReduce_1  26 happyReduction_72
happyReduction_72 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn26
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)
happyReduction_72 _  = notHappyAtAll 

happyReduce_73 = happySpecReduce_1  27 happyReduction_73
happyReduction_73 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_73 _  = notHappyAtAll 

happyReduce_74 = happySpecReduce_1  27 happyReduction_74
happyReduction_74 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_74 _  = notHappyAtAll 

happyReduce_75 = happyReduce 5 27 happyReduction_75
happyReduction_75 ((HappyTerminal happy_var_5) `HappyStk`
	(HappyAbsSyn18  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn26  happy_var_2) `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn19
		 (ExpImpliedDo () (getTransSpan happy_var_1 happy_var_5) happy_var_2 happy_var_4
	) `HappyStk` happyRest

happyReduce_76 = happySpecReduce_1  28 happyReduction_76
happyReduction_76 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_76 _  = notHappyAtAll 

happyReduce_77 = happySpecReduce_1  28 happyReduction_77
happyReduction_77 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_77 _  = notHappyAtAll 

happyReduce_78 = happySpecReduce_3  29 happyReduction_78
happyReduction_78 (HappyAbsSyn30  happy_var_3)
	_
	(HappyAbsSyn29  happy_var_1)
	 =  HappyAbsSyn29
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)
happyReduction_78 _ _ _  = notHappyAtAll 

happyReduce_79 = happySpecReduce_3  29 happyReduction_79
happyReduction_79 (HappyAbsSyn30  happy_var_3)
	_
	(HappyAbsSyn29  happy_var_1)
	 =  HappyAbsSyn29
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)
happyReduction_79 _ _ _  = notHappyAtAll 

happyReduce_80 = happySpecReduce_2  29 happyReduction_80
happyReduction_80 (HappyAbsSyn30  happy_var_2)
	(HappyAbsSyn29  happy_var_1)
	 =  HappyAbsSyn29
		 (setSpan (getTransSpan happy_var_1 happy_var_2) $ happy_var_2 `aCons` happy_var_1
	)
happyReduction_80 _ _  = notHappyAtAll 

happyReduce_81 = happySpecReduce_2  29 happyReduction_81
happyReduction_81 (HappyAbsSyn30  happy_var_2)
	(HappyAbsSyn29  happy_var_1)
	 =  HappyAbsSyn29
		 (setSpan (getTransSpan happy_var_1 happy_var_2) $ happy_var_2 `aCons` happy_var_1
	)
happyReduction_81 _ _  = notHappyAtAll 

happyReduce_82 = happySpecReduce_1  29 happyReduction_82
happyReduction_82 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn29
		 (AList () (getSpan happy_var_1) [ ]
	)
happyReduction_82 _  = notHappyAtAll 

happyReduce_83 = happySpecReduce_1  30 happyReduction_83
happyReduction_83 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn30
		 (FIDelimiter () (getSpan happy_var_1)
	)
happyReduction_83 _  = notHappyAtAll 

happyReduce_84 = happySpecReduce_3  31 happyReduction_84
happyReduction_84 (HappyTerminal happy_var_3)
	(HappyAbsSyn29  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn30
		 (FIFormatList () (getTransSpan happy_var_1 happy_var_3) (let (TInt _ s) = happy_var_1 in Just s) (aReverse happy_var_2)
	)
happyReduction_84 _ _ _  = notHappyAtAll 

happyReduce_85 = happySpecReduce_2  31 happyReduction_85
happyReduction_85 (HappyTerminal happy_var_2)
	(HappyAbsSyn29  happy_var_1)
	 =  HappyAbsSyn30
		 (FIFormatList () (getTransSpan happy_var_1 happy_var_2) Nothing (aReverse happy_var_1)
	)
happyReduction_85 _ _  = notHappyAtAll 

happyReduce_86 = happySpecReduce_1  31 happyReduction_86
happyReduction_86 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn30
		 (let (ExpValue _ s val) = happy_var_1 in FIHollerith () s val
	)
happyReduction_86 _  = notHappyAtAll 

happyReduce_87 = happySpecReduce_1  31 happyReduction_87
happyReduction_87 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn30
		 (let (TFieldDescriptorDEFG s a b c d) = happy_var_1 in FIFieldDescriptorDEFG () s a b c d
	)
happyReduction_87 _  = notHappyAtAll 

happyReduce_88 = happySpecReduce_1  31 happyReduction_88
happyReduction_88 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn30
		 (let (TFieldDescriptorAIL s a b c) = happy_var_1 in FIFieldDescriptorAIL () s a b c
	)
happyReduction_88 _  = notHappyAtAll 

happyReduce_89 = happySpecReduce_1  31 happyReduction_89
happyReduction_89 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn30
		 (let (TBlankDescriptor s w) = happy_var_1 in FIBlankDescriptor () s w
	)
happyReduction_89 _  = notHappyAtAll 

happyReduce_90 = happySpecReduce_1  31 happyReduction_90
happyReduction_90 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn30
		 (let (TScaleFactor s sf) = happy_var_1 in FIScaleFactor () s sf
	)
happyReduction_90 _  = notHappyAtAll 

happyReduce_91 = happyReduce 6 32 happyReduction_91
happyReduction_91 ((HappyTerminal happy_var_6) `HappyStk`
	(HappyAbsSyn26  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn26  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn32  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn32
		 (setSpan (getTransSpan happy_var_1 happy_var_6) $ (DataGroup () (getTransSpan happy_var_3 happy_var_6) (aReverse happy_var_3) (aReverse happy_var_5)) `aCons` happy_var_1
	) `HappyStk` happyRest

happyReduce_92 = happyReduce 4 32 happyReduction_92
happyReduction_92 ((HappyTerminal happy_var_4) `HappyStk`
	(HappyAbsSyn26  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn26  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn32
		 (AList () (getTransSpan happy_var_1 happy_var_4) [ DataGroup () (getTransSpan happy_var_1 happy_var_4) (aReverse happy_var_1) (aReverse happy_var_3) ]
	) `HappyStk` happyRest

happyReduce_93 = happySpecReduce_3  33 happyReduction_93
happyReduction_93 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn26  happy_var_1)
	 =  HappyAbsSyn26
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)
happyReduction_93 _ _ _  = notHappyAtAll 

happyReduce_94 = happySpecReduce_1  33 happyReduction_94
happyReduction_94 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn26
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)
happyReduction_94 _  = notHappyAtAll 

happyReduce_95 = happySpecReduce_3  34 happyReduction_95
happyReduction_95 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Multiplication happy_var_1 happy_var_3
	)
happyReduction_95 _ _ _  = notHappyAtAll 

happyReduce_96 = happySpecReduce_1  34 happyReduction_96
happyReduction_96 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_96 _  = notHappyAtAll 

happyReduce_97 = happySpecReduce_1  35 happyReduction_97
happyReduction_97 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_97 _  = notHappyAtAll 

happyReduce_98 = happySpecReduce_1  35 happyReduction_98
happyReduction_98 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_98 _  = notHappyAtAll 

happyReduce_99 = happySpecReduce_1  35 happyReduction_99
happyReduction_99 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_99 _  = notHappyAtAll 

happyReduce_100 = happySpecReduce_1  35 happyReduction_100
happyReduction_100 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_100 _  = notHappyAtAll 

happyReduce_101 = happyReduce 5 36 happyReduction_101
happyReduction_101 ((HappyTerminal happy_var_5) `HappyStk`
	(HappyAbsSyn26  happy_var_4) `HappyStk`
	(HappyTerminal happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn36  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn36
		 (setSpan (getTransSpan happy_var_1 happy_var_5) $ (setSpan (getTransSpan happy_var_3 happy_var_5) $ aReverse happy_var_4) `aCons` happy_var_1
	) `HappyStk` happyRest

happyReduce_102 = happySpecReduce_3  36 happyReduction_102
happyReduction_102 (HappyTerminal happy_var_3)
	(HappyAbsSyn26  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn36
		 (let s = (getTransSpan happy_var_1 happy_var_3) in AList () s [ setSpan s $ aReverse happy_var_2 ]
	)
happyReduction_102 _ _ _  = notHappyAtAll 

happyReduce_103 = happySpecReduce_2  37 happyReduction_103
happyReduction_103 (HappyAbsSyn38  happy_var_2)
	(HappyAbsSyn37  happy_var_1)
	 =  HappyAbsSyn37
		 (setSpan (getTransSpan happy_var_1 happy_var_2) $ happy_var_2 `aCons` happy_var_1
	)
happyReduction_103 _ _  = notHappyAtAll 

happyReduce_104 = happySpecReduce_1  37 happyReduction_104
happyReduction_104 (HappyAbsSyn38  happy_var_1)
	 =  HappyAbsSyn37
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)
happyReduction_104 _  = notHappyAtAll 

happyReduce_105 = happySpecReduce_2  38 happyReduction_105
happyReduction_105 (HappyAbsSyn26  happy_var_2)
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn38
		 (CommonGroup () (getTransSpan happy_var_1 happy_var_2) (Just happy_var_1) $ aReverse happy_var_2
	)
happyReduction_105 _ _  = notHappyAtAll 

happyReduce_106 = happySpecReduce_3  38 happyReduction_106
happyReduction_106 (HappyAbsSyn26  happy_var_3)
	_
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn38
		 (CommonGroup () (getTransSpan happy_var_1 happy_var_3) Nothing $ aReverse happy_var_3
	)
happyReduction_106 _ _ _  = notHappyAtAll 

happyReduce_107 = happySpecReduce_2  39 happyReduction_107
happyReduction_107 (HappyAbsSyn26  happy_var_2)
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn38
		 (CommonGroup () (getTransSpan happy_var_1 happy_var_2) (Just happy_var_1) $ aReverse happy_var_2
	)
happyReduction_107 _ _  = notHappyAtAll 

happyReduce_108 = happySpecReduce_3  39 happyReduction_108
happyReduction_108 (HappyAbsSyn26  happy_var_3)
	_
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn38
		 (CommonGroup () (getTransSpan happy_var_1 happy_var_3) Nothing $ aReverse happy_var_3
	)
happyReduction_108 _ _ _  = notHappyAtAll 

happyReduce_109 = happySpecReduce_1  39 happyReduction_109
happyReduction_109 (HappyAbsSyn26  happy_var_1)
	 =  HappyAbsSyn38
		 (CommonGroup () (getSpan happy_var_1) Nothing $ aReverse happy_var_1
	)
happyReduction_109 _  = notHappyAtAll 

happyReduce_110 = happySpecReduce_3  40 happyReduction_110
happyReduction_110 (HappyTerminal happy_var_3)
	(HappyAbsSyn19  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn19
		 (setSpan (getTransSpan happy_var_1 happy_var_3) happy_var_2
	)
happyReduction_110 _ _ _  = notHappyAtAll 

happyReduce_111 = happySpecReduce_3  41 happyReduction_111
happyReduction_111 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn26  happy_var_1)
	 =  HappyAbsSyn26
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)
happyReduction_111 _ _ _  = notHappyAtAll 

happyReduce_112 = happySpecReduce_1  41 happyReduction_112
happyReduction_112 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn26
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)
happyReduction_112 _  = notHappyAtAll 

happyReduce_113 = happySpecReduce_1  42 happyReduction_113
happyReduction_113 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_113 _  = notHappyAtAll 

happyReduce_114 = happySpecReduce_1  42 happyReduction_114
happyReduction_114 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_114 _  = notHappyAtAll 

happyReduce_115 = happySpecReduce_3  43 happyReduction_115
happyReduction_115 (HappyAbsSyn44  happy_var_3)
	_
	(HappyAbsSyn43  happy_var_1)
	 =  HappyAbsSyn43
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)
happyReduction_115 _ _ _  = notHappyAtAll 

happyReduce_116 = happySpecReduce_1  43 happyReduction_116
happyReduction_116 (HappyAbsSyn44  happy_var_1)
	 =  HappyAbsSyn43
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)
happyReduction_116 _  = notHappyAtAll 

happyReduce_117 = happySpecReduce_1  44 happyReduction_117
happyReduction_117 (HappyAbsSyn44  happy_var_1)
	 =  HappyAbsSyn44
		 (happy_var_1
	)
happyReduction_117 _  = notHappyAtAll 

happyReduce_118 = happySpecReduce_1  44 happyReduction_118
happyReduction_118 (HappyAbsSyn44  happy_var_1)
	 =  HappyAbsSyn44
		 (happy_var_1
	)
happyReduction_118 _  = notHappyAtAll 

happyReduce_119 = happySpecReduce_3  45 happyReduction_119
happyReduction_119 (HappyAbsSyn44  happy_var_3)
	_
	(HappyAbsSyn43  happy_var_1)
	 =  HappyAbsSyn43
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)
happyReduction_119 _ _ _  = notHappyAtAll 

happyReduce_120 = happySpecReduce_1  45 happyReduction_120
happyReduction_120 (HappyAbsSyn44  happy_var_1)
	 =  HappyAbsSyn43
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)
happyReduction_120 _  = notHappyAtAll 

happyReduce_121 = happyReduce 4 46 happyReduction_121
happyReduction_121 ((HappyTerminal happy_var_4) `HappyStk`
	(HappyAbsSyn47  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn44
		 (DeclArray () (getTransSpan happy_var_1 happy_var_4) happy_var_1 (aReverse happy_var_3) Nothing Nothing
	) `HappyStk` happyRest

happyReduce_122 = happySpecReduce_3  47 happyReduction_122
happyReduction_122 (HappyAbsSyn48  happy_var_3)
	_
	(HappyAbsSyn47  happy_var_1)
	 =  HappyAbsSyn47
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)
happyReduction_122 _ _ _  = notHappyAtAll 

happyReduce_123 = happySpecReduce_1  47 happyReduction_123
happyReduction_123 (HappyAbsSyn48  happy_var_1)
	 =  HappyAbsSyn47
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)
happyReduction_123 _  = notHappyAtAll 

happyReduce_124 = happySpecReduce_1  48 happyReduction_124
happyReduction_124 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn48
		 (DimensionDeclarator () (getSpan happy_var_1) Nothing (Just happy_var_1)
	)
happyReduction_124 _  = notHappyAtAll 

happyReduce_125 = happySpecReduce_1  49 happyReduction_125
happyReduction_125 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn44
		 (DeclVariable () (getSpan happy_var_1) happy_var_1 Nothing Nothing
	)
happyReduction_125 _  = notHappyAtAll 

happyReduce_126 = happySpecReduce_3  50 happyReduction_126
happyReduction_126 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn26  happy_var_1)
	 =  HappyAbsSyn26
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)
happyReduction_126 _ _ _  = notHappyAtAll 

happyReduce_127 = happySpecReduce_1  50 happyReduction_127
happyReduction_127 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn26
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)
happyReduction_127 _  = notHappyAtAll 

happyReduce_128 = happySpecReduce_2  51 happyReduction_128
happyReduction_128 (HappyTerminal happy_var_2)
	(HappyAbsSyn51  happy_var_1)
	 =  HappyAbsSyn51
		 (setSpan (getTransSpan happy_var_1 happy_var_2) $ aReverse happy_var_1
	)
happyReduction_128 _ _  = notHappyAtAll 

happyReduce_129 = happySpecReduce_3  52 happyReduction_129
happyReduction_129 (HappyAbsSyn53  happy_var_3)
	_
	(HappyAbsSyn51  happy_var_1)
	 =  HappyAbsSyn51
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)
happyReduction_129 _ _ _  = notHappyAtAll 

happyReduce_130 = happySpecReduce_2  52 happyReduction_130
happyReduction_130 (HappyAbsSyn53  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn51
		 (AList () (getTransSpan happy_var_1 happy_var_2) [ happy_var_2 ]
	)
happyReduction_130 _ _  = notHappyAtAll 

happyReduce_131 = happySpecReduce_1  52 happyReduction_131
happyReduction_131 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn51
		 (AList () (getSpan happy_var_1) [ ]
	)
happyReduction_131 _  = notHappyAtAll 

happyReduce_132 = happySpecReduce_1  53 happyReduction_132
happyReduction_132 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn53
		 (Argument () (getSpan happy_var_1) Nothing happy_var_1
	)
happyReduction_132 _  = notHappyAtAll 

happyReduce_133 = happySpecReduce_1  53 happyReduction_133
happyReduction_133 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn53
		 (Argument () (getSpan happy_var_1) Nothing happy_var_1
	)
happyReduction_133 _  = notHappyAtAll 

happyReduce_134 = happySpecReduce_3  54 happyReduction_134
happyReduction_134 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Addition happy_var_1 happy_var_3
	)
happyReduction_134 _ _ _  = notHappyAtAll 

happyReduce_135 = happySpecReduce_3  54 happyReduction_135
happyReduction_135 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Subtraction happy_var_1 happy_var_3
	)
happyReduction_135 _ _ _  = notHappyAtAll 

happyReduce_136 = happySpecReduce_3  54 happyReduction_136
happyReduction_136 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Multiplication happy_var_1 happy_var_3
	)
happyReduction_136 _ _ _  = notHappyAtAll 

happyReduce_137 = happySpecReduce_3  54 happyReduction_137
happyReduction_137 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Division happy_var_1 happy_var_3
	)
happyReduction_137 _ _ _  = notHappyAtAll 

happyReduce_138 = happySpecReduce_3  54 happyReduction_138
happyReduction_138 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Exponentiation happy_var_1 happy_var_3
	)
happyReduction_138 _ _ _  = notHappyAtAll 

happyReduce_139 = happySpecReduce_2  54 happyReduction_139
happyReduction_139 (HappyAbsSyn19  happy_var_2)
	(HappyAbsSyn58  happy_var_1)
	 =  HappyAbsSyn19
		 (ExpUnary () (getTransSpan (fst happy_var_1) happy_var_2) (snd happy_var_1) happy_var_2
	)
happyReduction_139 _ _  = notHappyAtAll 

happyReduce_140 = happySpecReduce_3  54 happyReduction_140
happyReduction_140 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Or happy_var_1 happy_var_3
	)
happyReduction_140 _ _ _  = notHappyAtAll 

happyReduce_141 = happySpecReduce_3  54 happyReduction_141
happyReduction_141 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) And happy_var_1 happy_var_3
	)
happyReduction_141 _ _ _  = notHappyAtAll 

happyReduce_142 = happySpecReduce_2  54 happyReduction_142
happyReduction_142 (HappyAbsSyn19  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn19
		 (ExpUnary () (getTransSpan happy_var_1 happy_var_2) Not happy_var_2
	)
happyReduction_142 _ _  = notHappyAtAll 

happyReduce_143 = happySpecReduce_3  54 happyReduction_143
happyReduction_143 (HappyAbsSyn19  happy_var_3)
	(HappyAbsSyn55  happy_var_2)
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) happy_var_2 happy_var_1 happy_var_3
	)
happyReduction_143 _ _ _  = notHappyAtAll 

happyReduce_144 = happySpecReduce_3  54 happyReduction_144
happyReduction_144 (HappyTerminal happy_var_3)
	(HappyAbsSyn19  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn19
		 (setSpan (getTransSpan happy_var_1 happy_var_3) happy_var_2
	)
happyReduction_144 _ _ _  = notHappyAtAll 

happyReduce_145 = happySpecReduce_1  54 happyReduction_145
happyReduction_145 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_145 _  = notHappyAtAll 

happyReduce_146 = happySpecReduce_1  54 happyReduction_146
happyReduction_146 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_146 _  = notHappyAtAll 

happyReduce_147 = happySpecReduce_1  54 happyReduction_147
happyReduction_147 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_147 _  = notHappyAtAll 

happyReduce_148 = happySpecReduce_1  54 happyReduction_148
happyReduction_148 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_148 _  = notHappyAtAll 

happyReduce_149 = happySpecReduce_1  54 happyReduction_149
happyReduction_149 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_149 _  = notHappyAtAll 

happyReduce_150 = happySpecReduce_1  54 happyReduction_150
happyReduction_150 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_150 _  = notHappyAtAll 

happyReduce_151 = happySpecReduce_1  55 happyReduction_151
happyReduction_151 _
	 =  HappyAbsSyn55
		 (EQ
	)

happyReduce_152 = happySpecReduce_1  55 happyReduction_152
happyReduction_152 _
	 =  HappyAbsSyn55
		 (NE
	)

happyReduce_153 = happySpecReduce_1  55 happyReduction_153
happyReduction_153 _
	 =  HappyAbsSyn55
		 (GT
	)

happyReduce_154 = happySpecReduce_1  55 happyReduction_154
happyReduction_154 _
	 =  HappyAbsSyn55
		 (GTE
	)

happyReduce_155 = happySpecReduce_1  55 happyReduction_155
happyReduction_155 _
	 =  HappyAbsSyn55
		 (LT
	)

happyReduce_156 = happySpecReduce_1  55 happyReduction_156
happyReduction_156 _
	 =  HappyAbsSyn55
		 (LTE
	)

happyReduce_157 = happySpecReduce_3  56 happyReduction_157
happyReduction_157 (HappyTerminal happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (ExpFunctionCall () (getTransSpan happy_var_1 happy_var_3) happy_var_1 Nothing
	)
happyReduction_157 _ _ _  = notHappyAtAll 

happyReduce_158 = happyReduce 4 56 happyReduction_158
happyReduction_158 ((HappyTerminal happy_var_4) `HappyStk`
	(HappyAbsSyn57  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn19
		 (ExpSubscript () (getTransSpan happy_var_1 happy_var_4) happy_var_1 (fromReverseList happy_var_3)
	) `HappyStk` happyRest

happyReduce_159 = happySpecReduce_3  57 happyReduction_159
happyReduction_159 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn57  happy_var_1)
	 =  HappyAbsSyn57
		 (IxSingle () (getSpan happy_var_3) Nothing happy_var_3 : happy_var_1
	)
happyReduction_159 _ _ _  = notHappyAtAll 

happyReduce_160 = happySpecReduce_1  57 happyReduction_160
happyReduction_160 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn57
		 ([ IxSingle () (getSpan happy_var_1) Nothing happy_var_1 ]
	)
happyReduction_160 _  = notHappyAtAll 

happyReduce_161 = happySpecReduce_1  58 happyReduction_161
happyReduction_161 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn58
		 ((getSpan happy_var_1, Minus)
	)
happyReduction_161 _  = notHappyAtAll 

happyReduce_162 = happySpecReduce_1  58 happyReduction_162
happyReduction_162 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn58
		 ((getSpan happy_var_1, Plus)
	)
happyReduction_162 _  = notHappyAtAll 

happyReduce_163 = happySpecReduce_1  59 happyReduction_163
happyReduction_163 (HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn10
		 (Just $ fromReverseList happy_var_1
	)
happyReduction_163 _  = notHappyAtAll 

happyReduce_164 = happySpecReduce_0  59 happyReduction_164
happyReduction_164  =  HappyAbsSyn10
		 (Nothing
	)

happyReduce_165 = happySpecReduce_3  60 happyReduction_165
happyReduction_165 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn60
		 (happy_var_3 : happy_var_1
	)
happyReduction_165 _ _ _  = notHappyAtAll 

happyReduce_166 = happySpecReduce_1  60 happyReduction_166
happyReduction_166 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn60
		 ([ happy_var_1 ]
	)
happyReduction_166 _  = notHappyAtAll 

happyReduce_167 = happySpecReduce_1  61 happyReduction_167
happyReduction_167 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn19
		 (ExpValue () (getSpan happy_var_1) $ let (TId _ s) = happy_var_1 in ValVariable () s
	)
happyReduction_167 _  = notHappyAtAll 

happyReduce_168 = happySpecReduce_2  62 happyReduction_168
happyReduction_168 (HappyAbsSyn19  happy_var_2)
	(HappyAbsSyn58  happy_var_1)
	 =  HappyAbsSyn19
		 (ExpUnary () (getTransSpan (fst happy_var_1) happy_var_2) (snd happy_var_1) happy_var_2
	)
happyReduction_168 _ _  = notHappyAtAll 

happyReduce_169 = happySpecReduce_1  62 happyReduction_169
happyReduction_169 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_169 _  = notHappyAtAll 

happyReduce_170 = happySpecReduce_1  63 happyReduction_170
happyReduction_170 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn19
		 (ExpValue () (getSpan happy_var_1) $ let (TInt _ i) = happy_var_1 in ValInteger i
	)
happyReduction_170 _  = notHappyAtAll 

happyReduce_171 = happySpecReduce_2  64 happyReduction_171
happyReduction_171 (HappyAbsSyn19  happy_var_2)
	(HappyAbsSyn58  happy_var_1)
	 =  HappyAbsSyn19
		 (ExpUnary () (getTransSpan (fst happy_var_1) happy_var_2) (snd happy_var_1) happy_var_2
	)
happyReduction_171 _ _  = notHappyAtAll 

happyReduce_172 = happySpecReduce_1  64 happyReduction_172
happyReduction_172 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_172 _  = notHappyAtAll 

happyReduce_173 = happySpecReduce_2  65 happyReduction_173
happyReduction_173 (HappyAbsSyn67  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn19
		 (makeReal (Just happy_var_1) Nothing Nothing (Just happy_var_2)
	)
happyReduction_173 _ _  = notHappyAtAll 

happyReduce_174 = happySpecReduce_3  65 happyReduction_174
happyReduction_174 (HappyAbsSyn66  happy_var_3)
	(HappyTerminal happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn19
		 (makeReal (Just happy_var_1) (Just happy_var_2) Nothing happy_var_3
	)
happyReduction_174 _ _ _  = notHappyAtAll 

happyReduce_175 = happySpecReduce_3  65 happyReduction_175
happyReduction_175 (HappyAbsSyn66  happy_var_3)
	(HappyTerminal happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn19
		 (makeReal Nothing (Just happy_var_1) (Just happy_var_2) happy_var_3
	)
happyReduction_175 _ _ _  = notHappyAtAll 

happyReduce_176 = happyReduce 4 65 happyReduction_176
happyReduction_176 ((HappyAbsSyn66  happy_var_4) `HappyStk`
	(HappyTerminal happy_var_3) `HappyStk`
	(HappyTerminal happy_var_2) `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn19
		 (makeReal (Just happy_var_1) (Just happy_var_2) (Just happy_var_3) happy_var_4
	) `HappyStk` happyRest

happyReduce_177 = happySpecReduce_1  66 happyReduction_177
happyReduction_177 (HappyAbsSyn67  happy_var_1)
	 =  HappyAbsSyn66
		 (Just happy_var_1
	)
happyReduction_177 _  = notHappyAtAll 

happyReduce_178 = happySpecReduce_0  66 happyReduction_178
happyReduction_178  =  HappyAbsSyn66
		 (Nothing
	)

happyReduce_179 = happySpecReduce_1  67 happyReduction_179
happyReduction_179 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn67
		 (let (TExponent s exp) = happy_var_1 in (s, exp)
	)
happyReduction_179 _  = notHappyAtAll 

happyReduce_180 = happySpecReduce_1  68 happyReduction_180
happyReduction_180 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_180 _  = notHappyAtAll 

happyReduce_181 = happySpecReduce_1  68 happyReduction_181
happyReduction_181 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1
	)
happyReduction_181 _  = notHappyAtAll 

happyReduce_182 = happyReduce 5 69 happyReduction_182
happyReduction_182 ((HappyTerminal happy_var_5) `HappyStk`
	(HappyAbsSyn19  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_2) `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn19
		 (ExpValue () (getTransSpan happy_var_1 happy_var_5) (ValComplex happy_var_2 happy_var_4)
	) `HappyStk` happyRest

happyReduce_183 = happySpecReduce_1  70 happyReduction_183
happyReduction_183 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn19
		 (let TBool s b = happy_var_1 in ExpValue () s $ ValLogical b
	)
happyReduction_183 _  = notHappyAtAll 

happyReduce_184 = happySpecReduce_1  71 happyReduction_184
happyReduction_184 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn19
		 (ExpValue () (getSpan happy_var_1) $ let (THollerith _ h) = happy_var_1 in ValHollerith h
	)
happyReduction_184 _  = notHappyAtAll 

happyReduce_185 = happySpecReduce_2  72 happyReduction_185
happyReduction_185 (HappyTerminal happy_var_2)
	(HappyAbsSyn26  happy_var_1)
	 =  HappyAbsSyn26
		 (setSpan (getTransSpan happy_var_1 happy_var_2) $ aReverse happy_var_1
	)
happyReduction_185 _ _  = notHappyAtAll 

happyReduce_186 = happySpecReduce_3  73 happyReduction_186
happyReduction_186 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn26  happy_var_1)
	 =  HappyAbsSyn26
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)
happyReduction_186 _ _ _  = notHappyAtAll 

happyReduce_187 = happySpecReduce_2  73 happyReduction_187
happyReduction_187 (HappyAbsSyn19  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn26
		 (AList () (getTransSpan happy_var_1 happy_var_2) [ happy_var_2 ]
	)
happyReduction_187 _ _  = notHappyAtAll 

happyReduce_188 = happySpecReduce_1  74 happyReduction_188
happyReduction_188 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn19
		 (ExpValue () (getSpan happy_var_1) (let (TLabel _ l) = happy_var_1 in ValLabel l)
	)
happyReduction_188 _  = notHappyAtAll 

happyReduce_189 = happySpecReduce_1  75 happyReduction_189
happyReduction_189 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn19
		 (ExpValue () (getSpan happy_var_1) (let (TInt _ l) = happy_var_1 in ValLabel l)
	)
happyReduction_189 _  = notHappyAtAll 

happyReduce_190 = happySpecReduce_1  76 happyReduction_190
happyReduction_190 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn76
		 (TypeSpec () (getSpan happy_var_1) TypeInteger Nothing
	)
happyReduction_190 _  = notHappyAtAll 

happyReduce_191 = happySpecReduce_1  76 happyReduction_191
happyReduction_191 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn76
		 (TypeSpec () (getSpan happy_var_1) TypeReal Nothing
	)
happyReduction_191 _  = notHappyAtAll 

happyReduce_192 = happySpecReduce_1  76 happyReduction_192
happyReduction_192 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn76
		 (TypeSpec () (getSpan happy_var_1) TypeDoublePrecision Nothing
	)
happyReduction_192 _  = notHappyAtAll 

happyReduce_193 = happySpecReduce_1  76 happyReduction_193
happyReduction_193 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn76
		 (TypeSpec () (getSpan happy_var_1) TypeLogical Nothing
	)
happyReduction_193 _  = notHappyAtAll 

happyReduce_194 = happySpecReduce_1  76 happyReduction_194
happyReduction_194 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn76
		 (TypeSpec () (getSpan happy_var_1) TypeComplex Nothing
	)
happyReduction_194 _  = notHappyAtAll 

happyNewToken action sts stk
	= lexer(\tk -> 
	let cont i = action i i tk (HappyState action) sts stk in
	case tk of {
	TEOF _ -> action 138 138 tk (HappyState action) sts stk;
	TLeftPar _ -> cont 77;
	TRightPar _ -> cont 78;
	TComma _ -> cont 79;
	TDot _ -> cont 80;
	TFunction _ -> cont 81;
	TSubroutine _ -> cont 82;
	TBlockData _ -> cont 83;
	TEnd _ -> cont 84;
	TOpAssign _ -> cont 85;
	TAssign _ -> cont 86;
	TTo _ -> cont 87;
	TGoto _ -> cont 88;
	TIf _ -> cont 89;
	TCall _ -> cont 90;
	TReturn _ -> cont 91;
	TContinue _ -> cont 92;
	TStop _ -> cont 93;
	TPause _ -> cont 94;
	TDo _ -> cont 95;
	TRead _ -> cont 96;
	TWrite _ -> cont 97;
	TRewind _ -> cont 98;
	TBackspace _ -> cont 99;
	TEndfile _ -> cont 100;
	TCommon _ -> cont 101;
	TEquivalence _ -> cont 102;
	TExternal _ -> cont 103;
	TDimension _ -> cont 104;
	TType _ "integer" -> cont 105;
	TType _ "real" -> cont 106;
	TType _ "doubleprecision" -> cont 107;
	TType _ "logical" -> cont 108;
	TType _ "complex" -> cont 109;
	TData _ -> cont 110;
	TFormat _ -> cont 111;
	TFieldDescriptorDEFG _ _ _ _ _ -> cont 112;
	TFieldDescriptorAIL _ _ _ _ -> cont 113;
	TBlankDescriptor _ _ -> cont 114;
	TScaleFactor _ _ -> cont 115;
	TInt _ _ -> cont 116;
	TExponent _ _ -> cont 117;
	TBool _ _ -> cont 118;
	TOpPlus _ -> cont 119;
	TOpMinus _ -> cont 120;
	TOpExp _ -> cont 121;
	TStar _ -> cont 122;
	TSlash _ -> cont 123;
	TOpOr _ -> cont 124;
	TOpAnd _ -> cont 125;
	TOpNot _ -> cont 126;
	TOpLT _ -> cont 127;
	TOpLE _ -> cont 128;
	TOpGT _ -> cont 129;
	TOpGE _ -> cont 130;
	TOpEQ _ -> cont 131;
	TOpNE _ -> cont 132;
	TId _ _ -> cont 133;
	TComment _ _ -> cont 134;
	THollerith _ _ -> cont 135;
	TLabel _ _ -> cont 136;
	TNewline _ -> cont 137;
	_ -> happyError' tk
	})

happyError_ 138 tk = happyError' tk
happyError_ _ tk = happyError' tk

happyThen :: () => LexAction a -> (a -> LexAction b) -> LexAction b
happyThen = (>>=)
happyReturn :: () => a -> LexAction a
happyReturn = (return)
happyThen1 = happyThen
happyReturn1 :: () => a -> LexAction a
happyReturn1 = happyReturn
happyError' :: () => (Token) -> LexAction a
happyError' tk = parseError tk

programParser = happySomeParser where
  happySomeParser = happyThen (happyParse action_0) (\x -> case x of {HappyAbsSyn6 z -> happyReturn z; _other -> notHappyAtAll })

statementParser = happySomeParser where
  happySomeParser = happyThen (happyParse action_1) (\x -> case x of {HappyAbsSyn15 z -> happyReturn z; _other -> notHappyAtAll })

expressionParser = happySomeParser where
  happySomeParser = happyThen (happyParse action_2) (\x -> case x of {HappyAbsSyn19 z -> happyReturn z; _other -> notHappyAtAll })

happySeq = happyDontSeq


makeReal :: Maybe Token -> Maybe Token -> Maybe Token -> Maybe (SrcSpan, String) -> Expression A0
makeReal i1 dot i2 exp =
  let span1   = getSpan (i1, dot, i2)
      span2   = case exp of
                  Just e -> getTransSpan span1 (fst e)
                  Nothing -> span1
      i1Str   = case i1 of { Just (TInt _ s) -> s ; _ -> "" }
      dotStr  = case dot of { Just (TDot _) -> "." ; _ -> "" }
      i2Str   = case i2 of { Just (TInt _ s) -> s ; _ -> "" }
      expStr  = case exp of { Just (_, s) -> s ; _ -> "" } in
    ExpValue () span2 (ValReal $ i1Str ++ dotStr ++ i2Str ++ expStr)

transformations66 =
  [ GroupLabeledDo
  , DisambiguateFunction
  ]

fortran66Parser :: String -> String -> ProgramFile A0
fortran66Parser sourceCode filename =
    transform transformations66 $ parse parseState
  where
    parse = evalParse programParser
    parseState = initParseState sourceCode Fortran66 filename

parseError :: Token -> LexAction a
parseError _ = fail "Parsing failed."
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 16 "<built-in>" #-}
{-# LINE 1 "/usr/local/lib/ghc-7.10.2/include/ghcversion.h" #-}


















{-# LINE 17 "<built-in>" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 


{-# LINE 13 "templates/GenericTemplate.hs" #-}


{-# LINE 46 "templates/GenericTemplate.hs" #-}









{-# LINE 67 "templates/GenericTemplate.hs" #-}


{-# LINE 77 "templates/GenericTemplate.hs" #-}










infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is (1), it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept (1) tk st sts (_ `HappyStk` ans `HappyStk` _) =
        happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
         (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action


{-# LINE 155 "templates/GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- HappyState data type (not arrays)



newtype HappyState b c = HappyState
        (Int ->                    -- token number
         Int ->                    -- token number (yes, again)
         b ->                           -- token semantic value
         HappyState b c ->              -- current state
         [HappyState b c] ->            -- state stack
         c)



-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state (1) tk st sts stk@(x `HappyStk` _) =
     let i = (case x of { HappyErrorToken (i) -> i }) in
--     trace "shifting the error token" $
     new_state i i tk (HappyState (new_state)) ((st):(sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state ((st):(sts)) ((HappyTerminal (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_0 nt fn j tk st@((HappyState (action))) sts stk
     = action nt j tk st ((st):(sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@(((st@(HappyState (action))):(_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_2 nt fn j tk _ ((_):(sts@(((st@(HappyState (action))):(_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_3 nt fn j tk _ ((_):(((_):(sts@(((st@(HappyState (action))):(_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k - ((1) :: Int)) sts of
         sts1@(((st1@(HappyState (action))):(_))) ->
                let r = fn stk in  -- it doesn't hurt to always seq here...
                happyDoSeq r (action nt j tk st1 sts1 r)

happyMonadReduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
      case happyDrop k ((st):(sts)) of
        sts1@(((st1@(HappyState (action))):(_))) ->
          let drop_stk = happyDropStk k stk in
          happyThen1 (fn stk tk) (\r -> action nt j tk st1 sts1 (r `HappyStk` drop_stk))

happyMonad2Reduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
      case happyDrop k ((st):(sts)) of
        sts1@(((st1@(HappyState (action))):(_))) ->
         let drop_stk = happyDropStk k stk





             new_state = action

          in
          happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))

happyDrop (0) l = l
happyDrop n ((_):(t)) = happyDrop (n - ((1) :: Int)) t

happyDropStk (0) l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n - ((1)::Int)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction









happyGoto action j tk st = action j j tk (HappyState action)


-----------------------------------------------------------------------------
-- Error recovery ((1) is the error token)

-- parse error if we are in recovery and we fail again
happyFail (1) tk old_st _ stk@(x `HappyStk` _) =
     let i = (case x of { HappyErrorToken (i) -> i }) in
--      trace "failing" $ 
        happyError_ i tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  (1) tk old_st (((HappyState (action))):(sts)) 
                                                (saved_tok `HappyStk` _ `HappyStk` stk) =
--      trace ("discarding state, depth " ++ show (length stk))  $
        action (1) (1) tk (HappyState (action)) sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (HappyState (action)) sts stk =
--      trace "entering error recovery" $
        action (1) (1) tk (HappyState (action)) sts ( (HappyErrorToken (i)) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll :: a
notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions







-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--      happySeq = happyDoSeq
-- otherwise it emits
--      happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.









{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.

